#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "apu2kernel4xi.py">
#<abstract4xi abstract = "APU kernel management"/>
#<refer4xi reference = "kernel4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
#<verify4xi verification = "10" target = "apu2kernel4xi5test.py">
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API  
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'APU2Kernel4Xi',                       # NACK 5.7.1  p157                              clCreateKernel 

            'add2kernel4apu',                      # ACK               

            'execute2kernel4apu',                  # NACK 5.8    p169 - arguments needed           clEnqueueNDRangeKernel                                                       
            'execute2task4apu',                    # NACK 5.8    p172                              clEnqueueTask
            'execute2nativekernel4apu',            # NACK 5.8    p174                              clEnqueueNativeKernel  
            
            'create2kernel4apu',                   # ACK 5.7.1   p157                              clCreateKernel 
            'create2kernelsinprogram4apu',         # NACK 5.7.1  p158                              clCreateKernelsInProgram
                       
            'delete2kernel4apu',                   # ACK

            'fetch2kernel4apu',                    # ACK 
            
            'get2kernelinfo4apu',                  # ACK 5.7.3   p162                              clGetKernelInfo
            'get2kernelworkgroupinfo4apu',         # NACK 5.7.3  p164 - execution needed           clGetKernelWorkGroupInfo
            'get2kernelarginfo4apu',               # ACK 5.7.3   p166 - set needed                 clGetKernelArgInfo                               
            
            'release2kernel4apu',                  # ACK 5.7.1   p159                              clReleaseKernel                                      
            'retain2kernel4apu',                   # ACK 5.7.1   p159                              clRetainKernel  
 
            'set2kernel4apu',                      # ACK 
            'set2kernelcallback4apu',              # ACK 
            'set2kernelarg4apu',                   # ACK 5.7.2   p160 - required for execution     clSetKernelArg 
                                          
            'trace2kernel4apu'                     # ACK 

          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi

# -------------------------------------------------------------------------------------------------
# Buffer                           
# -------------------------------------------------------------------------------------------------
from apu2buffer4xi import get2bufferinfo4apu

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from apu2commandqueue4xi import APU2CommandQueue4Xi
from apu2commandqueue4xi import create2commandqueue4apu 
from apu2commandqueue4xi import flush2commandqueue4apu
from apu2commandqueue4xi import finish2commandqueue4apu
from apu2commandqueue4xi import get2commandqueueinfo4apu
from apu2commandqueue4xi import release2commandqueue4apu
from apu2commandqueue4xi import retain2commandqueue4apu
from apu2commandqueue4xi import set2commandqueue4apu
from apu2commandqueue4xi import trace2commandqueue4apu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from apu2context4xi import APU2Context4Xi 
from apu2context4xi import create2context4apu
from apu2context4xi import get2context4apu
from apu2context4xi import release2context4apu
from apu2context4xi import retain2context4apu
from apu2context4xi import set2context4apu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from apu2device4xi import APU4Xi
from apu2device4xi import init2apu4xi 
from apu2device4xi import set2apu4xi
from apu2device4xi import get2apu4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from apu2event4xi import APU2Event4Xi
from apu2event4xi import create2event4apu
from apu2event4xi import get2eventinfo4apu
from apu2event4xi import release2event4apu
from apu2event4xi import retain2event4apu
from apu2event4xi import set2eventcallback4apu 
from apu2event4xi import set2event4apu
from apu2event4xi import trace2event4apu
from apu2event4xi import wait2event4apu


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Program module                           
# -------------------------------------------------------------------------------------------------
from apu2program4xi import APU2Program4Xi
from apu2program4xi import add2programwithsource4apu
from apu2program4xi import add2programwithbinary4apu
from apu2program4xi import build2program4apu
from apu2program4xi import compile2program4apu
from apu2program4xi import create2programwithsource4apu
from apu2program4xi import create2programwithbinary4apu
from apu2program4xi import delete2programwithsource4apu
from apu2program4xi import delete2programwithbinary4apu
from apu2program4xi import get2programinfo4apu
# from apu2program4xi import get2programbuildinfo4apu
from apu2program4xi import link2program4apu
from apu2program4xi import release2program4apu
from apu2program4xi import retain2program4apu
from apu2program4xi import set2programcallback4apu 
from apu2program4xi import set2programwithsource4apu
from apu2program4xi import set2programwithbinary4apu
from apu2program4xi import trace2program4apu
# from apu2program4xi import unload2compiler4apu



# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from process4xi import Process4Xi
from popen4xi import Popen4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                         
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global apu2kernel4xi                                                    # Kernel of APU
global apu2build4xi                                                     # Build of APU
global apu2compile4xi                                                   # Compile of APU
global apu2trace4xi                                                     # TRACE

global fetch2code4apu                                                   # Fetched code

global import2use4apu                                                   # Imports of target function for Process4Xi

global kb2fetch4apu                                                     # Knowledgebase for fetching
global kb2kernel4apu                                                    # Knowledgebase for kernel   

global folder2lib4apu                                                   # Folder of APU library

global profile2fetch                                                    # Profile knowledgebase for fetching
global keys2profile4apu

global target2function4apu                                                                                          # Target function for Process4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
temp2apu = 'apu'
key2dir = temp2apu[0]                                                                                               # MORE COMPLICATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4apu = VersionKB4Xi[key2dir] 

profile2fetch = {}                                                                                                  # PROFILES FOR FETCHING
profile2fetch ['.py']  = 'ACK'                                                                                    
profile2fetch ['.pyc'] = 'ACK'                                                                                    
profile2fetch ['.cpp'] = 'ACK'                                                                                   
profile2fetch ['.exe'] = 'ACK'       
keys2profile4apu = profile2fetch.keys()

kb2fetch4apu = {}                                                                                                   # PROGRAMS TO BE FETCHED - ALWAYS DEFINE BOTH SOURCE AND BINARY PAIRS                               
kb2fetch4apu[1] = folder2lib4apu + 'apu2sampler4xi5test.py'                                                         # Python code
kb2fetch4apu[2] = folder2lib4apu + '__pycache__//apu2sampler4xi.cpython-33.pyc'   
kb2fetch4apu[3] = folder2lib4apu + 'apu2dummy4xi5test.cpp'                                                          # C++ code
kb2fetch4apu[4] = folder2lib4apu + "bin//apu2dummy4xi5test.exe"                                                     # C++ binary

# kb2fetch4apu[1]  = folder2lib4apu + 'apu2sampler4xi5test.py'                                                      
# kb2fetch4apu[2]  = folder2lib4apu + '__pycache__//apu2sampler4xi.cpython-33.pyc'                                  
# kb2fetch4apu[3]  = folder2lib4apu + 'apu2image4xi5test.py'
# kb2fetch4apu[4]  = folder2lib4apu + '__pycache__//apu2image4xi.cpython-33.pyc'
# kb2fetch4apu[5]  = folder2lib4apu + 'apu3image4xi5test.py'
# kb2fetch4apu[6]  = folder2lib4apu + '__pycache__//apu3image4xi.cpython-33.pyc'
# kb2fetch4apu[7]  = folder2lib4apu + 'apu2commandqueue4xi5test.py'
# kb2fetch4apu[8]  = folder2lib4apu + '__pycache__//apu2commandqueue4xi.cpython-33.pyc'
# kb2fetch4apu[9]  = folder2lib4apu + 'apu2event4xi5test.py'
# kb2fetch4apu[10] = folder2lib4apu + '__pycache__//apu2event4xi.cpython-33.pyc'
# kb2fetch4apu[10]  = folder2lib4apu + 'APU2kernel4xi5test.py'
# kb2fetch4apu[11] = folder2lib4apu + '__pycache__//apu2program.cpython-33.pyc'

fetch2code4apu = {}                                                                                                 # reception arena in memory for code

kb2kernel4apu = {}
kb2kernel4apu ['.py'] = {}
kb2kernel4apu ['.py'] ['TAG']            = "<function4xi function ="                                                
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4apu ['.py'] ['VALUE']          = "apu2sampler4xi5test" 
kb2kernel4apu ['.py'] ['ATTRIBUTE']      = 'usage = "' 

kb2kernel4apu ['.cpp'] = {}
kb2kernel4apu ['.cpp'] ['TAG']            = "<function4xi function ="                                               
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4apu ['.cpp'] ['VALUE']          = "apu2dummy4xi5test" 
kb2kernel4apu ['.cpp'] ['ATTRIBUTE']      = 'usage = "kernel'                                                       

#"/>

# -------------------------------------------------------------------------------------------------
# Command queue module of APU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2commandqueue4apu" usage = " importing target function for Process4Xi">
def importcreate2commandqueue4apu():
   global target2function4apu
   from apu2commandqueue4xi import create2commandqueue4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importflush2commandqueue4apu" usage = " importing target function for Process4Xi">
def importflush2commandqueue4apu():
   global target2function4apu
   from apu2commandqueue4xi import flush2commandqueue4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importfinish2commandqueue4apu" usage = " importing target function for Process4Xi">
def importfinish2commandqueue4apu():
   global target2function4apu
   from apu2commandqueue4xi import finish2commandqueue4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importget2commandqueueinfo4apu" usage = " importing target function for Process4Xi">
def importget2commandqueueinfo4apu():
   global target2function4apu
   from apu2commandqueue4xi import get2commandqueueinfo4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importrelease2commandqueue4apu" usage = " importing target function for Process4Xi">
def importrelease2commandqueue4apu():
   global target2function4apu
   from apu2commandqueue4xi import release2commandqueue4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importretain2commandqueue4apu" usage = " importing target function for Process4Xi">
def importretain2commandqueue4apu():
   global target2function4apu
   from apu2commandqueue4xi import retain2commandqueue4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importset2commandqueue4apu" usage = " importing target function for Process4Xi">
def importset2commandqueue4apu():
   global target2function4apu
   from apu2commandqueue4xi import set2commandqueue4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importtrace2commandqueue4apu" usage = " importing target function for Process4Xi">
def importtrace2commandqueue4apu():
   global target2function4apu
   from apu2commandqueue4xi import trace2commandqueue4apu as target2function4apu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Context module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2context4apu" usage = " importing target function for Process4Xi">
def importcreate2context4apu():
   global target2function4apu
   from apu2context4xi import create2context4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importget2context4apu" usage = " importing target function for Process4Xi">
def importget2context4apu():
   global target2function4apu
   from apu2context4xi import get2context4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importrelease2context4apu" usage = " importing target function for Process4Xi">
def importrelease2context4apu():
   global target2function4apu
   from apu2context4xi import release2context4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importretain2context4apu" usage = " importing target function for Process4Xi">
def importretain2context4apu():
   global target2function4apu
   from apu2context4xi import retain2context4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importset2context4apu" usage = " importing target function for Process4Xi">
def importset2context4apu():
   global target2function4apu
   from apu2context4xi import set2context4apu as target2function4apu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Device module of APU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importinit2apu4xi" usage = " importing target function for Process4Xi">
def importinit2apu4xi():
   global target2function4apu
   from apu2device4xi import init2apu4xi as target2function4apu 
#</function4xi>
 
#<function4xi function = "importset2apu4xi" usage = " importing target function for Process4Xi">
def importset2apu4xi():
   global target2function4apu
   from apu2device4xi import set2apu4xi   as target2function4apu
#</function4xi>
 
#<function4xi function = "importget2apu4xi" usage = " importing target function for Process4Xi">
def importget2apu4xi():
   global target2function4apu
   from apu2device4xi import get2apu4xi   as target2function4apu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Event module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2event4apu" usage = " importing target function for Process4Xi">
def importcreate2event4apu():
   global target2function4apu
   from apu2event4xi import create2event4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importget2eventinfo4apu" usage = " importing target function for Process4Xi">
def importget2eventinfo4apu():
   global target2function4apu
   from apu2event4xi import get2eventinfo4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importrelease2event4apu" usage = " importing target function for Process4Xi">
def importrelease2event4apu():
   global target2function4apu
   from apu2event4xi import release2event4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importretain2event4apu" usage = " importing target function for Process4Xi">
def importretain2event4apu():
   global target2function4apu
   from apu2event4xi import retain2event4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importset2eventcallback4apu" usage = " importing target function for Process4Xi">
def importset2eventcallback4apu():
   global target2function4apu
   from apu2event4xi import set2eventcallback4apu as target2function4apu 
#</function4xi>
 
#<function4xi function = "importset2event4apu" usage = " importing target function for Process4Xi">
def importset2event4apu():
   global target2function4apu
   from apu2event4xi import set2event4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importtrace2event4apu" usage = " importing target function for Process4Xi">
def importtrace2event4apu():
   global target2function4apu
   from apu2event4xi import trace2event4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importwait2event4apu" usage = " importing target function for Process4Xi">
def importwait2event4apu():
   global target2function4apu
   from apu2event4xi import wait2event4apu as target2function4apu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# 2D Image module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2image4apu" usage = " importing target function for Process4Xi">
def importcreate2image4apu():
   global target2function4apu
   from apu2image4xi import create2image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importget2imageinfo4apu" usage = " importing target function for Process4Xi">
def importget2imageinfo4apu():
   global target2function4apu
   from apu2image4xi import get2imageinfo4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importget2supportedimageformats4apu" usage = " importing target function for Process4Xi">
def importget2supportedimageformats4apu():
   global target2function4apu
   from apu2image4xi import get2supportedimageformats4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimage4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimage4apu():
   global target2function4apu
   from apu2image4xi import manoeuvre2copyimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimagetobuffer4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimagetobuffer4apu():
   global target2function4apu
   from apu2image4xi import manoeuvre2copyimagetobuffer4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copybuffertoimage4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copybuffertoimage4apu():
   global target2function4apu
   from apu2image4xi import manoeuvre2copybuffertoimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2readimage4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre2readimage4apu():
   global target2function4apu
   from apu2image4xi import manoeuvre2readimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2writeimage4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre2writeimage4apu():
   global target2function4apu
   from apu2image4xi import manoeuvre2writeimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2mapimage4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre2mapimage4apu():
   global target2function4apu
   from apu2image4xi import manoeuvre2mapimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importcopy2image4apu" usage = " importing target function for Process4Xi">
def importcopy2image4apu():
   global target2function4apu
   from apu2image4xi import copy2image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importcopy2imagetobuffer4apu" usage = " importing target function for Process4Xi">
def importcopy2imagetobuffer4apu():
   global target2function4apu
   from apu2image4xi import copy2imagetobuffer4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importcopy2buffertoimage4apu" usage = " importing target function for Process4Xi">
def importcopy2buffertoimage4apu():
   global target2function4apu
   from apu2image4xi import copy2buffertoimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importread2image4apu" usage = " importing target function for Process4Xi">
def importread2image4apu():
   global target2function4apu
   from apu2image4xi import read2image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmap2image4apu" usage = " importing target function for Process4Xi">
def importmap2image4apu():
   global target2function4apu
   from apu2image4xi import map2image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importrelease2image4apu" usage = " importing target function for Process4Xi">
def importrelease2image4apu():
   global target2function4apu
   from apu2image4xi import release2image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importretain2image4apu" usage = " importing target function for Process4Xi">
def importretain2image4apu():
   global target2function4apu
   from apu2image4xi import retain2image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importset2imagecallback4apu" usage = " importing target function for Process4Xi">
def importset2imagecallback4apu():
   global target2function4apu
   from apu2image4xi import set2imagecallback4apu as target2function4apu 
#</function4xi>
 
#<function4xi function = "importset2image4apu" usage = " importing target function for Process4Xi">
def importset2image4apu():
   global target2function4apu
   from apu2image4xi import set2image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importtrace2image4apu" usage = " importing target function for Process4Xi">
def importtrace2image4apu():
   global target2function4apu
   from apu2image4xi import trace2image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importwait2image4apu" usage = " importing target function for Process4Xi">
def importwait2image4apu():
   global target2function4apu
   from apu2image4xi import wait2image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importwrite2image4apu" usage = " importing target function for Process4Xi">
def importwrite2image4apu():
   global target2function4apu
   from apu2image4xi import write2image4apu as target2function4apu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# 3D Image module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate3image4apu" usage = " importing target function for Process4Xi">
def importcreate3image4apu():
   global target2function4apu
   from apu3image4xi import create3image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importget3imageinfo4apu" usage = " importing target function for Process4Xi">
def importget3imageinfo4apu():
   global target2function4apu
   from apu3image4xi import get3imageinfo4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importget3supportedimageformats4apu" usage = " importing target function for Process4Xi">
def importget3supportedimageformats4apu():
   global target2function4apu
   from apu3image4xi import get3supportedimageformats4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimage4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimage4apu():
   global target2function4apu
   from apu3image4xi import manoeuvre3copyimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimagetobuffer4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimagetobuffer4apu():
   global target2function4apu
   from apu3image4xi import manoeuvre3copyimagetobuffer4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copybuffertoimage4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copybuffertoimage4apu():
   global target2function4apu
   from apu3image4xi import manoeuvre3copybuffertoimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3readimage4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre3readimage4apu():
   global target2function4apu
   from apu3image4xi import manoeuvre3readimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3writeimage4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre3writeimage4apu():
   global target2function4apu
   from apu3image4xi import manoeuvre3writeimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3mapimage4apu" usage = " importing target function for Process4Xi">
def importmanoeuvre3mapimage4apu():
   global target2function4apu
   from apu3image4xi import manoeuvre3mapimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importcopy3image4apu" usage = " importing target function for Process4Xi">
def importcopy3image4apu():
   global target2function4apu
   from apu3image4xi import copy3image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importcopy3imagetobuffer4apu" usage = " importing target function for Process4Xi">
def importcopy3imagetobuffer4apu():
   global target2function4apu
   from apu3image4xi import copy3imagetobuffer4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importcopy3buffertoimage4apu" usage = " importing target function for Process4Xi">
def importcopy3buffertoimage4apu():
   global target2function4apu
   from apu3image4xi import copy3buffertoimage4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importread3image4apu" usage = " importing target function for Process4Xi">
def importread3image4apu():
   global target2function4apu
   from apu3image4xi import read3image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importmap3image4apu" usage = " importing target function for Process4Xi">
def importmap3image4apu():
   global target2function4apu
   from apu3image4xi import map3image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importrelease3image4apu" usage = " importing target function for Process4Xi">
def importrelease3image4apu():
   global target2function4apu
   from apu3image4xi import release3image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importretain3image4apu" usage = " importing target function for Process4Xi">
def importretain3image4apu():
   global target2function4apu
   from apu3image4xi import retain3image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importset3imagecallback4apu" usage = " importing target function for Process4Xi">
def importset3imagecallback4apu():
   global target2function4apu
   from apu3image4xi import set3imagecallback4apu as target2function4apu 
#</function4xi>
 
#<function4xi function = "importset3image4apu" usage = " importing target function for Process4Xi">
def importset3image4apu():
   global target2function4apu
   from apu3image4xi import set3image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importtrace3image4apu" usage = " importing target function for Process4Xi">
def importtrace3image4apu():
   global target2function4apu
   from apu3image4xi import trace3image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importwait3image4apu" usage = " importing target function for Process4Xi">
def importwait3image4apu():
   global target2function4apu
   from apu3image4xi import wait3image4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importwrite3image4apu" usage = " importing target function for Process4Xi">
def importwrite3image4apu():
   global target2function4apu
   from apu3image4xi import write3image4apu as target2function4apu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Sampler module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2sampler4apu" usage = " importing target function for Process4Xi">
def importcreate2sampler4apu():
   global target2function4apu
   from apu2sampler4xi import create2sampler4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importget2samplerinfo4apu" usage = " importing target function for Process4Xi">
def importget2samplerinfo4apu():
   global target2function4apu
   from apu2sampler4xi import get2samplerinfo4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importrelease2sampler4apu" usage = " importing target function for Process4Xi">
def importrelease2sampler4apu():
   global target2function4apu
   from apu2sampler4xi import release2sampler4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importretain2sampler4apu" usage = " importing target function for Process4Xi">
def importretain2sampler4apu():
   global target2function4apu
   from apu2sampler4xi import retain2sampler4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importset2samplercallback4apu" usage = " importing target function for Process4Xi">
def importset2samplercallback4apu():
   global target2function4apu
   from apu2sampler4xi import set2samplercallback4apu as target2function4apu 
#</function4xi>
 
#<function4xi function = "importset2sampler4apu" usage = " importing target function for Process4Xi">
def importset2sampler4apu():
   global target2function4apu
   from apu2sampler4xi import set2sampler4apu as target2function4apu
#</function4xi>
 
#<function4xi function = "importtrace2sampler4apu" usage = " importing target function for Process4Xi">
def importtrace2sampler4apu():
   global target2function4apu
   from apu2sampler4xi import trace2sampler4apu as target2function4apu
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
# Program module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2programwithsource4apu" usage = " importing target function for Process4Xi">
def importcreate2programwithsource4apu():
   global target2function4apu
   from apu2kernel4xi import create2programwithsource4apu as target2function4apu
#</function4xi> 

#<function4xi function = "importcreate2programwithbinary4apu" usage = " importing target function for Process4Xi">
def importcreate2programwithbinary4apu():
   global target2function4apu
   from apu2kernel4xi import create2programwithbinary4apu as target2function4apu
#</function4xi> 

#<function4xi function = "importadd2programwithsource4apu" usage = " importing target function for Process4Xi">
def importadd2programwithsource4apu():
   global target2function4apu
   from apu2kernel4xi import add2programwithsource4apu as target2function4apu
#</function4xi> 

#<function4xi function = "importadd2programwithbinary4apu" usage = " importing target function for Process4Xi">
def importadd2programwithbinary4apu():
   global target2function4apu
   from apu2kernel4xi import add2programwithbinary4apu as target2function4apu
#</function4xi>

#<function4xi function = "importbuild2program4apu" usage = " importing target function for Process4Xi">
def importbuild2program4apu():
   global target2function4apu
   from apu2kernel4xi import build2program4apu as target2function4apu
#</function4xi>

#<function4xi function = "importbuild2program4apu" usage = " importing target function for Process4Xi">
def importbuild2program4apu():
   global target2function4apu
   from apu2kernel4xi import build2program4apu as target2function4apu
#</function4xi>

#<function4xi function = "importcompile2program4apuX" usage = " importing target function for Process4Xi">
def importcompile2program4apu():
   global target2function4apu
   from apu2kernel4xi import compile2program4apu as target2function4apu
#</function4xi>

#<function4xi function = "importdelete2programwithsource4apuX" usage = " importing target function for Process4Xi">
def importdelete2programwithsource4apu():
   global target2function4apu
   from apu2kernel4xi import delete2programwithsource4apu as target2function4apu
#</function4xi>    

#<function4xi function = "importdelete2programwithbinary4apuX" usage = " importing target function for Process4Xi">
def importdelete2programwithbinary4apu():
   global target2function4apu
   from apu2kernel4xi import delete2programwithbinary4apu as target2function4apu
#</function4xi>    

#<function4xi function = "importget2programinfo4apuX" usage = " importing target function for Process4Xi">
def importget2programinfo4apu():
   global target2function4apu
   from apu2kernel4xi import get2programinfo4apu as target2function4apu
#</function4xi>    

#<function4xi function = "importlink2program4apuX" usage = " importing target function for Process4Xi">
def importlink2program4apu():
   global target2function4apu
   from apu2kernel4xi import link2program4apu as target2function4apu
#</function4xi>    

#<function4xi function = "importrelease2program4apuX" usage = " importing target function for Process4Xi">
def importrelease2program4apu():
   global target2function4apu
   from apu2kernel4xi import release2program4apu as target2function4apu
#</function4xi>    

#<function4xi function = "importretain2program4apuX" usage = " importing target function for Process4Xi">
def importretain2program4apu():
   global target2function4apu
   from apu2kernel4xi import retain2program4apu as target2function4apu
#</function4xi>    

#<function4xi function = "importset2programcallback4apuX" usage = " importing target function for Process4Xi">
def importset2programcallback4apu():
   global target2function4apu
   from apu2kernel4xi import set2programcallback4apu as target2function4apu
#</function4xi>    

#<function4xi function = "importset2programwithsource4apuX" usage = " importing target function for Process4Xi">
def importset2programwithsource4apu():
   global target2function4apu
   from apu2kernel4xi import set2programwithsource4apu as target2function4apu
#</function4xi>    

#<function4xi function = "importset2programwithbinary4apuX" usage = " importing target function for Process4Xi">
def importset2programwithbinary4apu():
   global target2function4apu
   from apu2kernel4xi import set2programwithbinary4apu as target2function4apu
#</function4xi>    

#<function4xi function = "importtrace2program4apuX" usage = " importing target function for Process4Xi">
def importtrace2program4apu():
   global target2function4apu
   from apu2kernel4xi import trace2program4apu as target2function4apu
#</function4xi>    

# -------------------------------------------------------------------------------------------------
# Test modules of APU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importapu2commandqueue4xi5test" usage = " importing target function for Process4Xi">
def importapu2commandqueue4xi5test():
   global target2function4apu
   from apu2commandqueue4xi5test import apu2commandqueue4xi5test as target2function4apu
#</function4xi> 

#<function4xi function = "importapu2event4xi5test" usage = " importing target function for Process4Xi">
def importapu2event4xi5test():
   global target2function4apu
   from apu2event4xi5test import apu2event4xi5test as target2function4apu
#</function4xi>
 
#<function4xi function = "importapu2image4xi5test" usage = " importing target function for Process4Xi">
def importapu2image4xi5test():
   global target2function4apu
   from apu2image4xi5test import apu2image4xi5test as target2function4apu
#</function4xi>
 
#<function4xi function = "importapu3image4xi5test" usage = " importing target function for Process4Xi">
def importapu3image4xi5test():
   global target2function4apu
   from apu3image4xi5test import apu3image4xi5test as target2function4apu
#</function4xi>
 
#<function4xi function = "importapu2sampler4xi5test" usage = " importing target function for Process4Xi">
def importapu2sampler4xi5test():
   global target2function4apu
   from apu2sampler4xi5test import apu2sampler4xi5test as target2function4apu
#</function4xi>
 
#<function4xi function = "importAPU2kernel4xi5test" usage = " importing target function for Process4Xi">
def importapu2kernel4xi5test():
   global target2function4apu
   from apu2kernel4xi5test import apu2kernel4xi5test as target2function4apu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Error handler of APU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "handle2error4apu" usage = " Error handling for importing target function for Process4Xi">
def handle2error4apu():
   global import2use4apu
   print ("HANDLE2ERROR4APU OF APU2KERNEL4XI.PY: *** FAILED TO IMPORT TARGET FUNCTION ***")
   keys2import4apu = import2use4apu.keys()
   for key2import4apu in keys2import4apu:
       print(key2import4apu,import2use4apu[key2import4apu]) 
#</function4xi> 


import2use4apu = {}
# -------------------------------------------------------------------------------------------------
# Command queue module of APU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4apu["create2commandqueue4apu"] = importcreate2commandqueue4apu        
import2use4apu["flush2commandqueue4apu"] = importflush2commandqueue4apu 
import2use4apu["finish2commandqueue4apu"] = importfinish2commandqueue4apu 
import2use4apu["get2commandqueueinfo4apu"] = importget2commandqueueinfo4apu 
import2use4apu["release2commandqueue4apu"] = importrelease2commandqueue4apu 
import2use4apu["retain2commandqueue4apu"] = importretain2commandqueue4apu 
import2use4apu["set2commandqueue4apu"] = importset2commandqueue4apu 
import2use4apu["trace2commandqueue4apu"] = importtrace2commandqueue4apu 

# -------------------------------------------------------------------------------------------------
# Context module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4apu["create2context4apu"] = importcreate2context4apu 
import2use4apu["get2context4apu"] = importget2context4apu 
import2use4apu["release2context4apu"] = importrelease2context4apu 
import2use4apu["retain2context4apu"] = importretain2context4apu 
import2use4apu["set2context4apu"] = importset2context4apu 

# -------------------------------------------------------------------------------------------------
# Device module of APU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4apu["init2apu4xi"] = importinit2apu4xi 
import2use4apu["set2apu4xi"] = importset2apu4xi 
import2use4apu["get2apu4xi"] = importget2apu4xi 

# -------------------------------------------------------------------------------------------------
# Event module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4apu["create2event4apu"] = importcreate2event4apu 
import2use4apu["get2eventinfo4apu"] = importget2eventinfo4apu 
import2use4apu["release2event4apu"] = importrelease2event4apu 
import2use4apu["retain2event4apu"] = importretain2event4apu 
import2use4apu["set2eventcallback4apu"] = importset2eventcallback4apu 
import2use4apu["set2event4apu"] = importset2event4apu 
import2use4apu["trace2event4apu"] = importtrace2event4apu 
import2use4apu["wait2event4apu"] = importwait2event4apu 

# -------------------------------------------------------------------------------------------------
# 2D Image module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4apu["create2image4apu"] = importcreate2image4apu 
import2use4apu["get2imageinfo4apu"] = importget2imageinfo4apu 
import2use4apu["get2supportedimageformats4apu"] = importget2supportedimageformats4apu 
import2use4apu["manoeuvre2copyimage4apu"] = importmanoeuvre2copyimage4apu 
import2use4apu["manoeuvre2copyimagetobuffer4apu"] = importmanoeuvre2copyimagetobuffer4apu 
import2use4apu["manoeuvre2copybuffertoimage4apu"] = importmanoeuvre2copybuffertoimage4apu 
import2use4apu["manoeuvre2readimage4apu"] = importmanoeuvre2readimage4apu 
import2use4apu["manoeuvre2writeimage4apu"] = importmanoeuvre2writeimage4apu 
import2use4apu["manoeuvre2mapimage4apu"] = importmanoeuvre2mapimage4apu 
import2use4apu["copy2image4apu"] = importcopy2image4apu 
import2use4apu["copy2imagetobuffer4apu"] = importcopy2imagetobuffer4apu 
import2use4apu["copy2buffertoimage4apu"] = importcopy2buffertoimage4apu 
import2use4apu["read2image4apu"] = importread2image4apu 
import2use4apu["map2image4apu"] = importmap2image4apu 
import2use4apu["release2image4apu"] = importrelease2image4apu 
import2use4apu["retain2image4apu"] = importretain2image4apu 
import2use4apu["set2imagecallback4apu"] = importset2imagecallback4apu 
import2use4apu["set2image4apu"] = importset2image4apu 
import2use4apu["trace2image4apu"] = importtrace2image4apu 
import2use4apu["wait2image4apu"] = importwait2image4apu 
import2use4apu["write2image4apu"] = importwrite2image4apu 

# -------------------------------------------------------------------------------------------------
# 3D Image module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4apu["create3image4apu"] = importcreate3image4apu 
import2use4apu["get3imageinfo4apu"] = importget3imageinfo4apu 
import2use4apu["get3supportedimageformats4apu"] = importget3supportedimageformats4apu 
import2use4apu["manoeuvre3copyimage4apu"] = importmanoeuvre3copyimage4apu 
import2use4apu["manoeuvre3copyimagetobuffer4apu"] = importmanoeuvre3copyimagetobuffer4apu 
import2use4apu["manoeuvre3copybuffertoimage4apu"] = importmanoeuvre3copybuffertoimage4apu 
import2use4apu["manoeuvre3readimage4apu"] = importmanoeuvre3readimage4apu 
import2use4apu["manoeuvre3writeimage4apu"] = importmanoeuvre3writeimage4apu 
import2use4apu["manoeuvre3mapimage4apu"] = importmanoeuvre3mapimage4apu 
import2use4apu["copy3image4apu"] = importcopy3image4apu 
import2use4apu["copy3imagetobuffer4apu"] = importcopy3imagetobuffer4apu 
import2use4apu["copy3buffertoimage4apu"] = importcopy3buffertoimage4apu 
import2use4apu["read3image4apu"] = importread3image4apu 
import2use4apu["map3image4apu"] = importmap3image4apu 
import2use4apu["release3image4apu"] = importrelease3image4apu 
import2use4apu["retain3image4apu"] = importretain3image4apu 
import2use4apu["set3imagecallback4apu"] = importset3imagecallback4apu 
import2use4apu["set3image4apu"] = importset3image4apu 
import2use4apu["trace3image4apu"] = importtrace3image4apu 
import2use4apu["wait3image4apu"] = importwait3image4apu 
import2use4apu["write3image4apu"] = importwrite3image4apu 

# -------------------------------------------------------------------------------------------------
# Sampler module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4apu["create2sampler4apu"] = importcreate2sampler4apu 
import2use4apu["get2samplerinfo4apu"] = importget2samplerinfo4apu 
import2use4apu["release2sampler4apu"] = importrelease2sampler4apu 
import2use4apu["retain2sampler4apu"] = importretain2sampler4apu 
import2use4apu["set2samplercallback4apu"] = importset2samplercallback4apu 
import2use4apu["set2sampler4apu"] = importset2sampler4apu 
import2use4apu["trace2sampler4apu"] = importtrace2sampler4apu 

# -------------------------------------------------------------------------------------------------
# Program module of APU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4apu["trace2program4apu"] = importtrace2program4apu
import2use4apu["set2programwithbinary4apu"] = importset2programwithbinary4apu
import2use4apu["set2programwithsource4apu"] = importset2programwithsource4apu
import2use4apu["set2programcallback4apu"] = importset2programcallback4apu
import2use4apu["retain2program4apu"] = importretain2program4apu
import2use4apu["release2program4apu"] = importrelease2program4apu
import2use4apu["link2program4apu"] = importlink2program4apu
import2use4apu["get2programinfo4apu"] = importget2programinfo4apu
import2use4apu["delete2programwithbinary4apu"] = importdelete2programwithbinary4apu
import2use4apu["delete2programwithsource4apu"] = importdelete2programwithsource4apu
import2use4apu["compile2program4apu"] = importcompile2program4apu
import2use4apu["build2program4apu"] = importbuild2program4apu
import2use4apu["build2program4apu"] = importbuild2program4apu
import2use4apu["add2programwithbinary4apu"] = importadd2programwithbinary4apu
import2use4apu["add2programwithsource4apu"] = importadd2programwithsource4apu
import2use4apu["create2programwithbinary4apu"] = importcreate2programwithbinary4apu
import2use4apu["create2programwithsource4apu"] = importcreate2programwithsource4apu



# -------------------------------------------------------------------------------------------------
# Test modules of APU imports for target function                             
# -------------------------------------------------------------------------------------------------
import2use4apu["apu2commandqueue4xi5test"] = importapu2commandqueue4xi5test 
import2use4apu["apu2event4xi5test"]        = importapu2event4xi5test 
import2use4apu["apu2image4xi5test"]        = importapu2image4xi5test 
import2use4apu["apu3image4xi5test"]        = importapu3image4xi5test 
import2use4apu["apu2sampler4xi5test"]      = importapu2sampler4xi5test 
import2use4apu["apu2kernel4xi5test"]       = importapu2kernel4xi5test 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2kernel4apu" usage = "
#
#   print('=' *33)          
#   print('(Step 15A/25) OF APU2KERNEL4XI5TEST - TRYING TO TRACE APU: ', time4xi())      
#   print('=' *33)      
#   trace2apu = None
#   try:
#       trace2apu = trace2kernel4apu() 
#       print('(Step 15B/25) OF APU2KERNEL4XI5TEST - TRACE2APU: ', trace2apu)  
#       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4apu-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4apu', 'METHOD': 'trace2kernel4apu'} 
#   except:
#       print('(Step 15Z1/25) OF APU2KERNEL4XI5TEST *** FAILED TO TRACE APU: ', trace2apu) 
#      
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def trace2kernel4apu(task4trace2apu=None):  

    '''
    creates callback to apu2kernel4xi
    '''
    
    global apu2trace4xi
    global folder2lib4apu    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2kernel4apu" 
    method2print = "trace2kernel4apu"

    message2print = "{(Step 1A/33) started" + "; trace2kernel4apu-started: " + str(trace2kernel4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                               
    # <function trace2kernel4apu at 0x0000000003959A48> 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2apu-to-trace2kernel4apu: " + str(task4trace2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    apu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2apu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY DRAGONIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2apu = {}                                                                                            
            
        task4trace2apu['CLASS']   = "trace2kernel4apu"                                                              # DRAGONIZE ZPU TRACE!
        task4trace2apu['METHOD']  = "trace2kernel4apu" 
        task4trace2apu['MESSAGE'] = "{(Step 2Z0/33) failed" + "; trace2kernel4apu-failed " + str(apu2trace4xi)  + "; time: " + time4xi() + "}"               
  
        
        message2print = "{(Step 2A/33) set" + "; task4trace2apu-set-by-trace2kernel4apu to: " + str(task4trace2apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4apu-failed {}
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # PARAMETER GIVEN BY DRAGONIZED CALLBACK !
    # -----------------------------------------------------------------------------------------          
    message2print = "{(Step 3A/33) try" + "; task4trace2apu-try-by-trace2kernel4apu: " + str(task4trace2apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
    # 

    try:
        apu2trace4xi ['CLASS']  = task4trace2apu['CLASS']                                                           # DRAGONIZE APU TRACE!
        apu2trace4xi ['METHOD']  = task4trace2apu['METHOD']
        apu2trace4xi ['MESSAGE'] = task4trace2apu['MESSAGE']
        
        message2print = "{(Step 3B/33) set" + "; apu2trace4xi-set-by-trace2kernel4apu to: " + str(apu2trace4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4apu-failed {}

        code2ack = code2ack + '3B-'         
    except:
        message2print = "{(Step 3Z1/33) failed" + "; apu-trace-failed-by-trace2kernel4apu: " + str(task4trace2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z1-' 
        
    try:
        # =================================
        # SIMULATE APU TRACE
        # =================================
        class2print   = task4trace2apu['CLASS']                                                                     # DRAGONIZE APU TRACE!
        method2print  = task4trace2apu['METHOD']
        
        message2print = task4trace2apu['MESSAGE']
        print4xi(class2print, method2print, message2print)                                                          # DRAGONIZED TRACE FOR OPENCL CALLBACK!
        # 
        
        
        code2ack = code2ack + '3C-'         
    except:
        class2print = "trace2kernel4apu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4apu"   
        message2print = "{(Step 3Z2/33) failed" + "; simulation-of-apu-trace-failed-by-trace2kernel4apu: " + str(task4trace2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z2-' 
        
    try:
        # =================================
        # NORMAL TRACE
        # =================================                     
        class2print = "trace2kernel4apu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4apu"                
        message2print = "{(Step 3D/33) performed" + "; apu-trace-performed-by-trace2kernel4apu: " + str(task4trace2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4apu-failed {}
        code2ack = code2ack + '3D-' 
    except:
        message2print = "{(Step 3Z3/33) failed" + "; apu-trace-failed-by-trace2kernel4apu: " + str(task4trace2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z3-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; apu2trace4xi-returning-by-trace2kernel4apu: " + str(apu2trace4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4apu-failed {}
    
    return apu2trace4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2kernel4apu" usage = "
#   
#   response4execute2kernel = execute2kernel4apu()
#      
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def execute2kernel4apu(task4execute2apu=None):  

    '''
    executes kernel to APU 
    '''
    global folder2lib4apu 
    global import2use4apu 
    global target2function4apu 
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2kernel4apu" 
    method2print = "execute2kernel4apu"

    message2print = "{(Step 1A/33) started" + "; execute2kernel4apu-started: " + str(execute2kernel4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # <function execute2kernel4apu at 0x000000000454AEC8>
  
          
    message2print = "{(Step 1B/33) passed" + "; task4execute2apu-to-execute2kernel4apu: " + str(task4execute2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                            
    # {'LOCALWORKSIZE': 0, 'KERNEL': ... ; None
        
    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------   
    status4execute2apu = 'CL_SUCCESS'
    
    if task4execute2apu is None:
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)         
        # -----------------------------------------------------------------------------------------   
        try:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN - BUILD THEM
            # -----------------------------------------------------------------------------------------    
            task4execute2apu = {}                                                                                            
    
            message2print = "{(Step 2A1/33) set" + "; task4execute2apu-set-by-execute2kernel4apu to: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {}
            
            task4execute2apu['COMMANDQUEUE'] = create2commandqueue4apu()
            message2print = "{(Step 2A2/33) set" + "; commandqueue4execute2apu-set-by-execute2kernel4apu to: " + str(task4execute2apu['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
                        
            task4execute2apu['KERNEL'] = create2kernel4apu()
            message2print = "{(Step 2A3/33) set" + "; kernel4execute2apu-set-by-execute2kernel4apu to: " + str(task4execute2apu['KERNEL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'DIRECTORY4CL': ... 
            
            response4get2apu = get2apu4xi()
            task4execute2apu['WORKDIMENSION'] = response4get2apu['MAX2DIMENSIONS4WORKITEMS']        
            message2print = "{(Step 2A4/33) set" + "; workdimension4execute2apu-set-by-execute2kernel4apu to: " + str(task4execute2apu['WORKDIMENSION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 3             
            
            task4execute2apu['GLOBALWORKOFFSET'] = 0
            message2print = "{(Step 2A5/33) set" + "; globalworkoffset4execute2apu-set-by-execute2kernel4apu to: " + str(task4execute2apu['GLOBALWORKOFFSET'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
             
            task4execute2apu['GLOBALWORKSIZE'] = 0 
            message2print = "{(Step 2A6/33) set" + "; globalworksize4execute2apu-set-by-execute2kernel4apu to: " + str(task4execute2apu['GLOBALWORKSIZE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            task4execute2apu['LOCALWORKSIZE'] = 0 
            message2print = "{(Step 2A7/33) set" + "; localworksize4execute2apu-set-by-execute2kernel4apu to: " + str(task4execute2apu['LOCALWORKSIZE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            task4execute2apu['EVENTQUANTITY'] = 0
            message2print = "{(Step 2A8/33) set" + "; eventquantity4execute2apu-set-by-execute2kernel4apu to: " + str(task4execute2apu['EVENTQUANTITY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            task4execute2apu['EVENT'] = create2event4apu()
            message2print = "{(Step 2A9/33) set" + "; event4execute2apu-set-by-execute2kernel4apu to: " + str(task4execute2apu['EVENT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'CODE2ERROR': 0, 'DATA2CALLBACK' ...                                                           
            
        except:
            message2print = "{(Step 2Z1/33) failed" + "; task4execute2apu-failed-by-execute2kernel4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            status4execute2apu = 'CL_FAILURE' 
                     
    else:
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)         
        # -----------------------------------------------------------------------------------------      
        try:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN
            # -----------------------------------------------------------------------------------------          
            message2print = "{(Step 3A/33) using" + "; task4execute2apu-using-by-execute2kernel4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'LOCALWORKSIZE': 0, 'KERNEL': ...
            
        except:
            message2print = "{(Step 3Z1/33) failed" + "; task4execute2apu-failed-by-execute2kernel4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                          
            status4execute2apu = 'CL_FAILURE'
            message2print = "{(Step 3Z2/33) set" + "; status4execute2apu-set-by-execute2kernel4apu to: " + str(status4execute2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             

    # -----------------------------------------------------------------------------------------
    # (Step 4/3) 
    # -----------------------------------------------------------------------------------------          
    if status4execute2apu == 'CL_SUCCESS': 
        keys2execute4apu = task4execute2apu.keys()
        message2print = "{(Step 4A/33) using" + "; keys2execute4apu-using-by-execute2kernel4apu: " + str(keys2execute4apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # (['LOCALWORKSIZE', 'KERNEL', 'GLOBALWORKSIZE', 'GLOBALWORKOFFSET', 'COMMANDQUEUE', 'EVENTQUANTITY', 'WORKDIMENSION', 'EVENT'])

        if 'KERNEL' in keys2execute4apu:
            try:
                keys2kernel4apu = task4execute2apu['KERNEL'].keys()
                message2print = "{(Step 4B/33) using" + "; keys2kernel4apu-using-by-execute2kernel4apu: " + str(keys2kernel4apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # dict_keys(['DIRECTORY4CL',
                #  'CODE4PY',
                #  'DIRECTORY4PY',
                #  'SIZE4PY',
                #  'FUNCTION',
                #  'CODE4CPP',
                #  'SIZE4CL',
                #  'COUNT4CL',
                #  'COUNT4PY' ...
                
                if 'CODE4PY' in keys2kernel4apu: 
                    try:
                        keys2pythoncode4apu = task4execute2apu ['KERNEL'] ['CODE4PY'].keys()
                        
                        message2print = "{(Step 4C/33) using" + "; keys2pythoncode4apu-using-by-execute2kernel4apu: " + str(keys2pythoncode4apu)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # apu2sampler4xi5test.py 
                        for key2pythoncode4apu in keys2pythoncode4apu:
                            message2print = "{(Step 4D/33) using" + "; key2pythoncode4apu-using-by-execute2kernel4apu: " + str(key2pythoncode4apu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # apu2sampler4xi5test.py 
                            
                        if 'FUNCTION' in keys2kernel4apu: 
                            try:
                                keys2functiontype4apu = task4execute2apu ['KERNEL'] ['FUNCTION'].keys()
                                
                                message2print = "{(Step 4E/33) using" + "; keys2functiontype4apu-using-by-execute2kernel4apu: " + str(keys2functiontype4apu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # ['.py', '.cpp']
                                if '.py' in keys2functiontype4apu:
                                    try:
                                        keys2pythonfunction4apu = task4execute2apu ['KERNEL'] ['FUNCTION'] ['.py'].keys()
                                        message2print = "{(Step 4F/33) using" + "; keys2pythonfunction4apu-using-by-execute2kernel4apu: " + str(keys2pythonfunction4apu)  + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # apu2sampler4xi5test
                                         
                                                                               
                                        for key2pythonfunction4apu in keys2pythonfunction4apu:
                                            message2print = "{(Step 4G/33) using" + "; key2pythonfunction4apu-using-by-execute2kernel4apu: " + str(key2pythonfunction4apu)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # apu2sampler4xi5test JATKA
                                            target2execute4apu = key2pythonfunction4apu
                                            try: 
                                                import2use4apu.get(target2execute4apu, handle2error4apu) ()  
                            
                                                message2print = "{(Step 4H/70) imported" + "; target2execute4apu-imported-by-execute2kernel4apu: " + str(target2execute4apu) + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # apu2sampler4xi5test 
                                                try:
                                                    # ---------------------------------------------------------------------------------------------    
                                                    # CREATE PROCESS WITH TARGET FUNCTION (NOTE TARGET!)
                                                    # ---------------------------------------------------------------------------------------------                          
                                                    p2apu = Process4Xi(target=target2function4apu, args=())                                
                                                    message2print = "{(Step 4I/33) created" + "; p2apu-created-by-execute2kernel4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                                                    print4xi(class2print, method2print, message2print)  
                                                    # <Process4Xi(Process4Xi-1, initial)>
                                                    try:
                                                        # ---------------------------------------------------------------------------------------------    
                                                        # START PROCESS 
                                                        # --------------------------------------------------------------------------------------------- 
                                                        p2apu.start()
                                                        message2print = "{(Step 4J/33) started" + "; p2apu-started-by-execute2kernel4apu: " + str(p2apu.name) + "; time: " + time4xi() + "}"
                                                        print4xi(class2print, method2print, message2print)
                                                        # Process4Xi-1
                                                        try:
                                                            # ---------------------------------------------------------------------------------------------    
                                                            # STATUS OF PROCESS
                                                            # ---------------------------------------------------------------------------------------------                             
                                                            status2process4apu = p2apu.is_alive()
                                                            message2print = "{(Step 4K/33) got" + "; status-got-by-execute2kernel4apu: " + str(status2process4apu) + "; time: " + time4xi() + "}"
                                                            print4xi(class2print, method2print, message2print)
                                                            # True
                                                            try:
                                                                # ---------------------------------------------------------------------------------------------    
                                                                # RUN PROCESS
                                                                # ---------------------------------------------------------------------------------------------                                  
                                                                p2apu.run()
                                                                message2print = "{(Step 4L/33) run" + "; p2apu-run-by-execute2kernel4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                                                                print4xi(class2print, method2print, message2print)
                                                                # 
                                                            except:
                                                                message2print = "{(Step 4Z24/70) failed" + "; run2process4apu-failed-by-execute2kernel4apu: " + str(task4execute2apu) + "; time: " + time4xi() + "}"
                                                                print4xi(class2print, method2print, message2print)  
                                                                #
                                                                status4execute2apu = 'CL_FAILURE' 
                                                        except:
                                                            message2print = "{(Step 4Z25/33) failed" + "; status2process4apu-failed-by-execute2kernel4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
                                                            print4xi(class2print, method2print, message2print)
                                                            #
                                                            status4execute2apu = 'CL_FAILURE'
                                                    except:
                                                        message2print = "{(Step 4Z26/33) failed" + "; status2process4apu-failed-by-execute2kernel4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
                                                        print4xi(class2print, method2print, message2print)
                                                        #
                                                        status4execute2apu = 'CL_FAILURE'                                                                     
                                                except:
                                                    message2print = "{(Step 4Z27/33) failed" + "; start2process4apu-failed-by-execute2kernel4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
                                                    print4xi(class2print, method2print, message2print)
                                                    # 
                                                    status4execute2apu = 'CL_FAILURE'                               
                                            except:
                                                message2print = "{(Step 4Z28/33) failed" + "; import2target4apu-failed-by-execute2kernel4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                #
                                                status4execute2apu = 'CL_FAILURE'
                                                 
                                    except:
                                        message2print = "{(Step 4Z29/33) failed" + "; python2execute4apu-failed-by-execute2kernel4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        #
                                        status4execute2apu = 'CL_FAILURE'                                    
                                              
                            except:
                                message2print = "{(Step 4Z30/33) failed" + "; task4execute2apu-failed-by-execute2kernel4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                #
                                status4execute2apu = 'CL_FAILURE'
                                      
                    except:
                        message2print = "{(Step 4Z31/33) failed" + "; task4execute2apu-failed-by-execute2kernel4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #
                        status4execute2apu = 'CL_FAILURE'
                        


            except:
                message2print = "{(Step 4Z32/33) failed" + "; task4execute2apu-failed-by-execute2kernel4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                status4execute2apu = 'CL_FAILURE'
                message2print = "{(Step 4Z33/33) set" + "; status4execute2apu-set-by-execute2kernel4apu to: " + str(status4execute2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
            #                  
    else:
        pass
    

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; status4execute2apu-returning-by-execute2kernel4apu: " + str(status4execute2apu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # CL_SUCCESS
    
    return status4execute2apu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelcallback4apu" usage = "
#
#   print('(Step 14A/700) OF APU2KERNEL4XI5TEST - TRYING TO SET PROGRAM CALLBACK OF APU ', time4xi())  
#   try:                               
#       response4setcallback2program = set2kernelcallback4apu()                                                                                                 
#       print('(Step 14B/700) OF APU2KERNEL4XI5TEST - SET PROGRAM CALLBACK OF APU TO: ', response4setcallback2program)   
#       # 
#   except:
#       print('(Step 14Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO SET PROGRAM CALLBACK OF APU ', time4xi())  
# 
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------- 
 
def set2kernelcallback4apu(task4set2kernelcallback=None):

    '''
    registers callback function to apu2kernel4xi
    '''
    global apu2kernel4xi
    global folder2lib4apu  
        
    class2print = "set2kernelcallback4apu" 
    method2print = "set2kernelcallback4apu"
    
    message2print = "{(Step 2A/70) started" + "; set2kernelcallback4apu-started: " + str(set2kernelcallback4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # set2kernelcallback4apu-started
    
    try:
    
        apu2kernel4xi ['CALLBACK'] = trace2kernel4apu
        
        
        message2print = "{(Step 2C/70) returning" + "; callback-of-apu2kernel4xi-returning-by-set2kernelcallback4apu: " + str(apu2kernel4xi ['CALLBACK']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print) 
        # <function trace2kernel4apu at 0x0000000003959A48>
        
        return apu2kernel4xi ['CALLBACK']      
        
    except:
        message2print = "{(Step 2Z1/70) failed" + "; callback2program-failed-by-set2kernelcallback4apu: " + str(callback2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         

        message2print = "{(Step 2Z2/70) returning" + "; trace2kernel4apu-returning-by-set2kernelcallback4apu: " + str(trace2kernel4apu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)      
            
        return trace2kernel4apu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2task4apu" usage = "
#
#   try:                               
#       response4execute2task = execute2task4apu(task4execute2task)
#       print('(Step 99B/700) OF APU2KERNEL4XI5TEST - BUILT PROGRAM OF APU DEVICE ', time4xi())
#   except:
#       print('(Step 99Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO EXECUTE PROGRAM OF APU DEVICE ', time4xi())  
#                 
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def execute2task4apu(task4execute2apu=None):

    '''
    executes  program to APU 
    '''
    global apu2execute4xi
    global folder2lib4apu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2task4apu"
    method2print = "execute2task4apu" 

    message2print = "{(Step 1A/33) started" + "; execute2task4apu-started: " + str(execute2task4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # execute2task4apu-started
    
    
    message2print = "{(Step 1B/33) passed" + "; task4execute2apu-to-execute2task4apu: " + str(task4execute2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
             
    code2ack  = ' '
    code2nack = ' '

    message2print = "{(Step 1A/70) try" + "; execute-try-by-execute2task4apu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    try:             
        if task4execute2apu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - EXECUTE TASK TO APU! 
            # -----------------------------------------------------------------------------------------    
            task4execute2apu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4execute2apu-initialized-by-execute2task4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 
            
            # ---------------------------------------------------------------------------------------------
            # (1) KERNEL REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            program2apu = {}
            message2print = "{(Step 1A/70) trying" + "; program2apu-trying-by-create2kernel4apu: " + str(program2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                program2apu = create2kernel4apu()                                                                     
                
                message2print = "{(Step 1B/70) got" + "; program2apu-got-by-create2kernel4apu: " + str(program2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                #                 
                code2ack  = code2ack + '1B-'         
            except:
                message2print = "{(Step 1Z/70) failed" + "; program2apu-failed-by-create2kernel4apu: " + str(program2apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '1Z-'
                
            task4execute2apu ['PROGRAM'] = program2apu
            
            # ---------------------------------------------------------------------------------------------
            # (2) OPTIONS - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            task4execute2task  ['OPTIONS'] = {}
          
            
            # ---------------------------------------------------------------------------------------------
            # (3) CALLBACK - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            function2callback4apu = trace2kernel4apu                                                               # CALLBACK FUNCTION FOR APU
            
            message2print = "{(Step 3A/70) initialized" + "; function2callback4apu-created-by-execute2task4apu: " + str(function2callback4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 
            
            code2ack  = code2ack + '3A-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "execute2task4apu"                                                            # MODULE OF DRAGONIZED OPENCL MODULE
            args2callback['METHOD']  = "execute2task4apu"                                                            # FUNCTION OF DRAGONIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 3Z1/33) failed" + "; execute2task4apu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR DRAGONIZED OPENCL TO RETURN    

            message2print = "{(Step 3B/70) initialized" + "; args2callback-created-by-execute2task4apu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 

            code2ack  = code2ack + '3B-'
            
           
            task4execute2apu['DATA2CALLBACK'] = args2callback                                                       # USER DATA PASSED TO DRAGONIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4execute2apu['FUNCTION2CALLBACK'] = function2callback4apu                                           # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '3C-'

            
            # ---------------------------------------------------------------------------------------------
            # (4) USERDATA - REQUIRED                         
            # ---------------------------------------------------------------------------------------------
            task4execute2apu['USERDATA'] = None 
            
            message2print = "{(Step 4A/70) initialized" + "; task4execute2apu-created-by-execute2task4apu: " + str(task4execute2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #
        else:
            pass                                                                  
    except:
        message2print = "{(Step 1Z1/70) yielded" + "; task4execute2apu-yielded-by-execute2task4apu: " + str(task4execute2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-'  
                                                                                                 
    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4execute2apu.keys()        
    message2print = "{(Step 9/70) using" + "; keys2task-using-by-execute2task4apu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 
  
    # ---------------------------------------------------------------------------------------------
    # (Step 10A/70) - CREATE EXECUTE FOR APU ! 
    # ---------------------------------------------------------------------------------------------    
    apu2execute4xi = {}                                                                                                                                                                               
    message2print = "{(Step 10A/70) initialized" + "; apu2execute4xi-initialized-by-execute2task4apu to: " + str(apu2execute4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    message2print = "{(Step 11A0/70) try" + "; program-try-by-execute2task4apu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 11A/70) - PROGRAM - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        apu2execute4xi['PROGRAM'] = task4execute2apu['PROGRAM']
        
        message2print = "{(Step 11A1/70) initialized" + "; program-created-by-execute2task4apu: " + str(apu2execute4xi['PROGRAM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '11A1-'
    except: 
        message2print = "{(Step 11Z1/70) yielded" + "; program-apu2execute4xi-yielded-by-execute2task4apu: " + str(apu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '11Z1-' 
           
    message2print = "{(Step 12A0/70) try" + "; options-try-by-execute2task4apu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 12A/70) - OPTIONS - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        apu2execute4xi['OPTIONS'] = task4execute2apu['OPTIONS']
        
        message2print = "{(Step 12A1/70) initialized" + "; options-created-by-execute2task4apu: " + str(apu2execute4xi['OPTIONS'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '12A1-'
    except: 
        message2print = "{(Step 12Z1/70) yielded" + "; options-apu2execute4xi-yielded-by-execute2task4apu: " + str(apu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '12Z1-' 
        
    message2print = "{(Step 13A0/70) try" + "; callback-try-by-execute2task4apu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 13A/70) - CALLBACK - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        apu2execute4xi['CALLBACK'] = task4execute2apu['CALLBACK']
        
        message2print = "{(Step 13A1/70) initialized" + "; callback-created-by-execute2task4apu: " + str(apu2execute4xi['CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '13A1-'
    except: 
        message2print = "{(Step 13Z1/70) yielded" + "; callback-apu2execute4xi-yielded-by-execute2task4apu: " + str(apu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '13Z1-' 
        
    message2print = "{(Step 14A0/70) try" + "; userdata-try-by-execute2task4apu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 14A/70) - USERDATA - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        apu2execute4xi['USERDATA'] = task4execute2apu['USERDATA']
        
        message2print = "{(Step 14A1/70) initialized" + "; userdata-created-by-execute2task4apu: " + str(apu2execute4xi['USERDATA'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '14A1-'
    except: 
        message2print = "{(Step 14Z1/70) yielded" + "; userdata-apu2execute4xi-yielded-by-execute2task4apu: " + str(apu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '14Z1-'
                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2execute4xi ['ACK2RETURN']  = code2ack
    apu2execute4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; apu2execute4xi-returning-by-execute2task4apu: " + str(apu2execute4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    
    return apu2execute4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernel4apu" usage = "
#     
#   print('(Step 2A1/700) OF APU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR APU ', time4xi())       
#   try:
#       response4create2kernel = create2kernel4apu()
#   except:
#       print('(Step 2Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR APU *** ', time4xi())
#          
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def create2kernel4apu(task4kernel2apu=None):

    '''
    creates kernel for APU
    '''
    global apu2kernel4xi                                                                                            # Kernel of APU    
    global folder2lib4apu  
    global kb2kernel4apu                                                                                            # Knowledgebase for kernel      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernel4apu" 
    method2print = "create2kernel4apu"

    message2print = "{(Step 1A/70) started" + "; create2kernel4apu-started: " + str(create2kernel4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2kernel4apu at 0x0000000003AAD8C8> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2apu-to-create2kernel4apu: " + str(task4kernel2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    #1: None
    #2: 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    apu2kernel4xi = {}                                                                                              # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernel2apu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO APU! 
            # -----------------------------------------------------------------------------------------    
            
            task4kernel2apu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4kernel2apu-created-by-create2kernel4apu: " + str(task4kernel2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - EXTRA                 
            # ---------------------------------------------------------------------------------------------
                        
            function2callback4apu = trace2kernel4apu                                                                # CALLBACK FUNCTION FOR APU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4apu-created-by-create2kernel4apu: " + str(function2callback4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4apu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4apu"                                                          # MODULE OF DRAGONIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4apu"                                                          # FUNCTION OF DRAGONIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4apu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR DRAGONIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4apu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4apu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4apu',
            #  'METHOD': 'create2kernel4apu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2apu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO DRAGONIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2apu['FUNCTION2CALLBACK'] = function2callback4apu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2apu-created-by-create2kernel4apu: " + str(task4kernel2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4apu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4apu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4apu',
            #  'METHOD': 'create2kernel4apu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}


            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-created-by-create2kernel4apu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            try:
                platform2xi = get2platformids4xi()                                                                  # PLATFORM IS COMMON TO ALL DEVICES I.E TO DEVICE XI
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2kernel4apu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 03:33:11 12/06/11 Pacific Standard Time}
                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2kernel4apu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4kernel2apu['PLATFORM'] = platform2xi                                                               # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - EXTRA                   
            # ---------------------------------------------------------------------------------------------    
            context2apu = {}
            message2print = "{(Step 3A/70) trying" + "; context2apu-trying-by-create2kernel4apu: " + str(context2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2apu = get2context4apu()                                                                     # NO PARAMETERS - THE SYSTEM CREATES CONTEXT IF REQUIRED  
                
                message2print = "{(Step 3B/70) got" + "; context2apu-got-by-create2kernel4apu: " + str(context2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2apu-failed-by-create2kernel4apu: " + str(context2apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
                
            task4kernel2apu ['CONTEXT'] = context2apu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------    
            device2apu = {}
            
            message2print = "{(Step 4A/70) trying" + "; device2apu-trying-by-create2kernel4apu: " + str(device2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2apu = get2apu4xi()                                                                           # THE SYSTEM CREATES DEVICE INFO, IF NECESSARY    
                
                message2print = "{(Step 4B/70) got" + "; device2apu-got-by-create2kernel4apu: " + str(device2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2apu-failed-by-create2kernel4apu: " + str(device2apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4kernel2apu ['DEVICE'] = device2apu
            
                   
            # ---------------------------------------------------------------------------------------------
            # (5) ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4kernel2apu ['CODE2ERROR'] = 0             
            code2ack  = code2ack + '5B-'              

            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            queue2apu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2apu-trying-by-create2kernel4apu: " + str(queue2apu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2apu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2apu-got-by-create2kernel4apu: " + str(queue2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2apu-failed-by-create2kernel4apu: " + str(queue2apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2apu ['QUEUE'] = queue2apu

            
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - EXTRA                              
            # ---------------------------------------------------------------------------------------------         
            pipe2apu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2apu-trying-by-create2kernel4apu: " + str(pipe2apu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2apu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2apu-got-by-create2kernel4apu: " + str(pipe2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2apu-failed-by-create2kernel4apu: " + str(pipe2apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2apu ['PIPE'] = pipe2apu 
            
            # ---------------------------------------------------------------------------------------------
            # (8) COMMAND QUEUE INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            commandqueueinfo2apu = {}
           
            message2print = "{(Step 8A/70) trying" + "; commandqueueinfo2apu-trying-by-create2kernel4apu: " + str(commandqueueinfo2apu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                        
            try:
                commandqueueinfo2apu = get2commandqueueinfo4apu()                                                   # SYSTEM CREATES COMMAND QUEUE, IF NECESSARY   
                message2print = "{(Step 8B/70) got" + "; commandqueueinfo2apu-got-by-create2kernel4apu: " + str(commandqueueinfo2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '8B-'  
            except:
                message2print = "{(Step 8Z/70) failed" + "; commandqueueinfo2apu-failed-by-create2kernel4apu: " + str(commandqueueinfo2apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '8Z-'
        
            task4kernel2apu ['COMMANDQUEUE'] = commandqueueinfo2apu
            
            
            
            # ---------------------------------------------------------------------------------------------
            # (9) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            bufferinfo2apu = {}
           
            message2print = "{(Step 9A/70) trying" + "; bufferinfo2apu-trying-by-create2kernel4apu: " + str(bufferinfo2apu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                bufferinfo2apu = get2bufferinfo4apu()                                                               # SYSTEM CREATES BUFFER FOR APU, IF NECESSARY
                message2print = "{(Step 9B/70) got" + "; bufferinfo2apu-got-by-create2kernel4apu: " + str(bufferinfo2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '9B-' 
            except:
                message2print = "{(Step 9Z/70) failed" + "; bufferinfo2apu-failed-by-create2kernel4apu: " + str(bufferinfo2apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '9Z-'
        
            task4kernel2apu ['BUFFER'] = bufferinfo2apu 
            
            # ---------------------------------------------------------------------------------------------
            # (10) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            eventinfo2apu = {}
           
            message2print = "{(Step 10A/70) trying" + "; eventinfo2apu-trying-by-create2kernel4apu: " + str(eventinfo2apu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                eventinfo2apu = get2eventinfo4apu()                                                                 # SYSTEM CREATES EVENT IF NECESSAY   
                message2print = "{(Step 10B/70) got" + "; eventinfo2apu-got-by-create2kernel4apu: " + str(eventinfo2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'DATA2CALLBACK': ... 
                
                code2ack  = code2ack + '10B-' 
            except:
                message2print = "{(Step 10Z/70) failed" + "; eventinfo2apu-failed-by-create2kernel4apu: " + str(eventinfo2apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '10Z-'
        
            task4kernel2apu ['EVENT'] = eventinfo2apu             

            
            task4kernel2apu ['CODE4PY']       = {}                                                                  
            task4kernel2apu ['CODE4CPP']      = {}                                                                  
            task4kernel2apu ['CODE4C']        = {} 
            task4kernel2apu ['CODE4CL']       = {} 
            task4kernel2apu ['CODE4PYC']      = {}                                                                  
            task4kernel2apu ['CODE4BIN']      = {}
 
            task4kernel2apu ['DIRECTORY4PY']     = {}                                                                  
            task4kernel2apu ['DIRECTORY4CPP']    = {}
            task4kernel2apu ['DIRECTORY4C']      = {}
            task4kernel2apu ['DIRECTORY4CL']     = {}
            task4kernel2apu ['DIRECTORY4PYC']    = {}                                                                  
            task4kernel2apu ['DIRECTORY4BIN']    = {}
            task4kernel2apu ['DIRECTORY4SOURCE'] = {}                                                                   
                                               
            # ---------------------------------------------------------------------------------------------
            # (12A0) DIRECTORY4PY - PYTHON                 
            # ---------------------------------------------------------------------------------------------             
            dir2py4apu = folder2lib4apu                                                                                                                                                            
            message2print = "{(Step 12A0/70) set" + "; dir2py4apu-set-by-create2kernel4apu to: " + str(dir2py4apu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4apu 
            code2ack  = code2ack + '12A0-' 
        
            task4kernel2apu ['DIRECTORY4PY'] = dir2py4apu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A0) CODE4PY - PYTHON         
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A0/70) using" + "; DirectoryWalker-using-by-create2kernel4apu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2py4apu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B0/70) examining" + "; directory-examining-by-create2kernel4apu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C0/70) examining" + "; file-examining-by-create2kernel4apu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4apu + apu2sampler4xi5test.py; apu2dummy4xi5test.cpp 
                    
                    message2print = "{(Step 14D0/70) calling" + "; fetch2kernel4apu-calling-by-create2kernel4apu: " + str(fetch2kernel4apu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4apu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E0/70) passing" + "; file2walk-passing-to-fetch2kernel4apu-by-create2kernel4apu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4apu + apu2sampler4xi5test.py; apu2dummy4xi5test.cpp 
                    
                    fetch2kernel4apu(file2walk)                                                                     # FETCHES KERNEL FILES INTO FETCH2CODE4APU DICTIONARY 
                    
                    message2print = "{(Step 14E0/70) performed" + "; fetch2kernel4apu-performed-by-create2kernel4apu: " + str(fetch2kernel4apu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4apu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14F0/70) got" + "; fetch2code4apu-got-by-create2kernel4apu: " + str(fetch2code4apu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # ...  {1: '...profile = "11" />\n', 2: '# --
            
            
                     
            keys2explore4apu = fetch2code4apu.keys()
            message2print = "{(Step 14G0/70) using" + "; keys2explore4apu-using-by-create2kernel4apu: " + str(keys2explore4apu) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)             
            # folder2lib4apu + apu2sampler4xi5test.py; apu2dummy4xi5test.cpp
            
            for key2explore4apu in keys2explore4apu:
                name2program4apu=os.path.splitext(key2explore4apu)                                                  # apu2sampler4xi5test + py
                key2extension4apu = name2program4apu[1]                                                              
                if key2extension4apu == '.py':                          
                    task4kernel2apu ['CODE4PY'] [key2explore4apu] = fetch2code4apu[key2explore4apu]                 # Python code(s)      

            # ---------------------------------------------------------------------------------------------
            # (14H0) SIZE4PY - PYTHON SOURCE            
            # ---------------------------------------------------------------------------------------------                                                
            size2py4apu  = {}
            count2py4apu  = 0
            keys2py4apu = fetch2code4apu.keys()                                                                     # apu2sampler4xi5test.py
            for key2py4apu in keys2py4apu:
                name2program4apu=os.path.splitext(key2py4apu)                                                       # apu2sampler4xi5test + py
                key2extension4apu = name2program4apu[1]                                                             # py   
                if key2extension4apu == '.py':                          
                    size2py4apu[key2py4apu] = len(fetch2code4apu[key2py4apu])                                       # length of saved py code 
                else:
                    pass
          
                                 
            task4kernel2apu ['SIZE4PY'] = size2py4apu
                               
            message2print = "{(Step 14H0/70) set" + "; size2py4apu-set-by-create2kernel4apu to: " + str(size2py4apu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {folder2lib4apu + apu2sampler4xi5test.py': 1337}
            
            code2ack  = code2ack + '14H0-' 
            

            # ---------------------------------------------------------------------------------------------
            # (12A1) C, C++, CL, SOURCE                   
            # ---------------------------------------------------------------------------------------------             
            dir2c4apu = folder2lib4apu                                                                                                                                                            
            message2print = "{(Step 12A1/70) set" + "; dir2c4apu-set-by-create2kernel4apu to: " + str(dir2c4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # folder2lib4apu 
            code2ack  = code2ack + '12A1-' 
        
            task4kernel2apu ['DIRECTORY4C']      = dir2c4apu
            task4kernel2apu ['DIRECTORY4CPP']    = dir2c4apu
            task4kernel2apu ['DIRECTORY4CL']     = dir2c4apu
            task4kernel2apu ['DIRECTORY4SOURCE'] = dir2c4apu

            task4kernel2apu ['CODE4CPP'] = {} 
            task4kernel2apu ['CODE4C']   = {} 
            task4kernel2apu ['CODE4CL']  = {}            
            
            # ---------------------------------------------------------------------------------------------
            # (14A1) C, C++, CL  
            # ---------------------------------------------------------------------------------------------             
            keys2c4apu = fetch2code4apu.keys()
            for key2c4apu in keys2c4apu:
                message2print = "{(Step 14A1/70) set" + "; key2c4apu-set-by-create2kernel4apu to: " + str(key2c4apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)   
                # apu2dummy4xi5test.cpp; apu2sampler4xi5test.py
                
                name2c4apu=os.path.splitext(key2c4apu)                                                  
                key2extension4apu = name2c4apu[1]                                                             # C++, C, CL 
                message2print = "{(Step 14A2/70) set" + "; key2extension4apu-set-by-create2kernel4apu to: " + str(key2extension4apu)  + "; time: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)   
                # .cpp; .py                
                if ((key2extension4apu == '.py') or (key2extension4apu == '.pyc')):
                    pass 
                else:
                    if key2extension4apu == '.cpp': 
                        try:                         
                            task4kernel2apu ['CODE4CPP'] [key2c4apu] = fetch2code4apu[key2c4apu]                     
                            message2print = "{(Step 14G1/70) set" + "; key2c4apu-set-by-create2kernel4apu to: " + str(key2c4apu)  + "; time: " + time4xi() + "}" 
                            print4xi(class2print, method2print, message2print)  
                            # apu2dummy4xi5test.cpp 
                            
                        except:
                            message2print = "{(Step 14Z1/70) failed" + "; key2c4apu-failed-by-create2kernel4apu: " + str(key2c4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)             
                            code2nack  = code2nack + '14Z1-'                    
                        
                    if key2extension4apu == '.c':                          
                        try:
                            task4kernel2apu ['CODE4C'] [key2c4apu] = fetch2code4apu[key2c4apu]                     
                            message2print = "{(Step 14G2/70) set" + "; key2c4apu-set-by-create2kernel4apu to: " + str(key2c4apu)  + "; time: " + time4xi() + "}" 
                            print4xi(class2print, method2print, message2print)  
                            # folder2lib4apu + apu2dummy4xi5test.c
                        except:
                            message2print = "{(Step 14Z2/70) failed" + "; key2c4apu-failed-by-create2kernel4apu: " + str(key2c4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)             
                            code2nack  = code2nack + '14Z2-'                      
                        
                    if key2extension4apu == '.cl':                          
                        try:
                            task4kernel2apu ['CODE4CL'] [key2c4apu] = fetch2code4apu[key2c4apu]                     
                            message2print = "{(Step 14G3/70) set" + "; key2c4apu-set-by-create2kernel4apu to: " + str(key2c4apu)  + "; time: " + time4xi() + "}" 
                            print4xi(class2print, method2print, message2print)  
                            # folder2lib4apu + apu2dummy4xi5test.cl
                        except:
                            message2print = "{(Step 14Z3/70) failed" + "; key2c4apu-failed-by-create2kernel4apu: " + str(key2c4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)             
                            code2nack  = code2nack + '14Z3-'                      
                    
                                                                
            # ----------------------------------------------------------------------------------------------
            # (14H1) SIZE FOR BIN, C, CL, CPP - ALREADY FETCHED           
            # ----------------------------------------------------------------------------------------------                                                
            task4kernel2apu ['SIZE4BIN'] = {}
            task4kernel2apu ['SIZE4C']   = {}
            task4kernel2apu ['SIZE4CL']  = {}
            task4kernel2apu ['SIZE4CPP'] = {}

            keys2c4apu = fetch2code4apu.keys()                                                                # 
            for key2c4apu in keys2c4apu:
                message2print = "{(Step 14H0/70) set" + "; key2c4apu-set-by-create2kernel4apu to: " + str(key2c4apu)  + "; time: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)  
                # apu2dummy4xi5test.cpp
                name2program4apu=os.path.splitext(key2c4apu)                                                  # 
                message2print = "{(Step 14H1/70) set" + "; name2program4apu-set-by-create2kernel4apu to: " + str(name2program4apu)  + "; time: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)  
                # (folder2lib4apu + 'apu2dummy4xi5test', '.cpp')                
                
                key2extension4apu = name2program4apu[1]                                                       #
                message2print = "{(Step 14H2/70) set" + "; key2extension4apu-set-by-create2kernel4apu to: " + str(key2extension4apu)  + "; time: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)  
                # .cpp
                if ((key2extension4apu == '.py') or (key2extension4apu == '.pyc')):
                    pass 
                else:                                 
                    if key2extension4apu == '.exe':
                        try:                          
                            task4kernel2apu ['SIZE4BIN'] [key2c4apu] = len(fetch2code4apu[key2c4apu])                             # length of saved .exe
                            message2print = "{(Step 14H1/70) set" + "; size2type4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['SIZE4BIN'])  + "; time: " + time4xi() + "}" 
                            print4xi(class2print, method2print, message2print)  
                            # 
                            code2ack  = code2ack + '14H1-'
                        except:                                                                                       
                            message2print = "{(Step 14Z1/70) yielded" + "; size2type-yielded-by-create2kernel4apu: " + str(key2c4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)             
                            code2nack  = code2nack + '14Z1-'                             
                    if key2extension4apu == '.c':
                        try:                          
                            task4kernel2apu ['SIZE4C'] [key2c4apu] = len(fetch2code4apu[key2c4apu])                             # length of saved C
                            message2print = "{(Step 14H2/70) set" + "; size2type4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['SIZE4C'])  + "; time: " + time4xi() + "}" 
                            print4xi(class2print, method2print, message2print)  
                            # 
                            code2ack  = code2ack + '14H2-'
                        except:
                            message2print = "{(Step 14Z2/70) yielded" + "; size2type-yielded-by-create2kernel4apu: " + str(key2c4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)             
                            code2nack  = code2nack + '14Z2-'                                                      
                    if key2extension4apu == '.cl':
                        try:                          
                            task4kernel2apu ['SIZE4CL'] [key2c4apu] = len(fetch2code4apu[key2c4apu])                              # length of saved CL
                            message2print = "{(Step 14H3/70) set" + "; size2type4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['SIZE4CL'])  + "; time: " + time4xi() + "}" 
                            print4xi(class2print, method2print, message2print)  
                            # 
                            code2ack  = code2ack + '14H3-'
                        except:
                            message2print = "{(Step 14Z3/70) yielded" + "; size2type-yielded-by-create2kernel4apu: " + str(key2c4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)             
                            code2nack  = code2nack + '14Z3-'                                                      
                    if key2extension4apu == '.cpp':
                        try:                          
                            task4kernel2apu ['SIZE4CPP'] [key2c4apu] = len(fetch2code4apu[key2c4apu])                             # length of saved C++
                            message2print = "{(Step 14H4/70) set" + "; size2type4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['SIZE4CPP'])  + "; time: " + time4xi() + "}" 
                            print4xi(class2print, method2print, message2print)  
                            # 
                            code2ack  = code2ack + '14H4-'                                                                 
                        except:
                            message2print = "{(Step 14Z4/70) yielded" + "; size2type-yielded-by-create2kernel4apu: " + str(key2c4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)             
                            code2nack  = code2nack + '14Z4-'     
         
                                                  
            # ---------------------------------------------------------------------------------------------
            # (12B2) DIRECTORY FOR PYTHON CACHE - REQUIRED                      
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4apu = folder2lib4apu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 12B2/70) set" + "; dir2pycache4apu-set-by-create2kernel4apu to: " + str(dir2pycache4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4apu + '__pycache__//'
            code2ack  = code2ack + '12B2-' 
        
            task4kernel2apu ['DIRECTORY4PYC'] = dir2pycache4apu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A2) CODE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A2/70) using" + "; DirectoryWalker-using-by-create2kernel4apu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2pycache4apu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B2/70) examining" + "; directory-examining-by-create2kernel4apu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C2/70) examining" + "; file-examining-by-create2kernel4apu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4apu + __pycache__//apu2sampler4xi5test.cpython-33.pyc
                    
                    message2print = "{(Step 14D2/70) calling" + "; fetch2kernel4apu-calling-by-create2kernel4apu: " + str(fetch2kernel4apu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4apu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E2/70) passing" + "; file2walk-passing-to-fetch2kernel4apu-by-create2kernel4apu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4apu + __pycache__//apu2sampler4xi5test.cpython-33.pyc
                    
                    fetch2kernel4apu(file2walk)                                                                     # fetches kernel files into fetch2code4apu dictionary 
                    
                    message2print = "{(Step 14F2/70) performed" + "; fetch2kernel4apu-performed-by-create2kernel4apu: " + str(fetch2kernel4apu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4apu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14G2/70) got" + "; fetch2code4apu-got-by-create2kernel4apu: " + str(fetch2code4apu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # 
            
            task4kernel2apu ['CODE4PYC'] = {}
            keys2pyc4apu = fetch2code4apu.keys()
            for key2pyc4apu in keys2pyc4apu:
                name2program4apu=os.path.splitext(key2pyc4apu)                                                      # apu2sampler4xi5test.cpython-33.pyc
                key2extension4apu = name2program4apu[1]                                                             # pyc 
   
                if key2extension4apu == '.pyc':                          
                    task4kernel2apu ['CODE4PYC'] [key2pyc4apu] = fetch2code4apu[key2pyc4apu]                        # binary code(s)
                    message2print = "{(Step 14H2/70) set" + "; key2pyc4apu-set-by-create2kernel4apu to: " + str(key2pyc4apu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    #    
                                     
            size2pyc4apu  = {}

            for key2pyc4apu in keys2pyc4apu:
                name2program4apu=os.path.splitext(key2pyc4apu)                                                      # apu2sampler4xi5test.cpython-32 + pyc
                key2extension4apu = name2program4apu[1]                                                             # pyc 
                if key2extension4apu == '.pyc':                          
                    size2pyc4apu[key2pyc4apu] = len(fetch2code4apu[key2pyc4apu])                                    # length of saved binary code
                    message2print = "{(Step 14I2/70) set" + "; key2pyc4apu-set-by-create2kernel4apu to: " + str(key2pyc4apu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # 
                                              
            # ---------------------------------------------------------------------------------------------
            # (14I2) SIZE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2apu ['SIZE4PYC'] = size2pyc4apu
                               
            message2print = "{(Step 14J2/70) set" + "; size2pyc4apu-set-by-create2kernel4apu to: " + str(size2pyc4apu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 
            code2ack  = code2ack + '14J2-' 

                                               
            # ---------------------------------------------------------------------------------------------
            # (12A3) DIRECTORY FOR C++, C, CL BIN - REQUIRED                    
            # ---------------------------------------------------------------------------------------------             
            dir2bin4apu = folder2lib4apu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4apu-set-by-create2kernel4apu to: " + str(dir2bin4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4apu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2apu ['DIRECTORY4BIN'] = dir2bin4apu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A3) CODE4BIN FOR C++, C, CL - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A3/70) using" + "; DirectoryWalker-using-by-create2kernel4apu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2bin4apu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B3/70) examining" + "; directory-examining-by-create2kernel4apu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C3/70) examining" + "; file-examining-by-create2kernel4apu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4apu + bin//apu2dummy4xi5test.exe
                    
                    message2print = "{(Step 14D3/70) calling" + "; fetch2kernel4apu-calling-by-create2kernel4apu: " + str(fetch2kernel4apu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4apu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E3/70) passing" + "; file2walk-passing-to-fetch2kernel4apu-by-create2kernel4apu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4apu + bin//apu2dummy4xi5test.exe
                    
                    fetch2kernel4apu(file2walk)                                                                     # fetches kernel files into fetch2code4apu dictionary 
                    
                    message2print = "{(Step 14E3/70) performed" + "; fetch2kernel4apu-performed-by-create2kernel4apu: " + str(fetch2kernel4apu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4apu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14F3/70) got" + "; fetch2code4apu-got-by-create2kernel4apu: " + str(fetch2code4apu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # 

            task4kernel2apu ['CODE4BIN'] = {}
            
            keys2bin4apu = fetch2code4apu.keys()
            message2print = "{(Step 14G3/70) using" + "; keys2bin4apu-using-by-create2kernel4apu: " + str(keys2bin4apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4apu + 'apu2dummy4xi5test.cpp', 'apu2sampler4xi5test.py']
            
            for key2bin4apu in keys2bin4apu:
                name2program4apu=os.path.splitext(key2bin4apu)                                                      # apu2dummy4xi5test.exe
                key2extension4apu = name2program4apu[1]                                                             # bin 
   
                if key2extension4apu == '.exe':                          
                    task4kernel2apu ['CODE4BIN'] [key2bin4apu] = fetch2code4apu[key2bin4apu]                        # binary code(s)   
                                        
            size2bin4apu  = {}
            keys2bin4apu = fetch2code4apu.keys()                                                                    # apu2dummy4xi5test.exe
            for key2bin4apu in keys2bin4apu:
                name2program4apu=os.path.splitext(key2bin4apu)                                                      # apu2sampler4xi5test.cpython-32 + bin
                key2extension4apu = name2program4apu[1]                                                             # bin 
                if key2extension4apu == '.exe':                          
                    size2bin4apu[key2bin4apu] = len(fetch2code4apu[key2bin4apu])                                    # length of saved binary code
                        
            # ---------------------------------------------------------------------------------------------
            # (14H3) SIZE4BIN - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2apu ['SIZE4BIN'] = size2bin4apu
                               
            message2print = "{(Step 14H3/70) set" + "; size2bin4apu-set-by-create2kernel4apu to: " + str(size2bin4apu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {}
            code2ack  = code2ack + '14H3-' 

            # ---------------------------------------------------------------------------------------------
            # (14J) COUNT4PY, COUNT4CPP, COUNT4C,COUNT4CL, COUNT4PYC, COUNT4BIN, COUNT4SOURCE                
            # ---------------------------------------------------------------------------------------------             
            task4kernel2apu ['COUNT4PY']     = 0
            task4kernel2apu ['COUNT4CPP']    = 0
            task4kernel2apu ['COUNT4C']      = 0
            task4kernel2apu ['COUNT4CL']     = 0
            task4kernel2apu ['COUNT4PYC']    = 0
            task4kernel2apu ['COUNT4BIN']    = 0
            task4kernel2apu ['COUNT4SOURCE'] = 0

            keys2code4apu = fetch2code4apu.keys()
            message2print = "{(Step 14J/70) using" + "; keys2code4apu-using-by-create2kernel4apu: " + str(keys2code4apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4apu + 'apu2dummy4xi5test.cpp', folder2lib4apu + 'apu2sampler4xi5test.py']

            
            for key2code4apu in keys2code4apu:
                name2program4apu=os.path.splitext(key2code4apu)                                                    
                key2extension4apu = name2program4apu[1]                                                             
                if key2extension4apu == '.py':                          
                    task4kernel2apu ['COUNT4PY']     = task4kernel2apu ['COUNT4PY']  + 1 
                    task4kernel2apu ['COUNT4SOURCE'] = task4kernel2apu ['COUNT4SOURCE'] + 1
                     
                if key2extension4apu == '.cpp':                          
                    task4kernel2apu ['COUNT4CPP']    = task4kernel2apu ['COUNT4CPP'] + 1
                    task4kernel2apu ['COUNT4SOURCE'] = task4kernel2apu ['COUNT4SOURCE'] + 1
                                                                 
                if key2extension4apu == '.c':                          
                    task4kernel2apu ['COUNT4C']      = task4kernel2apu ['COUNT4C']   + 1    
                    task4kernel2apu ['COUNT4SOURCE'] = task4kernel2apu ['COUNT4SOURCE'] + 1
                               
                if key2extension4apu == '.cl':                          
                    task4kernel2apu ['COUNT4CL']     = task4kernel2apu ['COUNT4CL']  + 1    
                    task4kernel2apu ['COUNT4SOURCE'] = task4kernel2apu ['COUNT4SOURCE'] + 1 
                                                  
                if key2extension4apu == '.pyc':                          
                    task4kernel2apu ['COUNT4PYC']    = task4kernel2apu ['COUNT4PYC'] + 1 
                                               
                if key2extension4apu == '.exe':                          
                    task4kernel2apu ['COUNT4BIN']    = task4kernel2apu ['COUNT4BIN'] + 1                                                                                 
            
            message2print = "{(Step 14K/70) set" + "; count4py-set-by-create2kernel4apu to: " + str(task4kernel2apu ['COUNT4PY'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            
            message2print = "{(Step 14L/70) set" + "; count4cpp-set-by-create2kernel4apu to: " + str(task4kernel2apu ['COUNT4CPP'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            message2print = "{(Step 14M/70) set" + "; count4c-set-by-create2kernel4apu to: " + str(task4kernel2apu ['COUNT4C'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0 
            message2print = "{(Step 14N/70) set" + "; count4cl-set-by-create2kernel4apu to: " + str(task4kernel2apu ['COUNT4CL'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                         
            
            message2print = "{(Step 14M/70) set" + "; count4pyc-set-by-create2kernel4apu to: " + str(task4kernel2apu ['COUNT4PYC'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0
            
            message2print = "{(Step 14N/70) set" + "; count4bin-set-by-create2kernel4apu to: " + str(task4kernel2apu ['COUNT4BIN'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0
            
            message2print = "{(Step 14O/70) set" + "; count2source4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['COUNT4SOURCE'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 2                                                             
            code2ack  = code2ack + '14O-'
            
            # ---------------------------------------------------------------------------------------------
            # (15) LANGUAGE - EXTRA                             
            # ---------------------------------------------------------------------------------------------             
            task4kernel2apu ['LANGUAGE'] = {}
            
            for key2code4apu in keys2code4apu:
                name2program4apu=os.path.splitext(key2code4apu)                                                     
                key2extension4apu = name2program4apu[1]                                                             
                if key2extension4apu == '.py':                          
                    task4kernel2apu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4apu == '.cpp':                          
                    task4kernel2apu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4apu == '.c':                          
                    task4kernel2apu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4apu == '.cl':                          
                    task4kernel2apu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '15B-' 
                      
            # ---------------------------------------------------------------------------------------------
            # (16) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            count2reference2apu  = 1
           
            message2print = "{(Step 16B/70) set" + "; count2reference2apu-set-by-create2kernel4apu to: " + str(count2reference2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '16B-' 
        
            task4kernel2apu ['COUNT2REFERENCE'] = count2reference2apu                                 
                                    
            # ---------------------------------------------------------------------------------------------
            # (17) PROGRAM - REQUIRED                           
            # ---------------------------------------------------------------------------------------------             
            task4kernel2apu ['PROGRAM'] = None
            message2print = "{(Step 17A/70) try" + "; program2apu-try-by-create2kernel4apu: " + str(task4kernel2apu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2apu ['PROGRAM'] = create2programwithsource4apu()
                keys2program = task4kernel2apu ['PROGRAM'].keys()
                
                message2print = "{(Step 17B/70) set" + "; program-set-by-create2kernel4apu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'COUNT2REFERENCE', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '17B-'
            except:
                message2print = "{(Step 17Z1/70) failed" + "; task4kernel2apu-failed-by-create2kernel4apu: " + str(task4kernel2apu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '17Z-'
                                    
            # ---------------------------------------------------------------------------------------------
            # (18) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2apu ['FUNCTION'] = {}
            message2print = "{(Step 18A0/70) set" + "; function4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2apu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 18A1/70) set" + "; pythonfunction4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4apu  = kb2kernel4apu ['.py'] ['TAG']
            message2print = "{(Step 18A2/70) using" + "; tag2search4apu-using-by-create2kernel4apu: " + str(tag2search4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4apu    = kb2kernel4apu ['.py'] ['VALUE']
            message2print = "{(Step 18A3/70) using" + "; value2search4apu-using-by-create2kernel4apu: " + str(value2search4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # apu2sampler4xi5test
            
            attribute2search4apu= kb2kernel4apu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 18A4/70) using" + "; attribute2search4apu-using-by-create2kernel4apu: " + str(attribute2search4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4apu in keys2code4apu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'] [key2code4apu]
                    keys2line4apu = code2examine4apu.keys()
                    for key2line4apu in keys2line4apu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'] [key2code4apu] [key2line4apu]
                        # message2print = "{(Step 18A5/70) examining" + "; line2examine4apu-examining-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4apu,tag2search4apu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 18B/70) examining" + "; line2function4apu-examining-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # <... apu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4apu,value2search4apu)
                            if index2function == -1:
                                message2print = "{(Step 18C/70) skipped" + "; line2function4apu-skipped-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # <... set2trace4sampler" ... # ...function = "apu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4apu,attribute2search4apu)             # ...function = "apu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 18D/70) warning" + "; line2function4apu-warning-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 18E/70) accepted" + "; line2examine4apu-accepted-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ...function = "apu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4apu = line2examine4apu[index2function:index2usage-2]
                                    
                                    task4kernel2apu ['FUNCTION'] ['.py'] [key2pythonfunction4apu] = {}                                  

                                    message2print = "{(Step 18F/70) used" + "; key2pythonfunction4apu-used-by-create2kernel4apu: " + str(key2pythonfunction4apu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # apu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '18F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 18Z1/70) failed" + "; task4kernel2apu-failed-by-create2kernel4apu: " + str(task4kernel2apu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '18Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (19) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2apu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 19A0F/70) set" + "; cplusfunction4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4apu      = kb2kernel4apu ['.cpp'] ['TAG']
            message2print = "{(Step 19A2/70) using" + "; tag2search4apu-using-by-create2kernel4apu: " + str(tag2search4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <...            
            attribute2search4apu= kb2kernel4apu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 19A4/70) using" + "; attribute2search4apu-using-by-create2kernel4apu: " + str(attribute2search4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4apu in keys2code4apu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'] [key2code4apu]
                    message2print = "{(Step 19A5/70) using" + "; key2code4apu-using-by-create2kernel4apu: " + str(key2code4apu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # apu2dummy4xi5test.cpp
                       
                    keys2line4apu = code2examine4apu.keys()
                    # message2print = "{(Step 19A6/70) using" + "; keys2line4apu-using-by-create2kernel4apu: " + str(keys2line4apu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4apu in keys2line4apu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'] [key2code4apu] [key2line4apu]
                        # message2print = "{(Step 19A7/70) examining" + "; line2examine4apu-examining-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # /*<... nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4apu,tag2search4apu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 19B1/70) examining" + "; line2function4apu-examining-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # ... function = "OCLError" usage = "error code checking"*/
                            # ... function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 19B2/70) using" + "; attribute2search4apu-using-by-create2kernel4apu: " + str(attribute2search4apu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4apu,attribute2search4apu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 19C/70) skipped" + "; line2function4apu-skipped-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 19E/70) accepted" + "; line2examine4apu-accepted-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "nbody_kern" usage = "kernel example 1"*/; 
                                # ... function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4apu = line2examine4apu[27:index2usage-2]  
                                task4kernel2apu ['FUNCTION'] ['.cpp'] [key2kernelfunction4apu] =  {}                                       

                                message2print = "{(Step 19F/70) used" + "; key2kernelfunction4apu-used-by-create2kernel4apu: " + str(key2kernelfunction4apu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '19F-'
                                    
                                    
            except:
                message2print = "{(Step 19Z1/70) failed" + "; task4kernel2apu-failed-by-create2kernel4apu: " + str(task4kernel2apu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #   
                #             
                code2nack  = code2nack + '19Z-'           
                                                      
            # ---------------------------------------------------------------------------------------------
            # EOF CREATING TASK4KERNEL2APU                  
            # ---------------------------------------------------------------------------------------------                                                                                                                                                          
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernel2apu-yielded-by-create2kernel4apu: " + str(task4kernel2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-' 

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4kernel2apu.keys()        
    message2print = "{(Step 19A/70) using" + "; keys2task-using-by-create2kernel4apu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    #1 this program created:
    # ['BUFFER'  ... 'LANGUAGE', 'PIPE', 
    #  'PLATFORM', 'PROGRAM', 'QUEUE' ....']
    #2 caller passed:
    # ['FUNCTION', 'PROGRAM']
    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - CREATE PROGRAM OBJECT FOR APU - BUILD REQUIRED ONES IF USER HAS FORGOTTEN ! 
    # ---------------------------------------------------------------------------------------------    
    apu2kernel4xi = {}                                                                                             # CREATE INITIALIZES DICTIONARY!                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; apu2kernel4xi-initialized-by-create2kernel4apu to: " + str(apu2kernel4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    if (('DATA2CALLBACK' not in keys2task) or ('FUNCTION2CALLBACK' not in keys2task)):
        try:            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - REQUIRED                
            # ---------------------------------------------------------------------------------------------
                     
            function2callback4apu = trace2kernel4apu                                                                # CALLBACK FUNCTION FOR APU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4apu-created-by-create2kernel4apu: " + str(function2callback4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4apu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4apu"                                                          # MODULE OF DRAGONIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4apu"                                                          # FUNCTION OF DRAGONIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4apu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR DRAGONIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4apu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4apu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4apu',
            #  'METHOD': 'create2kernel4apu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2apu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO DRAGONIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2apu['FUNCTION2CALLBACK'] = function2callback4apu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2apu-created-by-create2kernel4apu: " + str(task4kernel2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4apu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4apu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4apu',
            #  'METHOD': 'create2kernel4apu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}
        except: 
            message2print = "{(Step 1Z2/70) yielded" + "; callbacks-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'     
                
    if 'DATA2CALLBACK' in keys2task:
        message2print = "{(Step 21A0/70) try" + "; data2callback-try-by-create2kernel4apu: {}" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21A/70) - DATA2CALLBACK - REQUIRED 
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['DATA2CALLBACK'] = task4kernel2apu['DATA2CALLBACK']
            
            message2print = "{(Step 21A1/70) initialized" + "; data2callback-created-by-create2kernel4apu: " + str(apu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4apu-failed ; time: 04:42:53 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4apu',
            #  'METHOD': 'create2kernel4apu'}
    
            code2ack  = code2ack + '21A1-'
        except: 
            message2print = "{(Step 21Z1/70) yielded" + "; data2callback-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '21Z1-'
    
    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22B/70) - FUNCTION2CALLBACK - REQUIRED
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['FUNCTION2CALLBACK'] = task4kernel2apu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 22B1/70) initialized" + "; function2callback-created-by-create2kernel4apu: " + str(apu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2kernel4apu at 0x000000000422F6C8>
            
            code2ack  = code2ack + '22B1-'
        except: 
            message2print = "{(Step 22Z2/70) yielded" + "; function2callback-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z2-' 
        
        message2print = "{(Step 22C0/70) try" + "; platform-try-by-create2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #

        
    if 'PLATFORM' in keys2task:         
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22C/70) - PLATFORM - EXTRA
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['PLATFORM'] = task4kernel2apu['PLATFORM']
            
            message2print = "{(Step 22C1/70) initialized" + "; platform-created-by-create2kernel4apu: " + str(apu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    
    
            code2ack  = code2ack + '22C1-'
        except: 
            message2print = "{(Step 22Z3/70) yielded" + "; platform-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z3-' 
            
    
    if 'CONTEXT' in keys2task:        
        message2print = "{(Step 23A/70) try" + "; context2apu-try-by-create2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 23/70) - CONTEXT  - EXTRA
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['CONTEXT'] = task4kernel2apu['CONTEXT']
            
            message2print = "{(Step 23B/70) initialized" + "; context-created-by-create2kernel4apu: " + str(apu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...      
            
            code2ack  = code2ack + '23B-'
        except: 
            message2print = "{(Step 23Z1/70) yielded" + "; context-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        
            code2nack  = code2nack + '23Z1-' 
    
    if 'DEVICE' in keys2task:        
        message2print = "{(Step 24A/70) try" + "; device-try-by-create2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 24/70) - DEVICE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['DEVICE'] = task4kernel2apu['DEVICE']
            
            message2print = "{(Step 24B/70) initialized" + "; device-created-by-create2kernel4apu: " + str(apu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
            
            code2ack  = code2ack + '24B-'
        except: 
            message2print = "{(Step 24Z1/70) yielded" + "; device-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '24Z1-'
    
    if 'CODE2ERROR' in keys2task:                     
        message2print = "{(Step 25A/70) try" + "; code2error-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 25/70) - ERROR CODE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['CODE2ERROR'] = task4kernel2apu['CODE2ERROR']
            
            message2print = "{(Step 25B/70) initialized" + "; code2error-created-by-create2kernel4apu: " + str(apu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '25B-'
        except: 
            message2print = "{(Step 25Z1/70) yielded" + "; code2error-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '25Z1-'
                            
    if 'QUEUE' not in keys2task: 
        try:
            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - REQUIRED                          
            # ---------------------------------------------------------------------------------------------         
            queue2apu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2apu-trying-by-create2kernel4apu: " + str(queue2apu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2apu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2apu-got-by-create2kernel4apu: " + str(queue2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2apu-failed-by-create2kernel4apu: " + str(queue2apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2apu ['QUEUE'] = queue2apu
        except:
            message2print = "{(Step 26Z1/70) yielded" + "; queue-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z1-'             

    if 'QUEUE' in keys2task:          
        message2print = "{(Step 26A/70) try" + "; queue-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 26/70) - QUEUE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['QUEUE'] = task4kernel2apu['QUEUE']
            
            message2print = "{(Step 26B/70) initialized" + "; queue-created-by-create2kernel4apu: " + str(apu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <queue4xi.Queue4Xi object at 0x0000000003E72828> 
            
            code2ack  = code2ack + '26B-'
        except: 
            message2print = "{(Step 26Z2/70) yielded" + "; queue-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z2-' 
              
    if 'PIPE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------         
            pipe2apu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2apu-trying-by-create2kernel4apu: " + str(pipe2apu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2apu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2apu-got-by-create2kernel4apu: " + str(pipe2apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2apu-failed-by-create2kernel4apu: " + str(pipe2apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2apu ['PIPE'] = pipe2apu 
        except: 
            message2print = "{(Step 27Z1/70) yielded" + "; pipe-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z1-'
                                 
    if 'PIPE' in keys2task:                                
        message2print = "{(Step 27A/70) try" + "; pipe-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 27/70) - PIPE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['PIPE'] = task4kernel2apu['PIPE']
            
            message2print = "{(Step 27B/70) initialized" + "; pipe-created-by-create2kernel4apu: " + str(apu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
            
            code2ack  = code2ack + '27B-'
        except: 
            message2print = "{(Step 27Z2/70) yielded" + "; pipe-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z2-' 

    if 'COMMANDQUEUE' in keys2task:
        message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-create2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (28) COMMAND QUEUE - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['COMMANDQUEUE']  = task4kernel2apu['COMMANDQUEUE']  
     
            message2print = "{(Step 28B/70) initialized" + "; commandqueue-created-by-create2kernel4apu: " + str(apu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                    
            code2ack  = code2ack + '28B-'
        except: 
            message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
                  
            code2nack  = code2nack + '28Z1-'    
    
    if 'BUFFER' in keys2task:
        message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-create2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (29) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['BUFFER']  = task4kernel2apu['BUFFER']  
     
            message2print = "{(Step 29B/70) initialized" + "; bufferinfo-created-by-create2kernel4apu: " + str(apu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
            
            
            code2ack  = code2ack + '29B-'
        except: 
            message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '29Z1-'            
    
    if 'EVENT' in keys2task:
        message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-create2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (30) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['EVENT']  = task4kernel2apu['EVENT']  
     
            message2print = "{(Step 30B/70) initialized" + "; eventinfo-created-by-create2kernel4apu: " + str(apu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'DATA2CALLBACK' ... 
            
            code2ack  = code2ack + '30B-'
        except: 
            message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '30Z1-'
                        
    
    if 'COUNT4PY' in keys2task:               
        message2print = "{(Step 31A1/70) try" + "; count2py4apu-try-by-create2kernel4apu: " + str(task4kernel2apu['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PY - REQUIRED                     
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4PY']  = task4kernel2apu['COUNT4PY']  
    
            message2print = "{(Step 31A2/70) initialized" + "; count2py4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31A2-'
        except: 
            message2print = "{(Step 31Z1/70) yielded" + "; count2py4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z1-'     
    
    if 'COUNT4CPP' in keys2task:               
        message2print = "{(Step 31B1/70) try" + "; count2cpp4apu-try-by-create2kernel4apu: " + str(task4kernel2apu['COUNT4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CPP - REQUIRED                      
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4CPP']  = task4kernel2apu['COUNT4CPP']  
    
            message2print = "{(Step 31B2/70) initialized" + "; count2cpp4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['COUNT4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31B2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cpp4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
            
    
    if 'COUNT4C' in keys2task:               
        message2print = "{(Step 31C1/70) try" + "; count2c4apu-try-by-create2kernel4apu: " + str(task4kernel2apu['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4C - REQUIRED                    
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4C']  = task4kernel2apu['COUNT4C']  
    
            message2print = "{(Step 31C2/70) initialized" + "; count2c4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31C2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2c4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
    
    if 'COUNT4CL' in keys2task:               
        message2print = "{(Step 31D1/70) try" + "; count2cl4apu-try-by-create2kernel4apu: " + str(task4kernel2apu['COUNT4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CL - REQUIRED                   
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4CL']  = task4kernel2apu['COUNT4CL']  
    
            message2print = "{(Step 31D2/70) initialized" + "; count2cl4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['COUNT4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31D2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cl4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
                
    if 'COUNT4PYC' in keys2task:               
        message2print = "{(Step 31E1/70) try" + "; count4pyc-try-by-create2kernel4apu: " + str(task4kernel2apu['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PYC - REQUIRED                   
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4PYC']  = task4kernel2apu['COUNT4PYC']  
    
            message2print = "{(Step 31E2/70) initialized" + "; count4pyc-created-by-create2kernel4apu: " + str(apu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '31E2-'
        except: 
            message2print = "{(Step 31Z4/70) yielded" + "; count4pyc-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z4-'     
    
    if 'COUNT4BIN' in keys2task:               
        message2print = "{(Step 31F1/70) try" + "; count4bin-try-by-create2kernel4apu: " + str(task4kernel2apu['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4BIN - REQUIRED                   
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4BIN']  = task4kernel2apu['COUNT4BIN']  
    
            message2print = "{(Step 31F2/70) initialized" + "; count4bin-created-by-create2kernel4apu: " + str(apu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 0
            code2ack  = code2ack + '31F2-'
        except: 
            message2print = "{(Step 31Z5/70) yielded" + "; count4bin-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z5-' 
    
    if 'COUNT4SOURCE' in keys2task:               
        message2print = "{(Step 31G1/70) try" + "; count2source4apu-try-by-create2kernel4apu: " + str(task4kernel2apu['COUNT4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4SOURCE - REQUIRED                   
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4SOURCE']  = task4kernel2apu['COUNT4SOURCE']  
    
            message2print = "{(Step 31G2/70) initialized" + "; count2source4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['COUNT4SOURCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 2 
            code2ack  = code2ack + '31G2-'
        except: 
            message2print = "{(Step 31Z5/70) yielded" + "; count2source4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z5-' 
                                        
    if 'DIRECTORY4PY' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A) DIRECTORY4PY - CREATE!                
            # ---------------------------------------------------------------------------------------------             
            dir2py4apu = folder2lib4apu                                                                                                                                                            
            message2print = "{(Step 32A/70) set" + "; dir2py4apu-set-by-create2kernel4apu to: " + str(dir2py4apu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4apu 
            code2ack  = code2ack + '32A-' 
        
            task4kernel2apu ['DIRECTORY4PY'] = dir2py4apu
        except: 
            message2print = "{(Step 32AZ/70) yielded" + "; directory4py-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32AZ-'                         
               
    if 'DIRECTORY4PY' in keys2task:
        message2print = "{(Step 32A1/70) try" + "; directory4py-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PY - CREATE!                   
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['DIRECTORY4PY']  = task4kernel2apu['DIRECTORY4PY']  
     
            message2print = "{(Step 32B1/70) initialized" + "; directory2py4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4apu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z1/70) yielded" + "; directory2py4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CPP' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CPP - CREATE!                
            # ---------------------------------------------------------------------------------------------             
            dir2cpp4apu = folder2lib4apu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cpp4apu-set-by-create2kernel4apu to: " + str(dir2cpp4apu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4apu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2apu ['DIRECTORY4CPP'] = dir2cpp4apu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CPP' in keys2task:
        message2print = "{(Step 32A2/70) try" + "; directory2cpp4apu-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CPP - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['DIRECTORY4CPP']  = task4kernel2apu['DIRECTORY4CPP']  
     
            message2print = "{(Step 32B2/70) initialized" + "; directory2cpp4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4apu
            code2ack  = code2ack + '32B2-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2cpp4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
                         
    if 'DIRECTORY4C' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4C - CREATE!             
            # ---------------------------------------------------------------------------------------------             
            dir2c4apu = folder2lib4apu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2c4apu-set-by-create2kernel4apu to: " + str(dir2c4apu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4apu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2apu ['DIRECTORY4C'] = dir2c4apu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4C' in keys2task:
        message2print = "{(Step 32A3/70) try" + "; directory2c4apu-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4C - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['DIRECTORY4C']  = task4kernel2apu['DIRECTORY4C']  
     
            message2print = "{(Step 32B3/70) initialized" + "; directory2c4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['DIRECTORY4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4apu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2c4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CL' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CL - CREATE!            
            # ---------------------------------------------------------------------------------------------             
            dir2cl4apu = folder2lib4apu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cl4apu-set-by-create2kernel4apu to: " + str(dir2cl4apu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4apu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2apu ['DIRECTORY4CL'] = dir2cl4apu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CL' in keys2task:
        message2print = "{(Step 32A4/70) try" + "; directory2cl4apu-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CL - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['DIRECTORY4CL']  = task4kernel2apu['DIRECTORY4CL']  
     
            message2print = "{(Step 32B4/70) initialized" + "; directory2cl4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['DIRECTORY4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4apu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z4/70) yielded" + "; directory2cl4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-'
                                        
    if 'DIRECTORY4SOURCE' in keys2task:
        message2print = "{(Step 32A5/70) try" + "; directory2source4apu-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4SOURCE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['DIRECTORY4SOURCE']  = task4kernel2apu['DIRECTORY4SOURCE']  
     
            message2print = "{(Step 32B5/70) initialized" + "; directory2source4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['DIRECTORY4SOURCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4apu
            code2ack  = code2ack + '32B5-'
        except: 
            message2print = "{(Step 32Z5/70) yielded" + "; directory2source4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z5-'
                          
    if 'DIRECTORY4PYC' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4PYC - CREATE!               
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4apu = folder2lib4apu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 32B2/70) set" + "; dir2pycache4apu-set-by-create2kernel4apu to: " + str(dir2pycache4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4apu + '__pycache__//'
            code2ack  = code2ack + '32B2-' 
        
            task4kernel2apu ['DIRECTORY4PYC'] = dir2pycache4apu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'                     
                                                    
    if 'DIRECTORY4PYC' in keys2task:
        message2print = "{(Step 32C/70) try" + "; directory2pyc4apu-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PYC - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['DIRECTORY4PYC']  = task4kernel2apu['DIRECTORY4PYC']  
     
            message2print = "{(Step 32D/70) initialized" + "; directory2pyc4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4apu + __pycache__//
            code2ack  = code2ack + '32D-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z2-' 
             
    if 'DIRECTORY4BIN' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4BIN - CREATE!               
            # ---------------------------------------------------------------------------------------------             
            dir2bin4apu = folder2lib4apu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4apu-set-by-create2kernel4apu to: " + str(dir2bin4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4apu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2apu ['DIRECTORY4BIN'] = dir2bin4apu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4bin-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-' 
                                        
    if 'DIRECTORY4BIN' in keys2task:
        message2print = "{(Step 32E/70) try" + "; directory2bin4apu-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4BIN - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['DIRECTORY4BIN']  = task4kernel2apu['DIRECTORY4BIN']  
     
            message2print = "{(Step 32F/70) initialized" + "; directory2bin4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4apu + bin//
            code2ack  = code2ack + '32F-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2bin4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z3-'  
    
                     
    if 'CODE4PY' in keys2task:            
        message2print = "{(Step 33A1/70) try" + "; code2py4aputask-try-by-create2kernel4apu: " + str(task4kernel2apu ['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4apu + 'apu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: ...
        
        apu2kernel4xi['CODE4PY'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PY - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['CODE4PY'] = task4kernel2apu ['CODE4PY']
    
     
            message2print = "{(Step 33B1/70) created" + "; code2py4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 'apu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2:
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z1/70) yielded" + "; code2py4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi['CODE4PY']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '33Z1-'     
                     
    if 'CODE4CPP' in keys2task:            
        message2print = "{(Step 33A2/70) try" + "; code2cpp4aputask-try-by-create2kernel4apu: " + str(len(task4kernel2apu ['CODE4CPP']))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4apu +  apu2dummy4xi5test.cpp
        
        apu2kernel4xi['CODE4CPP'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CPP - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['CODE4CPP'] = task4kernel2apu ['CODE4CPP']
    
     
            message2print = "{(Step 33B2/70) created" + "; code2cpp4apu-created-by-create2kernel4apu: " + str(len(apu2kernel4xi['CODE4CPP']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + apu2dummy4xi5test.cpp
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2cpp4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi['CODE4CPP']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cpp4apu2nack  = code2cpp4apu2nack + '33Z2-'     
                     
    if 'CODE4C' in keys2task:            
        message2print = "{(Step 33A3/70) try" + "; code2c4aputask-try-by-create2kernel4apu: " + str(task4kernel2apu ['CODE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4apu + 
        
        apu2kernel4xi['CODE4C'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4C - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['CODE4C'] = task4kernel2apu ['CODE4C']
    
     
            message2print = "{(Step 33B3/70) created" + "; code2c4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['CODE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2c4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi['CODE4C']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '33Z3-'                             
                     
    if 'CODE4CL' in keys2task:            
        message2print = "{(Step 33A4/70) try" + "; code2cl4aputask-try-by-create2kernel4apu: " + str(task4kernel2apu ['CODE4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4apu + 
        
        apu2kernel4xi['CODE4CL'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CL - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['CODE4CL'] = task4kernel2apu ['CODE4CL']
    
     
            message2print = "{(Step 33B4/70) created" + "; code2cl4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['CODE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z4/70) yielded" + "; code2cl4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi['CODE4CL']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cl4apu2nack  = code2cl4apu2nack + '33Z1-'     
                                        
    if 'CODE4PYC' in keys2task:            
        message2print = "{(Step 33C/70) try" + "; code2pyc4apu-try-by-create2kernel4apu: " + str(task4kernel2apu ['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4apu + 
        
        apu2kernel4xi['CODE4PYC'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['CODE4PYC'] = task4kernel2apu ['CODE4PYC']
    
     
            message2print = "{(Step 33D/70) created" + "; code2pyc4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 
             
            code2ack  = code2ack + '33D-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2pyc4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi['CODE4PYC']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '33Z2-'     
                            
    if 'CODE4BIN' in keys2task:            
        message2print = "{(Step 33E/70) try" + "; code2bin4apu2bin4apu-try-by-create2kernel4apu: " + str(task4kernel2apu ['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4apu + 
        
        apu2kernel4xi['CODE4BIN'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['CODE4BIN'] = task4kernel2apu ['CODE4BIN']
    
     
            message2print = "{(Step 33F/70) created" + "; code2bin4apu-created-by-create2kernel4apu: " + str(apu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 
             
            code2ack  = code2ack + '33F-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2bin4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi['CODE4BIN']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '33Z3-'     
            
    if 'SIZE4PY' in keys2task:        
        message2print = "{(Step 34A1/70) try" + "; size2py4apu-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['SIZE4PY']  = task4kernel2apu['SIZE4PY']  
     
            message2print = "{(Step 34B1/70) initialized" + "; size2py4apu-initialized-by-create2kernel4apu to: " + str(apu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 'apu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z1/70) yielded" + "; size2py4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
            
    if 'SIZE4CPP' in keys2task:        
        message2print = "{(Step 34A2/70) try" + "; size2cpp4apu-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['SIZE4CPP']  = task4kernel2apu['SIZE4CPP']  
     
            message2print = "{(Step 34B2/70) initialized" + "; size2cpp4apu-initialized-by-create2kernel4apu to: " + str(apu2kernel4xi['SIZE4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + apu2dummy4xi5test.cpp': 333}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z2/70) yielded" + "; size2cpp4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4C' in keys2task:        
        message2print = "{(Step 34A3/70) try" + "; size2c4apu-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['SIZE4C']  = task4kernel2apu['SIZE4C']  
     
            message2print = "{(Step 34B3/70) initialized" + "; size2c4apu-initialized-by-create2kernel4apu to: " + str(apu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size2c4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4CL' in keys2task:        
        message2print = "{(Step 34A4/70) try" + "; size2cl4apu-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['SIZE4CL']  = task4kernel2apu['SIZE4CL']  
     
            message2print = "{(Step 34B4/70) initialized" + "; size2cl4apu-initialized-by-create2kernel4apu to: " + str(apu2kernel4xi['SIZE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size2cl4apu-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
                                    
                        
    if 'SIZE4PYC' in keys2task:        
        message2print = "{(Step 34E/70) try" + "; size-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34F) SIZE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['SIZE4PYC']  = task4kernel2apu['SIZE4PYC']  
     
            message2print = "{(Step 34F/70) initialized" + "; size-initialized-by-create2kernel4apu to: " + str(apu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 
            code2ack  = code2ack + '34F-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z3-'     
            
    if 'SIZE4BIN' in keys2task:        
        message2print = "{(Step 34G/70) try" + "; size-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34G) SIZE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['SIZE4BIN']  = task4kernel2apu['SIZE4BIN']  
     
            message2print = "{(Step 34H/70) initialized" + "; size-initialized-by-create2kernel4apu to: " + str(apu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 
            code2ack  = code2ack + '34H-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z4-'

                 
    if 'LANGUAGE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (35A0) LANGUAGE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2apu ['LANGUAGE'] = {}
            
            for key2code4apu in keys2code4apu:
                name2program4apu=os.path.splitext(key2code4apu)                                                     
                key2extension4apu = name2program4apu[1]                                                             
                if key2extension4apu == '.py':                          
                    task4kernel2apu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4apu == '.cpp':                          
                    task4kernel2apu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4apu == '.c':                          
                    task4kernel2apu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4apu == '.cl':                          
                    task4kernel2apu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-' 
        except: 
            message2print = "{(Step 35Z0/70) yielded" + "; language-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z0-'
                                     
    if 'LANGUAGE' in keys2task:        
        message2print = "{(Step 35A/70) try" + "; language-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (35) LANGUAGE - PYTHON, C++, C, CL                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['LANGUAGE']  = task4kernel2apu['LANGUAGE']  
     
            message2print = "{(Step 35B/70) initialized" + "; language-created-by-create2kernel4apu: " + str(apu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-'
        except: 
            message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z1-'  
                     
    if 'COUNT2REFERENCE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (36A0) COUNT2REFERENCE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            count2reference2apu  = 1
           
            message2print = "{(Step 36B/70) set" + "; count2reference2apu-set-by-create2kernel4apu to: " + str(count2reference2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '36B-' 
        
            task4kernel2apu ['COUNT2REFERENCE'] = count2reference2apu     
        except: 
            message2print = "{(Step 36Z0/70) yielded" + "; count2reference2apu-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z0-'             
                
    if 'COUNT2REFERENCE' in keys2task:                
        message2print = "{(Step 36A/70) try" + "; count2reference-try-by-create2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (36) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['COUNT2REFERENCE']  = task4kernel2apu['COUNT2REFERENCE']  
     
            message2print = "{(Step 36B/70) initialized" + "; count2reference-created-by-create2kernel4apu: " + str(apu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '36B-'
        except: 
            message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z1-' 
                
    if 'PROGRAM' not in keys2task:
        message2print = "{(Step 37/70) warned" + "; keys2task4program-warned-by-create2kernel4apu: " + " ** " + str(keys2task)  + " ** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:             
            # ---------------------------------------------------------------------------------------------
            # (37A0) PROGRAM - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2apu ['PROGRAM'] = None
            message2print = "{(Step 37A/70) try" + "; program2apu-try-by-create2kernel4apu: " + str(task4kernel2apu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2apu ['PROGRAM'] = create2programwithsource4apu()
                keys2program = task4kernel2apu ['PROGRAM'].keys()
                
                message2print = "{(Step 37B/70) set" + "; program-set-by-create2kernel4apu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'PROGRAM', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '37B-'
            except:
                message2print = "{(Step 37Z1/70) failed" + "; task4kernel2apu-failed-by-create2kernel4apu: " + str(task4kernel2apu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '37Z-'    
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; program-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-' 
                            
    if 'PROGRAM' in keys2task:
        message2print = "{(Step 37A/70) try" + "; program-try-by-create2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (37) PROGRAM - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['PROGRAM']  = task4kernel2apu['PROGRAM']  
     
            message2print = "{(Step 37B/70) initialized" + "; program-created-by-create2kernel4apu: " + str(len(apu2kernel4xi['PROGRAM']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0 ... 
            
            code2ack  = code2ack + '37B-'
        except: 
            message2print = "{(Step 37Z1/70) yielded" + "; program-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z1-' 
                       
    if 'FUNCTION' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2apu ['FUNCTION'] = {}
            message2print = "{(Step 38A0/70) set" + "; function4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2apu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 38A1/70) set" + "; pythonfunction4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4apu  = kb2kernel4apu ['.py'] ['TAG']
            message2print = "{(Step 38A2/70) using" + "; tag2search4apu-using-by-create2kernel4apu: " + str(tag2search4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4apu    = kb2kernel4apu ['.py'] ['VALUE']
            message2print = "{(Step 38A3/70) using" + "; value2search4apu-using-by-create2kernel4apu: " + str(value2search4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # apu2sampler4xi5test
            
            attribute2search4apu= kb2kernel4apu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 38A4/70) using" + "; attribute2search4apu-using-by-create2kernel4apu: " + str(attribute2search4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4apu in keys2code4apu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'] [key2code4apu]
                    keys2line4apu = code2examine4apu.keys()
                    for key2line4apu in keys2line4apu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'] [key2code4apu] [key2line4apu]
                        # message2print = "{(Step 38A5/70) examining" + "; line2examine4apu-examining-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4apu,tag2search4apu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 38B/70) examining" + "; line2function4apu-examining-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # function = "apu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4apu,value2search4apu)
                            if index2function == -1:
                                message2print = "{(Step 38C/70) skipped" + "; line2function4apu-skipped-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "set2trace4sampler" ... # function = "apu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4apu,attribute2search4apu)             # ....function = "apu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 38D/70) warning" + "; line2function4apu-warning-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 38E/70) accepted" + "; line2examine4apu-accepted-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ... function = "apu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4apu = line2examine4apu[index2function:index2usage-2]
                                    
                                    task4kernel2apu ['FUNCTION'] ['.py'] [key2pythonfunction4apu] = {}                                  

                                    message2print = "{(Step 38F/70) used" + "; key2pythonfunction4apu-used-by-create2kernel4apu: " + str(key2pythonfunction4apu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # apu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '38F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 38Z1/70) failed" + "; task4kernel2apu-failed-by-create2kernel4apu: " + str(task4kernel2apu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '38Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (39) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2apu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 39A0F/70) set" + "; cplusfunction4apu-set-by-create2kernel4apu to: " + str(task4kernel2apu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4apu      = kb2kernel4apu ['.cpp'] ['TAG']
            message2print = "{(Step 39A2/70) using" + "; tag2search4apu-using-by-create2kernel4apu: " + str(tag2search4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # function =
            
            attribute2search4apu= kb2kernel4apu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 39A4/70) using" + "; attribute2search4apu-using-by-create2kernel4apu: " + str(attribute2search4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4apu in keys2code4apu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'] [key2code4apu]
                    message2print = "{(Step 39A5/70) using" + "; key2code4apu-using-by-create2kernel4apu: " + str(key2code4apu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # apu2dummy4xi5test.cpp
                       
                    keys2line4apu = code2examine4apu.keys()
                    # message2print = "{(Step 39A6/70) using" + "; keys2line4apu-using-by-create2kernel4apu: " + str(keys2line4apu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4apu in keys2line4apu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4apu = task4kernel2apu ['PROGRAM'] ['CODE4SOURCE'] [key2code4apu] [key2line4apu]
                        # message2print = "{(Step 39A7/70) examining" + "; line2examine4apu-examining-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # function = "nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4apu,tag2search4apu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 39B1/70) examining" + "; line2function4apu-examining-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # function = "OCLError" usage = "error code checking"*/
                            # function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 39B2/70) using" + "; attribute2search4apu-using-by-create2kernel4apu: " + str(attribute2search4apu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4apu,attribute2search4apu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 39C/70) skipped" + "; line2function4apu-skipped-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 39E/70) accepted" + "; line2examine4apu-accepted-by-create2kernel4apu: " + str(line2examine4apu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "nbody_kern" usage = "kernel example 1"*/; 
                                # function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4apu = line2examine4apu[27:index2usage-2]  
                                task4kernel2apu ['FUNCTION'] ['.cpp'] [key2kernelfunction4apu] =  {}                                       

                                message2print = "{(Step 39F/70) used" + "; key2kernelfunction4apu-used-by-create2kernel4apu: " + str(key2kernelfunction4apu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '39F-'
                                    
            except: 
                message2print = "{(Step 37Z1/70) yielded" + "; program-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + '37Z1-'
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; function-apu2kernel4xi-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-'                               
                
    if 'FUNCTION' in keys2task:    
        message2print = "{(Step 38A/70) trying" + "; function-trying-by-create2kernel4apu: " + str(task4kernel2apu['FUNCTION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'.py': {'apu2sampler4xi5test': {}}, 
        # '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}    
        try:            
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['FUNCTION']  = task4kernel2apu['FUNCTION']   
     
            message2print = "{(Step 38B/70) created" + "; function-created-by-create2kernel4apu: " + str(apu2kernel4xi['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'.py': {'apu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}} 
            
            code2ack  = code2ack + '38B-'
        except: 
            message2print = "{(Step 38Z1/70) yielded" + "; function-yielded-by-create2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '38Z1-'            
                                       
                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)     
    # -----------------------------------------------------------------------------------------
    apu2kernel4xi ['ACK2RETURN']  = code2ack
    apu2kernel4xi ['NACK2RETURN'] = code2nack 
     
    keys2kernel4apu = apu2kernel4xi.keys()
    message2print = "{(Step 70A/70) returning" + "; keys2kernel4apu-returning-by-create2kernel4apu: " + str(keys2kernel4apu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 (no parameters given by caller): 
    # ['DIRECTORY4CL',
    #  'DIRECTORY4PY',
    #  'DIRECTORY4C',
    #  'DIRECTORY4CPP',
    #  'DIRECTORY4PYC',    
    #  'DIRECTORY4BIN',    
    #  'CODE4PY',
    #  'CODE4PYC',
    #  'CODE4CPP',
    #  'CODE4BIN',
    #  'CODE4C',
    #  'CODE4CL',
    
    #  'COUNT4C',                
    #  'COUNT4CL',    
    #  'COUNT4CPP',
    #  'COUNT4PYC',
    #  'COUNT4PY',
    #  'COUNT4BIN',
    
    #  'SIZE4PY',    
    #  'SIZE4CPP', <-- OK: C and CL MISSING
    #  'SIZE4PYC',
    #  'SIZE4BIN',
                        
    #  'QUEUE',
    #  'PROGRAM',
    #  'CONTEXT',
    #  'PIPE',
    #  'FUNCTION2CALLBACK',
    #  'COMMANDQUEUE',
    #  'PLATFORM',
    #  'FUNCTION',
    #  'CODE2ERROR',
    #  'ACK2RETURN',
    #  'DATA2CALLBACK',
    #  'BUFFER',
    #  'COUNT2REFERENCE',
    #  'DEVICE',
    #  'LANGUAGE',
    #  'NACK2RETURN',
    #  'EVENT']



    
    #2 (function and program parameters given by user):
    # ['FUNCTION',
    #  'ACK2RETURN',
    #  'PROGRAM',
    #  'NACK2RETURN']

    
    keys2programkernel4apu = apu2kernel4xi['PROGRAM'].keys()
    message2print = "{(Step 70B/70) returning" + "; keys2programkernel4apu-returning-by-create2kernel4apu: " + str(keys2programkernel4apu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 and 2:
    # dict_keys(['CODE2ERROR',
    #  'LANGUAGE4SOURCE',
    #  'COUNT4SOURCE',
    #  'SIZE4SOURCE',
    #  'DATA2CALLBACK',
    #  'BUFFER',
    #  'FUNCTION2CALLBACK',
    #  'ACK2RETURN',
    #  'DIRECTORY4SOURCE',
    #  'QUEUE',
    #  'PLATFORM',
    #  'COUNT2REFERENCE',
    #  'NACK2RETURN',
    #  'CONTEXT',
    #  'COMMANDQUEUE',
    #  'DEVICE',
    #  'CODE4SOURCE',
    #  'EVENT',
    #  'PIPE'])
    
    try:
        message2print = "{(Step 70C1/70) returning" + "; count2bin4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi ['COUNT4BIN']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1 
    except:
        pass    
    
    try:
        message2print = "{(Step 70C2/70) returning" + "; count2c4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi ['COUNT4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
    
    try:
        message2print = "{(Step 70C3/70) returning" + "; count2cl4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi ['COUNT4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
    
    try:
        message2print = "{(Step 70C4/70) returning" + "; count2cpp4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi ['COUNT4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass  
          
    try:
        message2print = "{(Step 70C5/70) returning" + "; count2py4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi ['COUNT4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1 
    except:
        pass    
          
    try:
        message2print = "{(Step 70C6/70) returning" + "; count2pyc4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi ['COUNT4PYC']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    try:
        message2print = "{(Step 70C7/70) returning" + "; count2source4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi ['COUNT4SOURCE']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 2
    except:
        pass            
        
        
                               
    try:        
        message2print = "{(Step 70S1/70) returning" + "; size2bin4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi['SIZE4BIN']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # apu2dummy4xi5test.exe': 501
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S2/70) returning" + "; size2c4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi['SIZE4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S3/70) returning" + "; size2cl4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi['SIZE4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S4/70) returning" + "; size2cpp4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi['SIZE4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # apu2dummy4xi5test.cpp': 337
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S5/70) returning" + "; size2py4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi['SIZE4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # apu2sampler4xi5test.py': 1337
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S6/70) returning" + "; size2pyc4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi['SIZE4PYC']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # __pycache__//apu2sampler4xi.cpython-33.pyc': 167 
    except:
        pass    
        
    message2print = "{(Step 70T/70) returning" + "; function2kernel4apu-returning-by-create2kernel4apu: " + str(apu2kernel4xi['FUNCTION']) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # {'.py':  {'apu2sampler4xi5test': {}},
    #  '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}
    # }  
        
    
                         
    return apu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "add2kernel4apu" usage = "
#     
#   print('(Step 2A3/700) OF APU2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())          
#   try:
#       task4add2kernel = {}
#       task4add2kernel ['CODE4PY'] = {}
#       task4add2kernel ['CODE4PY'] [folder2lib4apu + 'apu2dummy4xi.py'] = {}
#       task4add2kernel ['CODE4PY'] [folder2lib4apu + 'apu2dummy4xi.py'] [1] = '#<profile4xi profile = "33" />\n'
#       task4add2kernel ['CODE4PY'] [folder2lib4apu + 'apu2dummy4xi.py'] [2] = '#<program4xi program = "apu2dummy4xi.py" />\n'
#       task4add2kernel ['SIZE4PY'] = {}
#       task4add2kernel ['SIZE4PY'] [folder2lib4apu + 'apu2dummy4xi.py'] = len(task4add2kernel ['CODE4PY'] [folder2lib4apu + 'apu2dummy4xi.py'])
#       
#       task4add2kernel ['CODE4CPP'] = {}
#       task4add2kernel ['CODE4CPP'] [folder2lib4apu + 'apu2dummy4xi.cpp'] = {}
#       task4add2kernel ['CODE4CPP'] [folder2lib4apu + 'apu2dummy4xi.cpp'] [1] = '//<profile4xi profile = "33" />\n'
#       task4add2kernel ['CODE4CPP'] [folder2lib4apu + 'apu2dummy4xi.cpp'] [2] = '//<program4xi program = "apu2dummy4xi.cpp" />\n'
#       task4add2kernel ['SIZE4CPP'] = {}
#       task4add2kernel ['SIZE4CPP'] [folder2lib4apu + 'apu2dummy4xi.cpp'] = len(task4add2kernel ['CODE4CPP'] [folder2lib4apu + 'apu2dummy4xi.cpp'])                        
#       
#       task4add2kernel ['CODE4CL'] = {}
#       task4add2kernel ['CODE4CL'] [folder2lib4apu + 'apu2dummy4xi.cl'] = {}
#       task4add2kernel ['CODE4CL'] [folder2lib4apu + 'apu2dummy4xi.cl'] [1] = '__kernel void simple( __global float* A) {\n'
#       task4add2kernel ['CODE4CL'] [folder2lib4apu + 'apu2dummy4xi.cl'] [2] = '    int tid = get_global_id(0);/>\n'
#       task4add2kernel ['SIZE4CL'] = {}
#       task4add2kernel ['SIZE4CL'] [folder2lib4apu + 'apu2dummy4xi.cl'] = len(task4add2kernel ['CODE4CL'] [folder2lib4apu + 'apu2dummy4xi.cl'])    
#       
#       task4add2kernel ['CODE4BIN'] = {}
#       dir2bin4apu = folder2lib4apu + 'bin//'
#       key2bin4apu = dir2bin4apu + 'apu2dummy4xi.exe'
#       task4add2kernel ['CODE4BIN'] [key2bin4apu] = {}
#       task4add2kernel ['CODE4BIN'] [key2bin4apu] [1] = '<assemblyIdentity version="04.17.11" processorArchitecture="x86" name="apu2dummy4xi" type="win32"></assemblyIdentity>\n'
#       task4add2kernel ['CODE4BIN'] [key2bin4apu] [2] = '<description>Dummy for Binary</description>\n'
#       task4add2kernel ['SIZE4BIN'] = {}
#       task4add2kernel ['SIZE4BIN'] [key2bin4apu] = len(task4add2kernel ['CODE4BIN'] [key2bin4apu])  
#       
#       task4add2kernel ['CODE4C'] = {}
#       task4add2kernel ['CODE4C'] [folder2lib4apu + 'apu2dummy4xi.c'] = {}
#       task4add2kernel ['CODE4C'] [folder2lib4apu + 'apu2dummy4xi.c'] [1] = 'const char *sum_kernel_code =\n'
#       task4add2kernel ['CODE4C'] [folder2lib4apu + 'apu2dummy4xi.c'] [2] = '__kernel void compute_sum(__global int *a, int n, __local long *tmp_sum, __global long *sum)\n'
#       task4add2kernel ['SIZE4C'] = {}
#       task4add2kernel ['SIZE4C'] [folder2lib4apu + 'apu2dummy4xi.c'] = len(task4add2kernel ['CODE4C'] [folder2lib4apu + 'apu2dummy4xi.c'])    
#                
#       task4add2kernel ['CODE4PYC'] = {}
#       dir2pyc4apu = folder2lib4apu + '__pycache__//'
#       key2pyc4apu = dir2pyc4apu + 'apu2dummy4xi.pyc'
#       task4add2kernel ['CODE4PYC'] [key2pyc4apu] = {}
#       task4add2kernel ['CODE4PYC'] [key2pyc4apu] [1] = 'creates apu2buffer4xi'
#       task4add2kernel ['CODE4PYC'] [key2pyc4apu] [2] = 'initialized-by-create2buffer4apu\n'
#       task4add2kernel ['SIZE4PYC'] = {}
#       task4add2kernel ['SIZE4PYC'] [key2pyc4apu] = len(task4add2kernel ['CODE4PYC'] [key2pyc4apu])          
#                         
#                                                                                                              
#       response4add2kernel = add2kernel4apu(task4add2kernel)
#
#       print('(Step 2A4/700) OF APU2KERNEL4XI5TEST - ADDED KERNEL INTO KERNEL OBJECT WITH FUNCTION ', response4add2kernel)
#       # DIRECTORY4CL
#       # CODE4PY
#       # ...                                                                  
#   except:
#       print('(Step 2Z3/700) OF APU2KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())
#          
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def add2kernel4apu(task4kernel2apu):

    '''
    adds to kernel for APU
    '''
    global apu2kernel4xi                                                                                            # Kernel of APU    
    global folder2lib4apu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "add2kernel4apu" 
    method2print = "add2kernel4apu"

    message2print = "{(Step 10A/70) started" + "; add2kernel4apu-started: " + str(add2kernel4apu)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # <function add2kernel4apu at 0x0000000003C02BC8>
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2apu-to-add2kernel4apu: " + str(task4kernel2apu) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # folder2lib4apu + 
    # {'SIZE4PY': {folder2lib4apu + apu2dummy4xi.py': 2},
    #  'SIZE4CPP': {folder2lib4apu + apu2dummy4xi.cpp': 2},
    #  'CODE4C': {folder2lib4apu + apu2dummy4xi.c': {1: 'const char *sum_kernel_code =\n', 2: '__kernel void compute_sum(__global int *a, int n, __local long *tmp_sum, __global long *sum)\n'}},
    #  'CODE4PY': {folder2lib4apu + apu2dummy4xi.py': {1: '#<profile4xi profile = "33" />\n', 2: '#<program4xi program = "apu2dummy4xi.py" />\n'}},
    #  'CODE4CPP': {folder2lib4apu + apu2dummy4xi.cpp': {1: '//<profile4xi profile = "33" />\n', 2: '//<program4xi program = "apu2dummy4xi.cpp" />\n'}},
    #  'SIZE4PYC': {folder2lib4apu + __pycache__//apu2dummy4xi.pyc': 2},
    #  'SIZE4C': {folder2lib4apu + apu2dummy4xi.c': 2},
    #  'CODE4CL': {folder2lib4apu + apu2dummy4xi.cl': {1: '__kernel void simple( __global float* A) {\n', 2: '    int tid = get_global_id(0);/>\n'}},
    #  'SIZE4BIN': {folder2lib4apu + bin//apu2dummy4xi.exe': 2},
    #  'CODE4PYC': {folder2lib4apu + __pycache__//apu2dummy4xi.pyc': {1: 'creates apu2buffer4xi', 2: 'initialized-by-create2buffer4apu\n'}},
    #  'SIZE4CL': {folder2lib4apu + apu2dummy4xi.cl': 2},
    #  'CODE4BIN': {folder2lib4apu + bin//apu2dummy4xi.exe': {1: '<assemblyIdentity version="04.17.11" processorArchitecture="x86" name="apu2dummy4xi" type="win32"></assemblyIdentity>\n', 2: '<description>Dummy for Binary</description>\n'}}}; time: 04:53:58 01/11/12 Pacific Standard Time}

    code2ack  = ' '
    code2nack = ' '
     
    try:
        keys2kernel4task = task4kernel2apu.keys()
        message2print = "{(Step 10C/70) using" + "; keys2kernel4task-using-by-add2kernel4apu: " + str(keys2kernel4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # ['SIZE4PY', 'SIZE4CPP', 'CODE4C', 'CODE4PY', 'CODE4CPP', 'SIZE4PYC', 'SIZE4C', 'CODE4CL', 'SIZE4BIN', 'CODE4PYC', 'SIZE4CL', 'CODE4BIN']
        
    except: 
        message2print = "{(Step 10Z1/70) failed" + "; keys2kernel4task-failed-by-add2kernel4apu: " + str(task4kernel2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
     
    try:
        keys2kernel4apu = apu2kernel4xi.keys()
        message2print = "{(Step 10D1/70) using" + "; keys2kernel4apu-using-by-add2kernel4apu: " + str(sorted(keys2kernel4apu)) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # ['ACK2RETURN',
        #  'BUFFER',
        #  'CODE2ERROR',
        #  'CODE4BIN',
        #  'CODE4C',
        #  'CODE4CL',
        #  'CODE4CPP',
        #  'CODE4PY',
        #  'CODE4PYC',
        #  'COMMANDQUEUE',
        #  'CONTEXT',
        #  'COUNT2REFERENCE',
        
        #  'COUNT4BIN',
        #  'COUNT4C',
        #  'COUNT4CL',
        #  'COUNT4CPP',
        #  'COUNT4PY',
        #  'COUNT4PYC',
        #  'COUNT4SOURCE',
        
        #  'DATA2CALLBACK',
        #  'DEVICE',
        
        #  'DIRECTORY4BIN',
        #  'DIRECTORY4C',
        #  'DIRECTORY4CL',
        #  'DIRECTORY4CPP',
        #  'DIRECTORY4PY',
        #  'DIRECTORY4PYC',
        #  'DIRECTORY4SOURCE',
        
        #  'EVENT',
        #  'FUNCTION',
        #  'FUNCTION2CALLBACK',
        #  'LANGUAGE',
        #  'NACK2RETURN',
        #  'PIPE',
        #  'PLATFORM',
        #  'PROGRAM',
        #  'QUEUE',
        
        #  'SIZE4BIN',
        #  'SIZE4C',
        #  'SIZE4CL',
        #  'SIZE4CPP',
        #  'SIZE4PY',
        #  'SIZE4PYC']



                    
    except:
        message2print = "{(Step 10Z2/70) failed" + "; apu2kernel4xi-failed-by-add2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
             
    try:
        if apu2kernel4xi is None:
            response2create4apu = create2kernel4apu()
            message2print = "{(Step 10A/70) created" + "; apu2kernel4xi-created-by-add2kernel4apu: " + str(apu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
    except:
        response2create4apu = create2kernel4apu()
        message2print = "{(Step 10B/70) created" + "; apu2kernel4xi-created-by-add2kernel4apu: " + str(apu2kernel4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
      
      
    # ---------------------------------------------------------------------------------------------
    # (33) SEVERAL CODES OF SEVERAL LANGUAGES (Python, C++, C, CL ) CAN BE ADDED TO KERNEL                      
    # ---------------------------------------------------------------------------------------------             
    for key2kernel4task in sorted(keys2kernel4task):
        message2print = "{(Step 33A/70) using" + "; key2kernel4task-using-by-add2kernel4apu: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # CODE4BIN; CODE4C; CODE4CL; CODE4CPP; CODE4PY; SIZE4CL; SIZE4BIN; CODE4PYC; SIZE4PYC   
        try:
          
            keys2detail4task = task4kernel2apu [key2kernel4task].keys()
          
            for key2detail4task in sorted(keys2detail4task):
               
                message2print = "{(Step 33C/70) using" + "; key2detail4task-using-by-add2kernel4apu: " + str(key2detail4task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # folder2lib4apu + apu2dummy4xi.c; + apu2dummy4xi.cl; apu2dummy4xi.cpp; apu2dummy4xi.py; apu2dummy4xi.cl; bin//apu2dummy4xi.exe; bin//apu2dummy4xi.exe 
                
                try:        
                    apu2kernel4xi [key2kernel4task] [key2detail4task] = task4kernel2apu [key2kernel4task] [key2detail4task]
                
                    message2print = "{(Step 33D/70) added" + "; detail2task4apu-added-by-add2kernel4apu to: " + str(apu2kernel4xi [key2kernel4task] [key2detail4task])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # {1: 'const char *sum_kernel_code =\n', 
                    #  2: '__kernel void compute_sum(__global int *a, int n, __local long *tmp_sum, __global long *sum)\n'}
                    #
                    # {1: '<assemblyIdentity version="04.17.11" processorArchitecture="x86" name="apu2dummy4xi" type="win32"></assemblyIdentity>\n', 
                    #  2: '<description>Dummy for Binary</description>\n'}; time: 01:25:18 01/05/12 Pacific Standard Time}
                    #
                    # {1: '__kernel void simple( __global float* A) {\n', 2: '    int tid = get_global_id(0);/>\n'}
                    # {1: '//<profile4xi profile = "33" />\n', 2: '//<program4xi program = "apu2dummy4xi.cpp" />\n'}
                    # {1: '#<profile4xi profile = "33" />\n', 2: '#<program4xi program = "apu2dummy4xi.py" />\n'}
                    # bin//apu2dummy4xi.exe; 2
                    # __pycache__//apu2dummy4xi.pyc; 2
                    
                    key2count4program = 'COUNT' + key2kernel4task[4:]                                               # CODE4BIN => COUNT4BIN
                    
                    message2print = "{(Step 33E/70) using" + "; key2count4program-using-by-add2kernel4apu: " + str(key2count4program)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # COUNT4BIN; COUNT4C; COUNT4CL; COUNT4CPP; COUNT4PY; COUNT4PYC 
                    try: 
                        apu2kernel4xi [key2count4program] = apu2kernel4xi [key2count4program] + 1
                        
                        message2print = "{(Step 33F/70) added" + "; key2count4program-added-by-add2kernel4apu to: " + str(apu2kernel4xi [key2count4program])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 2; 1; 1; 2; 2; 2  
                    
                        code2ack  = code2ack + '33F-'
                    except:
                        try:
                            apu2kernel4xi [key2count4program] = 1
                            
                            message2print = "{(Step 33G/70) set" + "; key2count4program-set-by-add2kernel4apu to: " + str(apu2kernel4xi [key2count4program])  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            #
                        except:
                            message2print = "{(Step 33Z1/70) failed" + "; key2kernel4task-failed-by-add2kernel4apu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '33Z1-' 
                     
                    if ((key2count4program == 'COUNT4C') or (key2count4program == 'COUNT4CL') or (key2count4program == 'COUNT4CPP') or (key2count4program == 'COUNT4PY')):
                        key2count4source = 'COUNT4SOURCE'
                        try: 
                            apu2kernel4xi [key2count4source] = apu2kernel4xi [key2count4source] + 1
                            
                            message2print = "{(Step 33G/70) added" + "; count2source4apu-added-by-add2kernel4apu to: " + str(apu2kernel4xi [key2count4source])  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 3; 4; 5; 6; 7; 8; 9; 10
                        
                            code2ack  = code2ack + '33G-'
                        except:
                            try:
                                apu2kernel4xi [key2count4source] = 1
                                
                                message2print = "{(Step 33H/70) set" + "; count2source4apu-set-by-add2kernel4apu to: " + str(apu2kernel4xi [key2count4source])  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                #
                            except:
                                message2print = "{(Step 33Z2/70) failed" + "; key2kernel4task-failed-by-add2kernel4apu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # 
                                code2nack  = code2nack + '33Z2-'                                                           
                except:
                    try:
                        apu2kernel4xi [key2kernel4task] = {}
                        apu2kernel4xi [key2kernel4task] [key2detail4task] = task4kernel2apu [key2kernel4task] [key2detail4task]
                        
                        message2print = "{(Step 33G/70) added" + "; detail2task4apu-added-by-add2kernel4apu to: " + str(apu2kernel4xi [key2kernel4task] [key2detail4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # detail2task4apu-added-by-add2kernel4apu to: 2
                        
                    except:    
                        message2print = "{(Step 33Z2/70) failed" + "; key2kernel4task-failed-by-add2kernel4apu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        message2print = "{(Step 33Z3/70) failed" + "; task4kernel2apu-failed-by-add2kernel4apu: " + str(task4kernel2apu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        message2print = "{(Step 33Z4/70) failed" + "; apu2kernel4xi-failed-by-add2kernel4apu: " + str(sorted(keys2kernel4apu)) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        code2nack  = code2nack + '33Z4-'                    
                                             
                    
        except:
            message2print = "{(Step 33Z10/70) failed" + "; key2kernel4task-failed-by-add2kernel4apu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            code2nack  = code2nack + '33Z10-' 
                                                                    
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2kernel4xi ['ACK2RETURN']  = code2ack
    apu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    try:
        message2print = "{(Step 70C1/70) returning" + "; count2bin4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi ['COUNT4BIN']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 3
    except:
        pass    
    
    try:
        message2print = "{(Step 70C2/70) returning" + "; count2c4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi ['COUNT4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 2
    except:
        pass    
    
    try:
        message2print = "{(Step 70C3/70) returning" + "; count2cl4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi ['COUNT4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 2
    except:
        pass    
    
    try:
        message2print = "{(Step 70C4/70) returning" + "; count2cpp4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi ['COUNT4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 3
    except:
        pass  
          
    try:
        message2print = "{(Step 70C5/70) returning" + "; count2py4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi ['COUNT4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 3
    except:
        pass    
          
    try:
        message2print = "{(Step 70C6/70) returning" + "; count2pyc4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi ['COUNT4PYC']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 3 
    except:
        pass    
    try:
        message2print = "{(Step 70C7/70) returning" + "; count2source4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi ['COUNT4SOURCE']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 10
    except:
        pass            
        
        
                               
    try:        
        message2print = "{(Step 70S1/70) returning" + "; size2bin4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi['SIZE4BIN']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S2/70) returning" + "; size2c4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi['SIZE4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S3/70) returning" + "; size2cl4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi['SIZE4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S4/70) returning" + "; size2cpp4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi['SIZE4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S5/70) returning" + "; size2py4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi['SIZE4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S6/70) returning" + "; size2pyc4apu-returning-by-add2kernel4apu: " + str(apu2kernel4xi['SIZE4PYC']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        #  
    except:
        pass    
            
    keys2kernel4apu = apu2kernel4xi.keys()
    for key2kernel4apu in sorted(keys2kernel4apu):
        message2print = "{(Step 70A/70) returning" + "; key2kernel4apu-returning-by-add2kernel4apu: " + str(key2kernel4apu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # ACK2RETURN
        # BUFFER
        # CODE2ERROR
        # 
        # CODE4BIN
        # CODE4C
        # CODE4CL
        # CODE4CPP
        # CODE4PY
        # CODE4PYC
        # 
        # COMMANDQUEUE
        # CONTEXT
        # COUNT2REFERENCE
        # 
        # COUNT4BIN
        # COUNT4C
        # COUNT4CL
        # COUNT4CPP
        # COUNT4PY
        # COUNT4PYC
        # COUNT4SOURCE
        # 
        # DATA2CALLBACK
        # DEVICE
        # DIRECTORY4BIN
        # DIRECTORY4C
        # DIRECTORY4CL
        # DIRECTORY4CPP
        # DIRECTORY4PY
        # DIRECTORY4PYC
        # DIRECTORY4SOURCE
        # 
        # EVENT
        # FUNCTION
        # FUNCTION2CALLBACK
        # LANGUAGE
        # NACK2RETURN
        # PIPE
        # PLATFORM
        # PROGRAM
        # QUEUE
        # 
        # SIZE4BIN
        # SIZE4C
        # SIZE4CL
        # SIZE4CPP
        # SIZE4PY
        # SIZE4PYC
        
    return apu2kernel4xi
            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2nativekernel4apu" usage = "
#     
#   print('(Step 2A2/700) OF APU2KERNEL4XI5TEST - TRYING TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())           
#   try:
#       response4execute = execute2nativekernel4apu()
#   except:
#       print('(Step 2Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION *** ', time4xi())                                                                      
#          
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def execute2nativekernel4apu(task4program2apu=None):

    '''
    executes native kernel of APU
    '''
    global apu2kernel4xi                                                                                            # Kernel of APU    
    global import2use4apu                                                                                           # Imports of APU
    global target2function4apu                                                                                      # Target function of Process4Xi
    global folder2lib4apu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2nativekernel4apu" 
    method2print = "execute2nativekernel4apu"

    message2print = "{(Step 1A/70) started" + "; execute2nativekernel4apu-started: " + str(execute2nativekernel4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function execute2nativekernel4apu at 0x0000000003B74448> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4program2apu-to-execute2nativekernel4apu: " + str(task4program2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # None 

    code2ack  = ' '
    code2nack = ' '    
    
    kernel2program4apu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
    message2print = "{(Step 1C/70) initialized" + "; kernel2program4apu-initialized-by-execute2nativekernel4apu to: " + str(kernel2program4apu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}               
    try:             
        if task4program2apu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4program2apu-yielded-by-execute2nativekernel4apu: " + str(task4program2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - EXECUTE NATIVE KERNELS INSIDE PROGRAM OBJECT FOR APU ! 
    # ---------------------------------------------------------------------------------------------    
    keys2kernel4apu = apu2kernel4xi.keys()
    if 'CODE4KERNEL' in keys2kernel4apu:
        try:            
            # ---------------------------------------------------------------------------------------------
            # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                            
            # ---------------------------------------------------------------------------------------------             
            keys2kernel4apu = apu2kernel4xi['CODE4KERNEL'].keys()
            message2print = "{(Step 30A/70) using" + "; keys2kernel4apu-using-by-execute2nativekernel4apu: " + str(keys2kernel4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            unit4processing = "apu"
            
            for key2kernel4apu in keys2kernel4apu:
                index2search=str.find(key2kernel4apu,unit4processing) 
                if index2search == -1:
                    pass
                else:
                    target2execute = key2kernel4apu[index2search:]                                                          # apu2sampler4xi5test.py
                    index2search=str.find(target2execute,".py")
                    if index2search == -1:
                        pass
                    else:
                        target2execute4apu = target2execute[:index2search]                                                  
                        message2print = "{(Step 32A/70) set" + "; target2execute4apu-set-by-execute2nativekernel4apu to: " + str(target2execute4apu)  + "; time: " + time4xi() + "}"  
                        print4xi(class2print, method2print, message2print)
                        # 
    
                        p2kernel4apu = None    
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4APU 
                            # ---------------------------------------------------------------------------------------------    
                 
                            try:
                                import2use4apu.get(target2execute4apu, handle2error4apu) ()
                                
                                message2print = "{(Step 32B/70) imported" + "; target2execute4apu-imported-by-execute2nativekernel4apu: " + str(target2execute4apu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # 
                                code2ack  = code2ack + '32B-'
                            except:
                                message2print = "{(Step 32Z1/70) failed" + "; import2use4apu-failed-by-execute2nativekernel4apu: " + str(import2use4apu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)                            
                                # 
                                message2print = "{(Step 32Z2/70) used" + "; target2execute4apu-used-by-execute2nativekernel4apu: " + str(target2execute4apu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # 
                                code2nack  = code2nack + '32Z2-'
                                        
                            # ---------------------------------------------------------------------------------------------    
                            # CREATE PROCESS WITH TARGET2FUNCTION4APU
                            # ---------------------------------------------------------------------------------------------                          
                            p2apu = Process4Xi(target=target2function4apu, args=())                                
                            message2print = "{(Step 33A/70) created" + "; p2apu-created-by-execute2nativekernel4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            # <Process4Xi(Process4Xi-1, initial)>
                            
                            code2ack  = code2ack + '33A-'
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # START PROCESS
                                # --------------------------------------------------------------------------------------------- 
                                p2apu.start()
                                message2print = "{(Step 34A/70) started" + "; p2apu-started-by-execute2nativekernel4apu: " + str(p2apu.name) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # Process4Xi-1
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # STATUS OF PROCESS
                                    # ---------------------------------------------------------------------------------------------                             
                                    status2process4apu = p2apu.is_alive()
                                    message2print = "{(Step 35A/70) got" + "; status-got-by-execute2nativekernel4apu: " + str(status2process4apu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # True
                                    
                                    try:
                                        # ---------------------------------------------------------------------------------------------    
                                        # RUN PROCESS
                                        # ---------------------------------------------------------------------------------------------                                  
                                        p2apu.run()
                                        message2print = "{(Step 36A/70) run" + "; p2apu-run-by-execute2nativekernel4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # <Process4Xi(Process4Xi-1, stopped[1])>
                                    except:
                                        message2print = "{(Step 36Z/70) failed" + "; run-failed-by-execute2nativekernel4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)  
                                        code2nack  = code2nack + '36Z-'            
                                        # 
                                except:
                                    message2print = "{(Step 35Z/70) failed" + "; status-failed-by-execute2nativekernel4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    # 
                                    code2nack  = code2nack + '35Z-'                                   
                                    
                            except:
                                message2print = "{(Step 33Z/70) failed" + "; start-failed-by-execute2nativekernel4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                code2nack  = code2nack + '33Z-'     
                            
                        except:
                            message2print = "{(Step 32Z/70) failed" + "; p2kernel4apu-failed-by-execute2nativekernel4apu: " + str(p2kernel4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '32Z-' 
                                                                                        
                # ---------------------------------------------------------------------------------------------
                # SAVE SOURCE WITHOUT END OF LINES
                # ---------------------------------------------------------------------------------------------        
                keys2lines = apu2kernel4xi['CODE4KERNEL'][key2kernel4apu].keys()     
                kernel2program4apu[key2kernel4apu] = ""
                for key2line in keys2lines:
                    code2add4apu = apu2kernel4xi ['CODE4KERNEL'] [key2kernel4apu] [key2line]
                    kernel2program4apu[key2kernel4apu] = kernel2program4apu[key2kernel4apu] + code2add4apu.replace("\n","")
            
                message2print = "{(Step 34A/70) saved" + "; lenght-kernel4apu-saved-by-execute2nativekernel4apu to: " + str(len(kernel2program4apu[key2kernel4apu]))  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #     
                    
     
            message2print = "{(Step 38A/70) set" + "; lenght-kernel2program4apu-set-by-execute2nativekernel4apu to: " + str(len(kernel2program4apu))  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            # 
             
            code2ack  = code2ack + '38A-'
        except: 
            message2print = "{(Step 30Z1/70) yielded" + "; kernel-yielded-by-execute2nativekernel4apu: " + str(apu2kernel4xi['CODE4KERNEL']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '30Z1-'     
    else:
        message2print = "{(Step 31Z1/70) yielded" + "; keys2kernel4apu-yielded-by-execute2nativekernel4apu: " + str(keys2kernel4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # dict_keys(['DIRECTORY4CL', 'CODE4PY', 'COUNT4CPP', 'DIRECTORY4PYC', 'QUEUE', 'PROGRAM', 'CONTEXT', 'DIRECTORY4PY', 'DIRECTORY4C', 'PIPE', 'SIZE4PY', 'COUNT4PYC', 'CODE4C', 
        #            'DIRECTORY4BIN', 'COUNT4SOURCE', 'FUNCTION2CALLBACK', 'CODE4CL', 'COMMANDQUEUE', 'PLATFORM', 'COUNT4C', 'FUNCTION', 'CODE2ERROR', 'ACK2RETURN', 'DATA2CALLBACK', 
        #            'BUFFER', 'CODE4PYC', 'CODE4CPP', 'SIZE4CL', 'COUNT4CL', 'COUNT2REFERENCE', 'DEVICE', 'SIZE4CPP', 'LANGUAGE', 'SIZE4PYC', 'DIRECTORY4CPP', 'SIZE4BIN', 'SIZE4C', 
        #            'DIRECTORY4SOURCE', 'COUNT4PY', 'NACK2RETURN', 'COUNT4BIN', 'CODE4BIN', 'EVENT']); time: 08:31:18 03/09/12 Pacific Standard Time}
                                                                                                   
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2kernel4xi ['ACK2RETURN']  = code2ack
    apu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernel4apu = kernel2program4apu.keys()
    for key2kernel4apu in keys2kernel4apu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4apu-returning-by-execute2nativekernel4apu: " + str(key2kernel4apu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        # 
    
    return kernel2program4apu
            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "delete2kernel4apu" usage = "
#     
#   print('(Step 2A4/700) OF APU2KERNEL4XI5TEST - TRYING TO DELETE KERNELs INSIDE KERNEL OBJECT WITH FUNCTION  ', time4xi())        
#   try:
#       task4delete2kernel = {}
#       
#       task4delete2kernel ['CODE4PY'] = {}
#       key2py4apu = folder2lib4apu + 'apu2dummy4xi.py'
#       task4delete2kernel ['CODE4PY'] [key2py4apu] = 'Yes'
#
#       delete2kernel ['CODE4CPP'] = {}
#       key2cpp4apu = folder2lib4apu + 'apu2dummy4xi.cpp'
#       task4delete2kernel ['CODE4CPP'] [key2cpp4apu] = 'Yes'
#           
#       task4delete2kernel ['CODE4CL'] = {}
#       key2cl4apu = folder2lib4apu + 'apu2dummy4xi.cl'
#       task4delete2kernel ['CODE4CL'] [key2cl4apu] = 'Yes'
#
#       delete2kernel ['CODE4BIN'] = {}
#       dir2bin4apu = folder2lib4apu + 'bin//'
#       key2bin4apu = dir2bin4apu + 'apu2dummy4xi.exe'
#       task4delete2kernel ['CODE4BIN'] [key2bin4apu] = 'Yes'
#                       
#       task4delete2kernel ['CODE4C'] = {}
#       key2c4apu = folder2lib4apu + 'apu2dummy4xi.c'
#       task4delete2kernel ['CODE4C'] [key2c4apu] = 'Yes'
#
#       task4delete2kernel ['CODE4PYC'] = {}
#       dir2pyc4apu = folder2lib4apu + '__pycache__//'
#       key2pyc4apu = dir2pyc4apu + 'apu2dummy4xi.pyc'
#       task4delete2kernel ['CODE4PYC'] [key2pyc4apu] = 'Yes'
#       
#       response4delete2kernel = delete2kernel4apu(task4delete2kernel)
#       print('(Step 2A5/700) OF APU2KERNEL4XI5TEST - DELETED DELETE KERNELs INSIDE KERNEL OBJECT WITH FUNCTION  ', time4xi())
#   except:
#       print('(Step 2Z4/700) OF APU2KERNEL4XI5TEST *** FAILED TO DELETE KERNELs INSIDE KERNEL OBJECT WITH FUNCTION  ', time4xi())  
#          
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def delete2kernel4apu(task4kernel2apu):

    '''
    deletes kernel for APU
    '''
    global apu2kernel4xi                                                                                     
    global folder2lib4apu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "delete2kernel4apu" 
    method2print = "delete2kernel4apu"

    message2print = "{(Step 10A/70) started" + "; delete2kernel4apu-started: " + str(delete2kernel4apu)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # <function delete2kernel4apu at 0x000000000405CEC8>
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2apu-to-delete2kernel4apu: " + str(task4kernel2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    #  {'CODE4CL': {folder2lib4apu + apu2dummy4xi.cl': 'Yes'},
    #  'CODE4C': {folder2lib4apu + apu2dummy4xi.c': 'Yes'},
    #  'CODE4PY': {folder2lib4apu + apu2dummy4xi.py': 'Yes'},
    #  'CODE4CPP': {folder2lib4apu + apu2dummy4xi.cpp': 'Yes'},
    #  'CODE4PYC': {folder2lib4apu + __pycache__//apu2dummy4xi.pyc': 'Yes'},
    #  'CODE4BIN': {folder2lib4apu + bin//apu2dummy4xi.exe': 'Yes'}}

    code2ack  = ' '
    code2nack = ' '    
    #
    ack4key2kernel = False
    try:
        # ---------------------------------------------------------------------------------------------
        # TASK MUST HAVE BEEN GIVEN BY USER - CONTAINS KERNEL KEYS    
        # ---------------------------------------------------------------------------------------------
        keys2program4kernel = task4kernel2apu.keys()        
        message2print = "{(Step 19A/70) using" + "; keys2program4kernel-using-by-delete2kernel4apu: " + str(sorted(keys2program4kernel))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # ['CODE4BIN', 'CODE4C', 'CODE4CL', 'CODE4CPP', 'CODE4PY', 'CODE4PYC']
        
        # ---------------------------------------------------------------------------------------------
        # (Step 20A/70) - DELETE KERNEL INSIDE PROGRAM OBJECT FOR APU ! 
        # ---------------------------------------------------------------------------------------------    
        message2print = "{(Step 20A/70) try" + "; key-try-by-delete2kernel4apu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      

        for key2program4kernel in keys2program4kernel:                                                              # CODE4PY, CODE4CPP, CODE4CL, CODE4BIN, CODE4C
            message2print = "{(Step 20B/70) using" + "; key2program4kernel-using-by-delete2kernel4apu: " + str(key2program4kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                    
            # 'CODE4BIN', 'CODE4C', 'CODE4CL', 'CODE4CPP', 'CODE4PY', 'CODE4PYC'
            try: 
                keys2detail4apu = task4kernel2apu [key2program4kernel].keys()                                       # SEVERAL PROGRAMS OF SAME TYPE POSSIBLE          
                
                for key2detail4apu in keys2detail4apu:                                                              # apu2dummy4xi.py, apu2dummy4xi.cpp, apu2dummy4xi.cl, apu2dummy4xi.exe, apu2dummy4xi.c
                    try:
                        message2print = "{(Step 20C/70) using" + "; key2detail4apu-using-by-delete2kernel4apu: " + str(key2detail4apu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)                    
                        # apu2dummy4xi.cpp, apu2dummy4xi.exe, apu2dummy4xi.cl, apu2dummy4xi.c, apu2dummy4xi.py 
                        
                        del apu2kernel4xi [key2program4kernel] [key2detail4apu]        
               
                        message2print = "{(Step 20D/70) deleted" + "; key2detail4apu-deleted-by-delete2kernel4apu: " + str(key2detail4apu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)                    
                        # apu2dummy4xi.cpp, apu2dummy4xi.exe, apu2dummy4xi.cl, apu2dummy4xi.c, apu2dummy4xi.py, __pycache__//apu2dummy4xi.pyc 
                
                        code2ack  = code2ack + '20D-'
                        try:
                            key2size4apu = 'SIZE' + key2program4kernel[4:]                                          # SIZE4PY, -CPP, -4CL, -4BIN, -4C, -PYC
                            message2print = "{(Step 20E/70) set" + "; key2size4apu-set-by-delete2kernel4apu to: " + str(key2size4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                    
                            # SIZE4CPP, SIZE4BIN, SIZE4CL, SIZE4C, SIZE4PY, SIZE4PYC
                            
                            del apu2kernel4xi [key2size4apu] [key2detail4apu]                                       # DELETE SIZE OF THE DELETED ONE
                            
                            message2print = "{(Step 20F/70) upgraded" + "; key2size4apu-upgraded-by-delete2kernel4apu: " + str(key2size4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                    
                            # SIZE4CPP, SIZE4BIN, SIZE4CL, SIZE4C, SIZE4PY, SIZE4PYC
                            
                            key2count4program = 'COUNT' + key2size4apu[4:]                                          # CODE4BIN => COUNT4BIN
                    
                            message2print = "{(Step 20G/70) using" + "; key2count4program-using-by-delete2kernel4apu: " + str(key2count4program)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # COUNT4BIN; COUNT4C; COUNT4CL; COUNT4CPP; COUNT4PY; COUNT4PYC  
                            try: 
                                apu2kernel4xi [key2count4program] = apu2kernel4xi [key2count4program] - 1
                        
                                message2print = "{(Step 20H/70) calculated" + "; key2count4program-calculated-by-delete2kernel4apu: " + str(apu2kernel4xi [key2count4program])  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # COUNT4CL=0; COUNT4C=0; COUNT4PY=2; COUNT4CPP=2; COUNT4PYC=2; COUNT4BIN=2;   
                    
                                code2ack  = code2ack + '20H-'
                            except:
                                try:
                                    apu2kernel4xi [key2count4program] = 1
                            
                                    message2print = "{(Step 20I/70) set" + "; key2count4program-set-by-delete2kernel4apu to: " + str(apu2kernel4xi [key2count4program])  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    #
                                except:
                                    message2print = "{(Step 20Z1/70) failed" + "; key2kernel4task-failed-by-delete2kernel4apu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    code2nack  = code2nack + '20Z1-' 
                     
                            if ((key2count4program == 'COUNT4C') or (key2count4program == 'COUNT4CL') or (key2count4program == 'COUNT4CPP') or (key2count4program == 'COUNT4PY')):
                                key2count4source = 'COUNT4SOURCE'
                                try: 
                                    apu2kernel4xi [key2count4source] = apu2kernel4xi [key2count4source] - 1
                                    
                                    message2print = "{(Step 20J/70) calculated" + "; count2source4apu-calculated-by-delete2kernel4apu: " + str(apu2kernel4xi [key2count4source])  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 9 (OK); 8; 7; 6
                                
                                    code2ack  = code2ack + '20J-'
                                except:
                                    try:
                                        apu2kernel4xi [key2count4source] = 1
                                        
                                        message2print = "{(Step 20K/70) set" + "; count2source4apu-set-by-delete2kernel4apu to: " + str(apu2kernel4xi [key2count4source])  + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        #
                                    except:
                                        message2print = "{(Step 20Z2/70) failed" + "; key2kernel4task-failed-by-delete2kernel4apu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # 
                                        code2nack  = code2nack + '20Z2-'                                     
                        except:     
                            message2print = "{(Step 20Z2/70) yielded" + "; key2detail4apu-yielded-by-delete2kernel4apu: " + str(key2detail4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            #                
                            code2nack  = code2nack + '20Z2-'                        
                    except:     
                        message2print = "{(Step 20Z3/70) yielded" + "; key2detail4apu-yielded-by-delete2kernel4apu: " + str(key2detail4apu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #                
                        code2nack  = code2nack + '20Z3-'     

            except:
                message2print = "{(Step 20Z4/70) yielded" + "; key2program4kernel-yielded-by-delete2kernel4apu: " + str(key2program4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                
                code2nack  = code2nack + '20Z4-' 
    except: 
        message2print = "{(Step 20Z0/70) failed" + "; task4kernel2apu-apu2kernel4xi-failed-by-delete2kernel4apu: " + str(task4kernel2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '20Z0-'    
                                                                                            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2kernel4xi ['ACK2RETURN']  = code2ack
    apu2kernel4xi ['NACK2RETURN'] = code2nack
    
    try:
        message2print = "{(Step 70C1/70) returning" + "; count2bin4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi ['COUNT4BIN']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 2
    except:
        pass    
    
    try:
        message2print = "{(Step 70C2/70) returning" + "; count2c4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi ['COUNT4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C3/70) returning" + "; count2cl4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi ['COUNT4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C4/70) returning" + "; count2cpp4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi ['COUNT4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 2
    except:
        pass  
          
    try:
        message2print = "{(Step 70C5/70) returning" + "; count2py4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi ['COUNT4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 2 
    except:
        pass    
          
    try:
        message2print = "{(Step 70C6/70) returning" + "; count2pyc4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi ['COUNT4PYC']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 2
    except:
        pass    
    try:
        message2print = "{(Step 70C7/70) returning" + "; count2source4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi ['COUNT4SOURCE']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 6 (OK)
    except:
        pass            
        
        
                               
    try:        
        message2print = "{(Step 70S1/70) returning" + "; size2bin4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi['SIZE4BIN']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # apu2dummy4xi5test.exe': 501
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S2/70) returning" + "; size2c4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi['SIZE4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S3/70) returning" + "; size2cl4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi['SIZE4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S4/70) returning" + "; size2cpp4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi['SIZE4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # apu2dummy4xi5test.cpp': 337
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S5/70) returning" + "; size2py4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi['SIZE4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # apu2sampler4xi5test.py': 1337
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S6/70) returning" + "; size2pyc4apu-returning-by-delete2kernel4apu: " + str(apu2kernel4xi['SIZE4PYC']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # __pycache__//apu2sampler4xi.cpython-33.pyc': 167 
    except:
        pass    
        
    keys2kernel4apu = apu2kernel4xi.keys()
    for key2kernel4apu in sorted(keys2kernel4apu):
        message2print = "{(Step 70B/70) returning" + "; key2kernel4apu-returning-by-delete2kernel4apu: " + str(key2kernel4apu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # ACK2RETURN
        # BUFFER
        # CODE2ERROR
        # 
        # CODE4BIN
        # CODE4C
        # CODE4CL
        # CODE4CPP
        # CODE4PY
        # CODE4PYC
        # 
        # COMMANDQUEUE
        # CONTEXT
        # COUNT2REFERENCE
        
        # COUNT4BIN
        # COUNT4C
        # COUNT4CL
        # COUNT4CPP
        # COUNT4PY
        # COUNT4PYC
        
        # DATA2CALLBACK
        # DEVICE
        # DIRECTORY4BIN
        # DIRECTORY4C
        # DIRECTORY4CL
        # DIRECTORY4CPP
        # DIRECTORY4PY
        # DIRECTORY4PYC
        # EVENT
        # FUNCTION
        # FUNCTION2CALLBACK
        # LANGUAGE
        # NACK2RETURN
        # PIPE
        # PLATFORM
        # PROGRAM
        # QUEUE
        # 
        # SIZE4BIN
        # SIZE4C
        # SIZE4CL
        # SIZE4CPP
        # SIZE4PY
        # SIZE4PYC


    return apu2kernel4xi
            
#</function4xi> 
 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernelsinprogram4apu" usage = "
#     
#   print('(Step 3A1/700) OF APU2KERNEL4XI5TEST - TRYING TO CREATE KERNELS IN PROGRAM FOR APU ', time4xi())          
#   try:
#       response4create2kernelsinprogram = create2kernelsinprogram4apu()
#       print('(Step 3A2/700) OF APU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRAM FOR APU ', time4xi())
#   except:
#       print('(Step 3Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO CREATE KERNELS IN PROGRAM FOR APU *** ', time4xi())
#
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def create2kernelsinprogram4apu(task4kernel2apu=None):

    '''
    creates kernels in program for APU
    '''
    global apu2kernel4xi                                                                                            # Kernel of APU    
    global folder2lib4apu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernelsinprogram4apu" 
    method2print = "create2kernelsinprogram4apu"

    message2print = "{(Step 1A/70) started" + "; create2kernelsinprogram4apu-started: " + str(create2kernelsinprogram4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2apu-to-create2kernelsinprogram4apu: " + str(task4kernel2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    

    
    keys2kernel4apu = apu2kernel4xi.keys()
    for key2kernel4apu in keys2kernel4apu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4apu-returning-by-create2kernelsinprogram4apu: " + str(key2kernel4apu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return apu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fetch2kernel4apu" usage = "
#   fetch2kernel4apu(file2walk)
#"> 
# -------------------------------------------------------------------------------------------------
def fetch2kernel4apu(program2explore4apu):
    global fetch2code4apu                                                                                           # dictionary to receive files 
        
    global kb2fetch4apu                                                                                             # knowledgebase for fetching
    global profile2fetch                                                                                            # profiles
    global keys2profile4apu                                                                                         # file extensions 
    
    global folder2lib4apu  

    class2print  = "fetch2kernel4apu"
    method2print = "fetch2kernel4apu" 
     
    message2print = "{(Step 1A/33) passed" + "; program2explore4apu-passed-to-fetch2kernel4apu: " + str(program2explore4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # folder2lib4apu + apu2buffer4xi.py          ... apu2sampler4xi5test.py ... apu2dummy4xi5test.cpp ...           # Python and C++ programs
    # __pycache__\apu2buffer4xi.cpython-33.pyc   ... apu2sampler4xi5test.cpython-33.pyc ...                         # Cache of Python binaries
    # //bin\apu2dummy4xi5test.exe                                                                                   # Built C++ exe files
                  
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program4apu=os.path.splitext(program2explore4apu)                                                          # apu2sampler4xi5test + py

    key2extension4apu = name2program4apu[1]                                                                         # py,pyc,cpp,exe 
    message2print = "{(Step 1B/33) set" + "; key2extension4apu-set-by-fetch2kernel4apu to: " + str(key2extension4apu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # .py; .pyc
    message2print = "{(Step 1C/33) using" + "; profile2fetch-using-by-fetch2kernel4apu: " + str(profile2fetch)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # {'.pyc': 'NACK', '.py': 'ACK', '.cpp': 'ACK', '.exe': 'NACK'}  
        
    if profile2fetch [key2extension4apu] == 'ACK':                                                                  # profile2fetch ['py']  = 'ACK'       
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF FETCH2SCOPE4XI - EXTENSION IN PROFILE 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore4apu-analyzing-by-fetch2kernel4apu: " + str(program2explore4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # folder2lib4apu +  apu2buffer4xi.py ; apu2sampler4xi5test.py ...  ... __pycache__\apu2sampler4xi5test.cpython-33.pyc
        # apu2dummy4xi5test.cpp
             
        path2input4apu = program2explore4apu
        message2print = "{(Step 1B/33) set" + "; path2input4apu-set-by-fetch2kernel4apu to: " + str(path2input4apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # folder2lib4apu +  apu2buffer4xi.py ; __pycache__\apu2sampler4xi5test.cpython-33.pyc; apu2dummy4xi5test.cpp

        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF FETCH2SCOPE4XI - CHECKING WHETHER PROGRAM MUST BE FETCHED 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A1/33) analyzing" + "; path2input4apu-analyzing-by-fetch2kernel4apu: " + str(path2input4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #folder2lib4apu +  apu2buffer4xi.py ; apu2dummy4xi5test.cpp 
            
        keys2fetch4apu = kb2fetch4apu.keys()
        message2print = "{(Step 2A2/33) using" + "; keys2fetch4apu-using-by-fetch2kernel4apu: " + str(keys2fetch4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #        
        ack2match4file = False
        for key2fecth4apu in keys2fetch4apu:                                                                        # 1,2 ...
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------
            index2search=str.find(path2input4apu,kb2fetch4apu[key2fecth4apu])                                       
            if index2search == -1:                                         
                # -----------------------------------------------------------------------------------------
                # VALID FILE TYPE BUT NOT SELECTED TO BE FETCHED - OK ONE MAY ALSO PASS HERE!
                # -----------------------------------------------------------------------------------------               
                message2print = "{(Step 2C1/33) skipped" + "; path2input4apu-skipped-by-fetch2kernel4apu: " + str(path2input4apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                # folder2lib4apu +  apu2buffer4xi.py 
                
            else:
                ack2match4file = True
                
                message2print = "{(Step 2D/33) decided" + "; program-to-read-decided-by-fetch2kernel4apu: " + str(path2input4apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
                #folder2lib4apu +  apu2sampler4xi5test.py; __pycache__//apu2sampler4xi.cpython-33.pyc; 
                #               +  apu2dummy4xi5test.cpp

                # -----------------------------------------------------------------------------------------
                # (Step 3/33) OF FETCH2SCOPE4XI - OPEN INPUT FILE - READ MODE SET ACCORDING TO FILE TYPE
                # -----------------------------------------------------------------------------------------
                if ((key2extension4apu == '.py') or (key2extension4apu == '.cpp') or (key2extension4apu == '.c') or (key2extension4apu == '.cl')):
                    file2input4apu = open(path2input4apu,'r')
                    message2print = "{(Step 3A/33) opened" + "; file2input4apu-opened-by-fetch2kernel4apu: " + str(file2input4apu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # <_io.TextIOWrapper name=folder2lib4apu + 'apu2sampler4xi5test.py' mode='r' encoding='cp1252'> 
                     
                if ((key2extension4apu == '.pyc') or (key2extension4apu == '.exe')):
                    file2input4apu = open(path2input4apu,'rb')
                    message2print = "{(Step 3B/33) opened" + "; file2input4apu-opened-by-fetch2kernel4apu: " + str(file2input4apu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    #  __pycache__//apu2sampler4xi.cpython-33.pyc               
                    
                # -----------------------------------------------------------------------------------------
                # (Step 4/33) OF FETCH2SCOPE4XI - OUTPUT 
                # -----------------------------------------------------------------------------------------
                key2save4apu = path2input4apu
                fetch2code4apu[key2save4apu] = {}                                                                   # fetch2code4apu['apu2sampler4xi5test.py'] = {}
                number2line4apu = 0  
                message2print = "{(Step 3B/33) saving" + "; key2fecth4apu-saving-by-fetch2kernel4apu: " + str(key2fecth4apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
         
                while 1:
                    # -------------------------------------------------------------------------------------
                    # (Step 5/33) OF FETCH2SCOPE4XI - PROCESS FILE
                    # -------------------------------------------------------------------------------------             
                    line2process4apu = file2input4apu.readline()  
                    if not line2process4apu:
                        # ---------------------------------------------------------------------------------
                        # (Step 30/33) OF FETCH2SCOPE4XI - ALL LINES READ, FINISH
                        # ---------------------------------------------------------------------------------             
                        break                                               
                    else:
                        # ---------------------------------------------------------------------------------
                        # (Step 7/33) OF FETCH2SCOPE4XI - SAVE LINE
                        # ---------------------------------------------------------------------------------
                        # message2print = "{(Step 7A/33) read" + "; line2process4apu-read-by-fetch2kernel4apu: " + str(line2process4apu) + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print)              
                        # ... profile = "11" />
                        # ...
                        # # end of apu2sampler4xi5test.py 
                        # #/> 
                        try:
                            number2line4apu = number2line4apu + 1
                            fetch2code4apu[key2save4apu][number2line4apu] = line2process4apu
                        except:
                            message2print = "{(Step 7Z1/33) failed" + "; key2fecth4apu-failed-by-fetch2kernel4apu: " + str(key2fecth4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z2/33) failed" + "; line2process4apu-failed-by-fetch2kernel4apu: " + str(line2process4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z3/33) failed" + "; number2line4apu-failed-by-fetch2kernel4apu: " + str(number2line4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                                                             
                # -----------------------------------------------------------------------------------------
                # (Step 31/33) OF FETCH2SCOPE4XI - CLOSE INPUT
                # -----------------------------------------------------------------------------------------            
                file2input4apu.close()
                message2print = "{(Step 31A/33) closed" + "; file2input4apu-closed-by-fetch2kernel4apu: " + str(file2input4apu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                # <_io.TextIOWrapper name=folder2lib4apu + 'apu2sampler4xi5test.py' mode='r' encoding='cp1252'>     # Python source files
                # {folder2lib4apu + 'apu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: '# -- 
                # apu2dummy4xi5test.cpp                                                                             # C++ source files
                # __pycache__//apu2sampler4xi.cpython-33.pyc                                                        # Cached binary files of Python
                # apu2dummy4xi5test.exe                                                                             # C++ exe files
        
                message2print = "{(Step 31B1/33) saved" + "; fetch2code4apu-saved-by-fetch2kernel4apu: " + str(fetch2code4apu[key2save4apu] [1]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... profile = "11" />
                
                message2print = "{(Step 31B2/33) saved" + "; fetch2code4apu-saved-by-fetch2kernel4apu: " + str(fetch2code4apu[key2save4apu] [2]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # apu2dummy4xi5test.cpp
                
                message2print = "{(Step 31B3/33) saved" + "; fetch2code4apu-saved-by-fetch2kernel4apu: " + str(fetch2code4apu[key2save4apu] [3]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... program = "apu2sampler4xi5test.py">
                
                message2print = "{(Step 31B4/33) saved" + "; fetch2code4apu-saved-by-fetch2kernel4apu: " + str(fetch2code4apu[key2save4apu] [4]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ...  abstract = "tests apu2sampler4xi.py"/>
                                                                 
                # ---------------------------------------------------------------------------------------------
                #
                # ---------------------------------------------------------------------------------------------                                          


    else:
        # -----------------------------------------------------------------------------------------
        # FILE TYPE - NOT IN PROFILE
        # -----------------------------------------------------------------------------------------       
        message2print = "{(Step 1F/33) skipped" + "; name2program4apu-skipped-by-fetch2kernel4apu: " + str(name2program4apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # folder2lib4apu + '__pycache__//apu2buffer4xi.cpython-32', '.pyc')
        
        extension2skip = name2program4apu[1]
        message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-fetch2kernel4apu: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # pyc

        message2print = "{(Step 1H/33) returning" + "; fetch2kernel4apu-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
 
    message2print = "{(Step 1H/33) returning" + "; fetch2kernel4apu-returning: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)            
    #   
                                            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernel4apu" usage = "
#
#   ... prepare task4set2kernel ...    
#
#   response4set2kernel = {} 
#   print('(Step 21F/700) OF APU2KERNEL4XI5TEST - TRYING TO SET KERNEL: ', set2kernel4apu)   
#   # 
#   try:                               
#       response4set2kernel = set2kernel4apu(task4set2kernel)
#       print('(Step 21G/700) OF APU2KERNEL4XI5TEST - SET KERNEL : ', set2kernel4apu)                                                                                                           
#   except:
#       print('(Step 21Z/700) OF APU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ', set2kernel4apu)  
#   try:                                                                                          
#       keys2kernel = response4set2kernel.keys()
#       for key2kernel in sorted(keys2kernel):
#           print('key2kernel ', key2kernel)
#           # ACK2RETURN
#           # BUFFER
#           # CODE2ERROR
#           # CODE4BIN
#           # CODE4C
#           # CODE4CL
#           # CODE4CPP
#           # CODE4PY
#           # CODE4PYC
#           # COMMANDQUEUE
#           # CONTEXT
#           # COUNT2REFERENCE
#           # COUNT4BIN
#           # COUNT4C
#           # COUNT4CL
#           # COUNT4CPP
#           # COUNT4PY
#           # COUNT4PYC
#           # COUNT4SOURCE
#           # DATA2CALLBACK
#           # DEVICE
#           # DIRECTORY4BIN
#           # DIRECTORY4C
#           # DIRECTORY4CL
#           # DIRECTORY4CPP
#           # DIRECTORY4PY
#           # DIRECTORY4PYC
#           # DIRECTORY4SOURCE
#           # EVENT
#           # FUNCTION
#           # FUNCTION2CALLBACK
#           # LANGUAGE
#           # NACK2RETURN
#           # PIPE
#           # PLATFORM
#           # PROGRAM
#           # QUEUE
#           # SIZE4BIN
#           # SIZE4C
#           # SIZE4CL
#           # SIZE4CPP
#           # SIZE4PY
#           # SIZE4PYC   
#   except:
#       print('(Step 3Z2/700) OF APU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4SET2KERNEL : ', response4set2kernel)                                               
#   try: 
#       print('ACK2RETURN: ', response4set2kernel['ACK2RETURN'])
#       print('NACK2RETURN: ', response4set2kernel['NACK2RETURN'])
#       print('CODE2ERROR: ', response4set2kernel['CODE2ERROR'])
#       print('CODE4CPP: ', response4set2kernel['CODE4CPP'])
#       # apu2dummy4xi5test.cpp': {1: '// apu2dummy4xi5test.cpp\n'}}
#       print('CODE4PY: ', response4set2kernel['CODE4PY'])
#       # apu2image4xi5test.py': {1: '#<profile4xi profile = "11" />\n', 2: '#<program4xi program = "apu2image4xi5test.py">\n'}}
#       print('COUNT4CPP: ', response4set2kernel['COUNT4CPP'])
#       # 1
#       print('COUNT4PY: ', response4set2kernel['COUNT4PY'])
#       # 1
#       print('COUNT4SOURCE: ', response4set2kernel['COUNT4SOURCE'])
#       # 2
#       print('DIRECTORY4CPP: ', response4set2kernel['DIRECTORY4CPP'])
#       print('DIRECTORY4PY: ', response4set2kernel['DIRECTORY4PY'])
#       print('DIRECTORY4SOURCE: ', response4set2kernel['DIRECTORY4SOURCE'])
#       print('SIZE4CPP: ', response4set2kernel['SIZE4CPP'])
#       # apu2dummy4xi5test.cpp': 337}
#       print('SIZE4PY: ', response4set2kernel['SIZE4PY'])
#       # apu2sampler4xi5test.py': 1337
#   except:
#       print('(Step 21Z2/700) OF APU2KERNEL4XI5TEST *** FAILED TO PRINT SELECTED KERNEL DETAIL ', time4xi())  
#
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def set2kernel4apu(task4kernelset2apu=None):

    '''
    sets kernels for APU
    '''
    global apu2kernel4xi  
    global folder2lib4apu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernel4apu"
    method2print = "set2kernel4apu" 

    message2print = "{(Step 1A/33) started" + "; set2kernel4apu-started: " + str(set2kernel4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernel4apu at 0x0000000003837948> 
    
    keys2task = task4kernelset2apu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernel4apu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # CODE2ERROR
        # CODE4CPP
        # CODE4PY
        # CONTEXT
        # COUNT4CPP
        # COUNT4PY
        # DEVICE
        # DIRECTORY4SOURCE
        # LANGUAGE4SOURCE
        # PIPE
        # QUEUE
        
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if apu2kernel4xi is None:
            apu2kernel4xi = create2kernel4apu()                                                                              # INITIALIZE PROGRAM FOR APU 
            message2print = "{(Step 1C/70) set" + "; apu2kernel4xi-set-by-set2kernel4apu to: " + str(apu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4apu-skipped-by-set2kernel4apu: " + str(create2kernel4apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function create2kernel4apu at 0x0000000003ADCBC8>                                
    except:
        try:
            apu2kernel4xi = create2kernel4apu()
            message2print = "{(Step 1E/70) set" + "; apu2kernel4xi-set-by-set2kernel4apu to: " + str(apu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            apu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; apu2kernel4xi-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    if 'DATA2CALLBACK' in keys2task:
        message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21A/70) - DATA2CALLBACK - EXTRA
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['DATA2CALLBACK'] = task4kernelset2apu['DATA2CALLBACK']
                                            
            message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernel4apu to: " + str(apu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  
            
            code2ack  = code2ack + '21A1-'
        except: 
            message2print = "{(Step 21Z1/70) yielded" + "; data2callback-apu2kernel4xi-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # yielded
            code2nack  = code2nack + '21Z1-'
    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelset2apu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernel4apu to: " + str(apu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  
            code2ack  = code2ack + '22B1-'
        except: 
            message2print = "{(Step 22Z2/70) yielded" + "; function2callback-apu2kernel4xi-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            code2nack  = code2nack + '22Z2-' 
    if 'PLATFORM' in keys2task:    
        message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22C/70) - PLATFORM - EXTRA
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['PLATFORM'] = task4kernelset2apu['PLATFORM']
            
            message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernel4apu to: " + str(apu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #   
            code2ack  = code2ack + '2C1-'
        except: 
            message2print = "{(Step 22Z3/70) yielded" + "; platform-apu2kernel4xi-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # yielded
            code2nack  = code2nack + '22Z3-' 
            
    if 'CONTEXT' in keys2task:        
         
        message2print = "{(Step 23A/70) try" + "; context2apu-try-by-set2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 23/70) - CONTEXT - REQUIRED
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['CONTEXT'] = task4kernelset2apu['CONTEXT']
            
            message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernel4apu to: " + str(apu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0 ...
            
            code2ack  = code2ack + '23B-'
        except: 
            message2print = "{(Step 23Z1/70) yielded" + "; context-apu2kernel4xi-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        
            code2nack  = code2nack + '23Z1-' 
    if 'DEVICE' in keys2task:        
        message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 24/70) - DEVICE - EXTRA
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['DEVICE'] = task4kernelset2apu['DEVICE']
            
            message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernel4apu to: " + str(apu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'RESOLUTION2TIMER4PROFILING': 318 ...
            
            
            code2ack  = code2ack + '24B-'
        except: 
            message2print = "{(Step 24Z1/70) yielded" + "; device-apu2kernel4xi-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '24Z1-'
    if 'CODE2ERROR' in keys2task:                 
        message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 25/70) - ERROR CODE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['CODE2ERROR'] = task4kernelset2apu['CODE2ERROR']
            
            message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernel4apu to: " + str(apu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0 
            
            code2ack  = code2ack + '25B-'
        except: 
            message2print = "{(Step 25Z1/70) yielded" + "; code2error-apu2kernel4xi-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '25Z1-'                
                    
    if 'QUEUE' in keys2task:          
        message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 26/70) - QUEUE - EXTRA
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['QUEUE'] = task4kernelset2apu['QUEUE']
            
            message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernel4apu to: " + str(apu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <queue4xi.Queue4Xi object at 0x00000000042B8FD0>
             
            code2ack  = code2ack + '26B-'
        except: 
            message2print = "{(Step 26Z1/70) yielded" + "; queue-apu2kernel4xi-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z1-' 
    if 'PIPE' in keys2task:                                
        message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 27/70) - PIPE - EXTRA
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['PIPE'] = task4kernelset2apu['PIPE']
            
            message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernel4apu to: " + str(apu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # (<read-write PipeConnection, handle 552>, <read-write PipeConnection, handle 556>) 
            
            
            code2ack  = code2ack + '27B-'
        except: 
            message2print = "{(Step 27Z1/70) yielded" + "; pipe-apu2kernel4xi-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z1-'   
    if 'COMMANDQUEUE' in keys2task:
        message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (28) COMMAND QUEUE - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['COMMANDQUEUE']  = task4kernelset2apu['COMMANDQUEUE']  
     
            message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernel4apu to: " + str(apu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
            code2ack  = code2ack + '28B-'
        except: 
            message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '28Z1-'    
    if 'BUFFER' in keys2task:
        message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (29) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['BUFFER']  = task4kernelset2apu['BUFFER']  
     
            message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernel4apu to: " + str(apu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #  
            code2ack  = code2ack + '29B-'
        except: 
            message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            code2nack  = code2nack + '29Z1-'            
    if 'EVENT' in keys2task:
        message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernel4apu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (30) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['EVENT']  = task4kernelset2apu['EVENT']  
     
            message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernel4apu to: " + str(apu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '30B-'
        except: 
            message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '30Z1-'
    if 'COUNT4PY' in keys2task:                    
                  
        message2print = "{(Step 31A/70) try" + "; count2py4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31)  - COUNT4PY                           
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4PY']  = task4kernelset2apu['COUNT4PY']  
     
            message2print = "{(Step 31B/70) set" + "; count2py4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31B-'
        except: 
            message2print = "{(Step 31Z1/70) yielded" + "; count2py4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '31Z1-'  
    if 'COUNT4PYC' in keys2task:                
        message2print = "{(Step 31C/70) try" + "; count2pyc4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31C)  - COUNT4PYC                           
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4PYC']  = task4kernelset2apu['COUNT4PYC']  
     
            message2print = "{(Step 31D/70) set" + "; count2pyc4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31D-'
        except: 
            message2print = "{(Step 31Z2/70) yielded" + "; count2pyc4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '31Z2-'  
    if 'COUNT4C' in keys2task:                
        message2print = "{(Step 31E/70) try" + "; count2c4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31E)  - COUNT4C                           
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4C']  = task4kernelset2apu['COUNT4C']  
     
            message2print = "{(Step 31F/70) set" + "; count2c4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31F-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2c4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '31Z3-'                  
    if 'COUNT4BIN' in keys2task:                
        message2print = "{(Step 31G/70) try" + "; count2bin4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31G)  - COUNT4BIN                           
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4BIN']  = task4kernelset2apu['COUNT4BIN']  
     
            message2print = "{(Step 31H/70) set" + "; count2bin4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31H-'
        except: 
            message2print = "{(Step 31Z4/70) yielded" + "; count2bin4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '31Z4-'  
    if 'COUNT4CL' in keys2task:                
        message2print = "{(Step 31I/70) try" + "; count2cl4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31G)  - COUNT4CL                           
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4CL']  = task4kernelset2apu['COUNT4CL']  
     
            message2print = "{(Step 31J/70) set" + "; count2cl4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['COUNT4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '31J-'
        except: 
            message2print = "{(Step 31Z5/70) yielded" + "; count2cl4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '31Z5-'  
    if 'COUNT4CPP' in keys2task:                
        message2print = "{(Step 31K/70) try" + "; count2cpp4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31K)  - COUNT4CPP                           
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4CPP']  = task4kernelset2apu['COUNT4CPP']  
     
            message2print = "{(Step 31L/70) set" + "; count2cpp4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['COUNT4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31L-'
        except: 
            message2print = "{(Step 31Z6/70) yielded" + "; count2cpp4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '31Z6-'
             
    if 'COUNT4SOURCE' in keys2task:                
        message2print = "{(Step 31M/70) try" + "; count2source4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31M)  - COUNT4SOURCE - TRUST CALLER                          
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4SOURCE']  = task4kernelset2apu['COUNT4SOURCE']  
     
            message2print = "{(Step 31M/70) set" + "; count2source4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['COUNT4SOURCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '31M-'
        except: 
            message2print = "{(Step 31Z7/70) yielded" + "; count2source4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '31Z7-'
    else:    
        message2print = "{(Step 31N/70) try" + "; count2source4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31M)  - COUNT4SOURCE - NOT GIVEN BY CALLER - CALCULATE YOURSELF                          
            # ---------------------------------------------------------------------------------------------             
            apu2kernel4xi['COUNT4SOURCE']  = apu2kernel4xi['COUNT4C'] + apu2kernel4xi['COUNT4CL'] + apu2kernel4xi['COUNT4CPP'] + apu2kernel4xi['COUNT4PY'] 
     
            message2print = "{(Step 31N/70) set" + "; count2source4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['COUNT4SOURCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 2
            code2ack  = code2ack + '31N-'
        except: 
            apu2kernel4xi['COUNT4SOURCE']  =  0
            message2print = "{(Step 31Z8/70) yielded" + "; count2source4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '31Z8-'
                            
    if 'DIRECTORY4PY' in keys2task:                                
        message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernel4apu: " + str(task4kernelset2apu)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32B) DIRECTORY4PY - REQUIRED                     
            # ---------------------------------------------------------------------------------------------                                    
            apu2kernel4xi['DIRECTORY4PY']  = task4kernelset2apu['DIRECTORY4PY'] 
            
            message2print = "{(Step 32B/70) set" + "; directory2py4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '32B-'
        except: 
            message2print = "{(Step 32Z1/70) yielded" + "; directory2py4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '32Z1-' 
    if 'DIRECTORY4PYC' in keys2task:
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32C) DIRECTORY4PYC - REQUIRED                     
            # ---------------------------------------------------------------------------------------------                                    
            apu2kernel4xi['DIRECTORY4PYC']  = task4kernelset2apu['DIRECTORY4PYC'] 
            
            message2print = "{(Step 32C/70) set" + "; directory2pyc4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '32C-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '32Z2-'
    if 'DIRECTORY4CPP' in keys2task:    
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32D) DIRECTORY4C - REQUIRED                     
            # ---------------------------------------------------------------------------------------------                                    
            apu2kernel4xi['DIRECTORY4CPP']  = task4kernelset2apu['DIRECTORY4CPP'] 
            
            message2print = "{(Step 32D/70) set" + "; directory2c4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # OK
            code2ack  = code2ack + '32D-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2c4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '32Z3-' 
    if 'DIRECTORY4BIN' in keys2task:
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32E) DIRECTORY4BIN - REQUIRED                     
            # ---------------------------------------------------------------------------------------------                                    
            apu2kernel4xi['DIRECTORY4BIN']  = task4kernelset2apu['DIRECTORY4BIN'] 
            
            message2print = "{(Step 32E/70) set" + "; directory2bin4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '32E-'
        except: 
            message2print = "{(Step 32Z4/70) yielded" + "; directory2bin4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '32Z34-'         
    if 'DIRECTORY4CL' in keys2task:
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32F) DIRECTORY4CL - REQUIRED                     
            # ---------------------------------------------------------------------------------------------                                    
            apu2kernel4xi['DIRECTORY4CL']  = task4kernelset2apu['DIRECTORY4CL'] 
            
            message2print = "{(Step 32F/70) set" + "; directory2cl4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['DIRECTORY4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '32F-'
        except: 
            message2print = "{(Step 32Z5/70) yielded" + "; directory2cl4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '32Z5-' 
    if 'DIRECTORY4CPP' in keys2task:
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32G) DIRECTORY4CPP - REQUIRED                     
            # ---------------------------------------------------------------------------------------------                                    
            apu2kernel4xi['DIRECTORY4CPP']  = task4kernelset2apu['DIRECTORY4CPP'] 
            
            message2print = "{(Step 32G/70) set" + "; directory2cpp4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # OK 
            code2ack  = code2ack + '32G-'
        except: 
            message2print = "{(Step 32Z6/70) yielded" + "; directory2cpp4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '32Z6-' 
    if 'DIRECTORY4SOURCE' in keys2task:
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32G) DIRECTORY4SOURCE - REQUIRED                     
            # ---------------------------------------------------------------------------------------------                                    
            apu2kernel4xi['DIRECTORY4SOURCE']  = task4kernelset2apu['DIRECTORY4SOURCE'] 
            
            message2print = "{(Step 32G/70) set" + "; directory2source4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['DIRECTORY4SOURCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '32G-'
        except: 
            message2print = "{(Step 32Z6/70) yielded" + "; directory2source4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '32Z6-'
    if 'CODE4PY' in keys2task:                                                 
        message2print = "{(Step 33A/70) try" + "; code2py4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33B) CODE4PY - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['CODE4PY']  = task4kernelset2apu['CODE4PY']  
     
            message2print = "{(Step 33B/70) set" + "; code2py4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 'apu2image4xi5test.py': 
            #  {1: '... profile = "11" />\n', 
            #   2: '... kernel = "apu2image4xi5test.py">\n'}
     
            code2ack  = code2ack + '33B-'
        except: 
            message2print = "{(Step 33Z1/70) yielded" + "; code2py4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '33Z1-'        
    if 'CODE4CPP' in keys2task:                         
        message2print = "{(Step 33C/70) try" + "; code2c4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33C) CODE4C - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['CODE4CPP']  = task4kernelset2apu['CODE4CPP']  
     
            message2print = "{(Step 33D/70) set" + "; code2c4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['CODE4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + apu2dummy4xi5test.cpp': {1: '// apu2dummy4xi5test.cpp\n'
     
            code2ack  = code2ack + '33D-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2c4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '33Z2-'                     
    if 'CODE4PYC' in keys2task:                         
        message2print = "{(Step 33D/70) try" + "; code2pyc4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33D) CODE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['CODE4PYC']  = task4kernelset2apu['CODE4PYC']  
     
            message2print = "{(Step 33E/70) set" + "; code2pyc4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 
     
            code2ack  = code2ack + '33E-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2pyc4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '33Z3-'        
    if 'CODE4BIN' in keys2task:                         
        message2print = "{(Step 33F/70) try" + "; code2bin4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33D) CODE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['CODE4BIN']  = task4kernelset2apu['CODE4BIN']  
     
            message2print = "{(Step 33G/70) set" + "; code2bin4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4apu + 
     
            code2ack  = code2ack + '33G-'
        except: 
            message2print = "{(Step 33Z4/70) yielded" + "; code2bin4apu-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '33Z4-'                
    if 'SIZE4PY' in keys2task:                
        message2print = "{(Step 34A/70) try" + "; size2py4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE4PY - REQUIRED                         
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['SIZE4PY']  = task4kernelset2apu['SIZE4PY']  
     
            message2print = "{(Step 34B/70) set" + "; size2py4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '34B-'
        except: 
            message2print = "{(Step 34Z1/70) yielded" + "; size2py4apu-yielded-by-set2kernel4apu: " + str(task4kernelset2apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '34Z1-'    
    if 'SIZE4C' in keys2task:                    
        message2print = "{(Step 34C/70) try" + "; size2c4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34C) SIZE4C - REQUIRED                         
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['SIZE4C']  = task4kernelset2apu['SIZE4C']  
     
            message2print = "{(Step 34D/70) set" + "; size2c4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '34D-'
        except: 
            message2print = "{(Step 34Z2/70) yielded" + "; size2c4apu-yielded-by-set2kernel4apu: " + str(task4kernelset2apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '34Z2-'
    if 'SIZE4PYC' in keys2task:                
        message2print = "{(Step 34E/70) try" + "; size2pyc4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34E) SIZE4PYC - REQUIRED                         
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['SIZE4PYC']  = task4kernelset2apu['SIZE4PYC']  
     
            message2print = "{(Step 34F/70) set" + "; size2pyc4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '34F-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size2pyc4apu-yielded-by-set2kernel4apu: " + str(task4kernelset2apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '34Z3-'          
    if 'SIZE4BIN' in keys2task:                
        message2print = "{(Step 34G/70) try" + "; size2bin4apu-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34G) SIZE4BIN - REQUIRED                         
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['SIZE4BIN']  = task4kernelset2apu['SIZE4BIN']  
     
            message2print = "{(Step 34H/70) set" + "; size2bin4apu-set-by-set2kernel4apu to: " + str(apu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '34H-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size2bin4apu-yielded-by-set2kernel4apu: " + str(task4kernelset2apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '34Z4-'  
            
        
    if 'LANGUAGE' in keys2task:                                  
        message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (35) LANGUAGE (DICTIONARY) - REQUIRED                     
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['LANGUAGE']  = task4kernelset2apu['LANGUAGE']  
     
            message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernel4apu to: " + str(apu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '35B-'
        except: 
            message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '35Z1-'          
    if 'COUNT2REFERENCE' in keys2task:                            
        message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernel4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (36) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            apu2kernel4xi['COUNT2REFERENCE']  = task4kernelset2apu['COUNT2REFERENCE']  
     
            message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernel4apu to: " + str(apu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '36B-'
        except: 
            message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2kernel4xi ['ACK2RETURN']  = code2ack
    apu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernel4apu = apu2kernel4xi.keys()
    for key2kernel4apu in sorted(keys2kernel4apu):
        message2print = "{(Step 70/70) returning" + "; key2kernel4apu-returning-by-set2kernel4apu: " + str(key2kernel4apu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return apu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelarg4apu" usage = "
#
#   task4kernelargset2apu = {}
#   print('(Step 19A/700) OF APU2KERNEL4XI5TEST - TRYING TO PREPARE TASK4KERNELARGSET2APU ', task4kernelargset2apu)   
#   response4create2kernel = {}
#   
#   try:
#       response4create2kernel = create2kernel4apu()
#   except:
#       print('(Step 19Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO PREPARE TASK4KERNELARGSET2APU ', task4kernelargset2apu)
#   
#   try:
#       task4kernelargset2apu['KERNEL'] = response4create2kernel  # NEW KERNEL SET!
#   except:
#       print('(Step 19Z2/700) OF APU2KERNEL4XI5TEST *** FAILED TO PREPARE TASK4KERNELARGSET2APU ', task4kernelargset2apu)                
#   
#   arg4kernel2apu = {}
#   try:    
#       arg4kernel2apu[0] = create2image4apu()
#   except:
#       print('(Step 19Z3/700) OF APU2KERNEL4XI5TEST *** FAILED TO PREPARE TASK4KERNELARGSET2APU ', task4kernelargset2apu)                
#   try:
#       arg4kernel2apu[1] = create3image4apu()
#   except:
#       print('(Step 19Z4/700) OF APU2KERNEL4XI5TEST *** FAILED TO PREPARE TASK4KERNELARGSET2APU ', task4kernelargset2apu)
#   try:                    
#       arg4kernel2apu[2] = create2buffer4apu()
#   except:
#       print('(Step 19Z5/700) OF APU2KERNEL4XI5TEST *** FAILED TO PREPARE TASK4KERNELARGSET2APU ', task4kernelargset2apu)
#   try:                    
#       task4kernelargset2apu['ARG'] = arg4kernel2apu
#   except:
#       print('(Step 19Z6/700) OF APU2KERNEL4XI5TEST *** FAILED TO PREPARE TASK4KERNELARGSET2APU ', task4kernelargset2apu)
#       
#   print('(Step 19B/700) OF APU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS : ', time4xi())   
#   response4set2kernelarg = {}
#   try:                                           
#       response4set2kernelarg = set2kernelarg4apu(task4kernelargset2apu)
#       print('(Step 19C/700) OF APU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS: ', time4xi()) 
#   except:
#       print('(Step 19Z7/700) OF APU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS: ', time4xi())  
#   try:                    
#       keys2response = response4set2kernelarg['ARG'].keys()
#       print('(Step 19D/700) OF APU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS - KEYS ARE: ', keys2response)
#       # dict_keys([0, 1, 2])                                                                                                           
#   except:
#       print('(Step 19Z8/700) OF APU2KERNEL4XI5TEST *** FAILED TO PRINT KERNEL ARGUMENT KEYS: ', time4xi())  
#
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def set2kernelarg4apu(task4kernelargset2apu=None):

    '''
    sets kernel arguments for APU
    '''
    global apu2kernel4xi  
    global folder2lib4apu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernelarg4apu"
    method2print = "set2kernelarg4apu" 

    message2print = "{(Step 1A/33) started" + "; set2kernelarg4apu-started: " + str(set2kernelarg4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernelarg4apu at 0x0000000003C3C5C8>
    
    keys2task = task4kernelargset2apu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernelarg4apu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # ARG; KERNEL
          
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if apu2kernel4xi is None:
            apu2kernel4xi = create2kernel4apu()                                                                              # INITIALIZE PROGRAM FOR APU 
            message2print = "{(Step 1C/70) set" + "; apu2kernel4xi-set-by-set2kernelarg4apu to: " + str(apu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4apu-skipped-by-set2kernelarg4apu: " + str(create2kernel4apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            apu2kernel4xi = create2kernel4apu()
            message2print = "{(Step 1E/70) set" + "; apu2kernel4xi-set-by-set2kernelarg4apu to: " + str(apu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            apu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; apu2kernel4xi-yielded-by-set2kernelarg4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    if 'KERNEL' in keys2task:
        message2print = "{(Step 22A0/70) try" + "; kernel-try-by-set2kernelarg4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21A/70) - KERNEL - REPLACE THE WHOLE KERNEL !
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi = task4kernelargset2apu['KERNEL']
                                            
            message2print = "{(Step 21A1/70) set" + "; kernel-set-by-set2kernelarg4apu to: " + str(apu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'DIRECTORY4CL': ... 
            
            code2ack  = code2ack + '21A1-'
        except: 
            message2print = "{(Step 21Z1/70) yielded" + "; kernel-apu2kernel4xi-yielded-by-set2kernelarg4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # yielded
            code2nack  = code2nack + '21Z1-'
    
            
    if 'ARG' in keys2task:    
        message2print = "{(Step 22B0/70) try" + "; arg-try-by-set2kernelarg4apu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22B/70) - ARG 
            # -----------------------------------------------------------------------------------------               
            apu2kernel4xi['ARG'] = task4kernelargset2apu['ARG']
            
            keys2arg4apu = apu2kernel4xi['ARG'].keys()
            for key2arg4apu in keys2arg4apu: 
                message2print = "{(Step 22B1/70) set" + "; key2arg4apu-set-by-set2kernelarg4apu to: " + str(key2arg4apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 0, 1, 2  
            code2ack  = code2ack + '22B1-'
        except: 
            message2print = "{(Step 22Z2/70) yielded" + "; arg-apu2kernel4xi-yielded-by-set2kernelarg4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            code2nack  = code2nack + '22Z2-' 
            

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2kernel4xi ['ACK2RETURN']  = code2ack
    apu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernelarg4apu = apu2kernel4xi.keys()
    for key2kernelarg4apu in keys2kernelarg4apu:
        message2print = "{(Step 70/70) returning" + "; key2kernelarg4apu-returning-by-set2kernelarg4apu: " + str(key2kernelarg4apu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # ARG

    return apu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2kernel4apu" usage = "
#
#   task4release2kernel  = {} 
#   task4release2kernel  ['COUNT2REFERENCE'] = 1 
#   response4release2kernel = {}
#   
#   print('(Step 18A/700) OF APU2KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF APU DEVICE ', time4xi())    
#   try:                               
#       response4release2kernel = release2kernel4apu(task4release2kernel)
#       print('(Step 18B/700) OF APU2KERNEL4XI5TEST - RELEASED KERNEL OF APU DEVICE ', time4xi()) 
#   except:
#       print('(Step 18Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF APU DEVICE ', time4xi())                                                                                                  
#   
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def release2kernel4apu(task4release2apu=None):

    '''
    releases kernel for APU
    '''
    global apu2kernel4xi  
    global folder2lib4apu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2kernel4apu"
    method2print = "release2kernel4apu" 

    message2print = "{(Step 1A/33) started" + "; release2kernel4apu-started: " + str(release2kernel4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function release2kernel4apu at 0x0000000003B740C8>
    
    
    message2print = "{(Step 1B/33) passed" + "; task4release2apu-to-release2kernel4apu: " + str(task4release2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1}
    

    code2ack  = ' '
    code2nack = ' '

    try:
        if apu2kernel4xi is None:
            apu2kernel4xi = create2kernel4apu()                                                                       # INITIALIZE KERNEL                 
    except:
        try:
            apu2kernel4xi = create2kernel4apu()
        except:
            apu2kernel4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; apu2kernel4xi-yielded-by-release2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2kernel4apu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2apu is None:
        task4release2apu = {}
        task4release2apu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        apu2kernel4xi['COUNT2REFERENCE'] = apu2kernel4xi['COUNT2REFERENCE'] - task4release2apu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2kernel4apu: " + str(apu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
         
        if apu2kernel4xi['COUNT2REFERENCE'] < 0:
            apu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2kernel4apu: " + " ** " + str(apu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
             
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            apu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2kernel4apu: " + " ** " + str(apu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; apu2kernel4xi-yielded-by-release2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2kernel4xi ['ACK2RETURN']  = code2ack
    apu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2program4apu = apu2kernel4xi.keys()
    for key2program4apu in keys2program4apu:
        message2print = "{(Step 70/70) returning" + "; key2program4apu-returning-by-release2kernel4apu: " + str(key2program4apu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return apu2kernel4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2kernel4apu" usage = "
#
#   task4retain2kernel  = {} 
#   task4retain2kernel  ['COUNT2REFERENCE'] = 1 
#   response4retain2kernel = {}
#   
#   print('(Step 19A/700) OF APU2KERNEL4XI5TEST - TRYING TO RETAIN PROGRAM OF APU DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4retain2kernel = retain2kernel4apu(task4retain2kernel)
#       print('(Step 19B/700) OF APU2KERNEL4XI5TEST - RETAINED PROGRAM OF APU DEVICE ', time4xi()) 
#   except:
#       print('(Step 19Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO RETAIN PROGRAM OF APU DEVICE ', time4xi())                                                                                                  
#
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def retain2kernel4apu(task4retain2apu=None):

    '''
    retains kernel of APU
    '''
    global apu2kernel4xi 
    global folder2lib4apu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2kernel4apu"
    method2print = "retain2kernel4apu"

    message2print = "{(Step 1A/33) started" + "; retain2kernel4apu-started: " + str(retain2kernel4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function retain2kernel4apu at 0x0000000003B74148>
    
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2apu-to-retain2kernel4apu: " + str(task4retain2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1} 
    
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/70) - PROVIDE TASKS, IF NECESSARY AND CHECK GIVEN TASKS 
    # -----------------------------------------------------------------------------------------    
    if task4retain2apu is None:
        task4retain2apu = {}
        task4retain2apu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 2A/33) set" + "; task4retain2apu-set-by-retain2kernel4apu to: " + str(task4retain2apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    else:
        pass

    
    # -----------------------------------------------------------------------------------------
    # (Step 3/70) - CHECK COUNT2REFERENCE
    # -----------------------------------------------------------------------------------------         
    if 'COUNT2REFERENCE' in task4retain2apu.keys():
        pass
    else:
        task4retain2apu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3A/33) set" + "; count2reference-set-by-retain2kernel4apu to: " + str(task4retain2apu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1 
                                   
    if task4retain2apu['COUNT2REFERENCE'] < 1:
        task4retain2apu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3B/33) set" + "; count2reference-set-by-retain2kernel4apu to: " + str(task4retain2apu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
        
    # -----------------------------------------------------------------------------------------
    # (Step 4/70) - INITIALIZE PROGRAM IF NECESSARY
    # -----------------------------------------------------------------------------------------
    try:
        if apu2kernel4xi is None:
            apu2kernel4xi = create2kernel4apu()
            message2print = "{(Step 4A/70) created" + "; apu2kernel4xi-created-by-retain2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                                          
    except:
        try:
            apu2kernel4xi = create2kernel4apu()
            message2print = "{(Step 4B/70) created" + "; apu2kernel4xi-created-by-retain2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
        except:
            apu2kernel4xi = {}
            message2print = "{(Step 4Z/70) yielded" + "; apu2kernel4xi-yielded-by-retain2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z-' 


    # -----------------------------------------------------------------------------------------
    # (Step 5/70) - RETAIN
    # -----------------------------------------------------------------------------------------             
    try:
        apu2kernel4xi['COUNT2REFERENCE'] = apu2kernel4xi['COUNT2REFERENCE'] + task4retain2apu['COUNT2REFERENCE']
        message2print = "{(Step 6A/70) calculated" + "; count2reference-calculated-by-retain2kernel4apu: " + str(apu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1            
        if apu2kernel4xi['COUNT2REFERENCE'] <= 0:
            apu2kernel4xi['COUNT2REFERENCE'] = 1
            message2print = "{(Step 6Z1/70) warning" + "; count2reference-warning-by-retain2kernel4apu: " + " ** " + str(apu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            code2nack  = code2nack + '6Z1-'
        else:
            code2ack  = code2ack + '6C-'

    except:
        try:
            apu2kernel4xi['COUNT2REFERENCE'] = 1
        
            message2print = "{(Step 7Z1/70) warning" + "; count2reference-warning-by-retain2kernel4apu: " + " ** " + str(apu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '7Z1-'
        
        except:
            message2print = "{(Step 7Z2/70) yielded" + "; apu2kernel4xi-yielded-by-retain2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z2-'
        
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70) - RETURN           
    # -----------------------------------------------------------------------------------------
    
    apu2kernel4xi ['ACK2RETURN']  = code2ack
    apu2kernel4xi ['NACK2RETURN'] = code2nack     
     
    keys2program4apu = apu2kernel4xi.keys()
    for key2program4apu in keys2program4apu:
        message2print = "{(Step 70/70) returning" + "; key2program4apu-returning-by-retain2kernel4apu: " + str(key2program4apu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return apu2kernel4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelinfo4apu" usage = "
#
#   print('(Step 2B1/700) OF APU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFO WITH FUNCTION PASSING NO ARUMENTS FOR APU ', time4xi())     
#   try:
#       response4programinfo2apu = get2kernelinfo4apu()
#       print('(Step 2B2/700) OF APU2KERNEL4XI5TEST - GOT KERNEL INFO WITH FUNCTION PASSING NO ARUMENTS FOR APU ', time4xi())  
#   except:
#       print('(Step 2Z2/700) OF APU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO WITH FUNCTION PASSING NO ARUMENTS FOR APU', time4xi())
#   try:                                                                                          
#       for key2kernel in keys2kernel:
#           print('KEY2KERNEL ', key2kernel)
#           #                 
#   except:
#       print('(Step 2Z3/700) OF APU2KERNEL4XI5TEST *** FAILED TO PRINT response4programinfo2apu: ', response4programinfo2apu)
#       
#   task4getinfo2kernel = {}
#   try:
#       # ---------------------------------------------------------------------------------------------
#       # PHASE I: FUNCTION TESTS - GET SELECTED KERNEL INFO WITH FUNCTION                
#       # ---------------------------------------------------------------------------------------------    
#       print('(Step 3B1/700) OF APU2KERNEL4XI5TEST - TRYING TO GET SELECTED KERNEL INFO FOR APU ', time4xi())     
#       task4getinfo2kernel ['COUNT4BIN'] = 'OK'
#       task4getinfo2kernel ['COUNT4C'] = 'OK'
#       task4getinfo2kernel ['COUNT4CL'] = 'OK'
#       task4getinfo2kernel ['COUNT4CPP'] = 'OK'
#       task4getinfo2kernel ['COUNT4PY'] = 'OK'
#       task4getinfo2kernel ['COUNT4PYC'] = 'OK'
#       task4getinfo2kernel ['COUNT4SOURCE'] = 'OK'
#       task4getinfo2kernel ['DIRECTORY4BIN'] = 'OK'
#       task4getinfo2kernel ['DIRECTORY4C'] = 'OK'
#       task4getinfo2kernel ['DIRECTORY4CL'] = 'OK'
#       task4getinfo2kernel ['DIRECTORY4CPP'] = 'OK'
#       task4getinfo2kernel ['DIRECTORY4PY'] = 'OK'
#       task4getinfo2kernel ['DIRECTORY4PYC'] = 'OK'
#       task4getinfo2kernel ['DIRECTORY4SOURCE'] = 'OK'
#       task4getinfo2kernel ['SIZE4BIN'] = 'OK'
#       task4getinfo2kernel ['SIZE4C'] = 'OK'
#       task4getinfo2kernel ['SIZE4CL'] = 'OK'
#       task4getinfo2kernel ['SIZE4CPP'] = 'OK'
#       task4getinfo2kernel ['SIZE4PY'] = 'OK'
#       task4getinfo2kernel ['SIZE4PYC'] = 'OK'
#   except:
#       print('(Step 3Z2/700) OF APU2KERNEL4XI5TEST *** FAILED TO PREPARE TASK4GETINFO2KERNEL ', task4getinfo2kernel)  
#   
#   try:
#       response4kernelinfo2apu = get2kernelinfo4apu(task4getinfo2kernel) 
#       print('(Step 3B2/700) OF APU2KERNEL4XI5TEST - GOT SELECTED KERNEL INFO FOR APU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF APU2KERNEL4XI5TEST *** FAILED TO GET SELECTED KERNEL INFO FOR APU ', time4xi())                  
#   try:                                                                                          
#       keys2kernel = response4kernelinfo2apu.keys()
#       for key2kernel in sorted(keys2kernel):
#           print('KEY2KERNEL ', key2kernel)
#           # COUNT4BIN
#           # COUNT4C
#           # COUNT4CL
#           # COUNT4CPP
#           # COUNT4PY
#           # COUNT4PYC
#           # COUNT4SOURCE
#           # DIRECTORY4BIN
#           # DIRECTORY4C
#           # DIRECTORY4CL
#           # DIRECTORY4CPP
#           # DIRECTORY4PY
#           # DIRECTORY4PYC
#           # DIRECTORY4SOURCE
#           # SIZE4BIN
#           # SIZE4C
#           # SIZE4CL
#           # SIZE4CPP
#           # SIZE4PY
#           # SIZE4PYC                             
#   except:
#       print('(Step 3Z4/700) OF APU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4KERNELINFO2APU : ', response4kernelinfo2apu)                  
#   
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def get2kernelinfo4apu(task2getkernelinfo4apu=None):

    '''
    gets kernel information of APU
    '''
    
    global apu2kernel4xi
    global folder2lib4apu  

    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelinfo4apu"
    method2print = "get2kernelinfo4apu"

    message2print = "{(Step 0A/33) started" + "; get2kernelinfo4apu-started: " + str(get2kernelinfo4apu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <function get2kernelinfo4apu at 0x00000000044AB048> 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task2getkernelinfo4apu-passed-to-get2kernelinfo4apu: " + str(task2getkernelinfo4apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # None; 
    # {'DIRECTORY4CL': 'OK',
    #  'DIRECTORY4CPP': 'OK',
    #  'COUNT4PYC': 'OK',
    #  'DIRECTORY4BIN': 'OK',
    #  'COUNT4SOURCE': 'OK',
    #  'SIZE4BIN': 'OK',
    #  'SIZE4C': 'OK',
    #  'COUNT4CPP': 'OK',
    #  'DIRECTORY4PYC': 'OK',
    #  'COUNT4PY': 'OK',
    #  'SIZE4CL': 'OK',
    #  'DIRECTORY4SOURCE': 'OK',
    #  'COUNT4CL': 'OK',
    #  'SIZE4PY': 'OK',
    #  'SIZE4PYC': 'OK',
    #  'COUNT4C': 'OK',
    #  'COUNT4BIN': 'OK',
    #  'SIZE4CPP': 'OK',
    #  'DIRECTORY4PY': 'OK',
    #  'DIRECTORY4C': 'OK'}

    
    code2ack  = ' '
    code2nack = ' '    
        
    
    info2kernel4apu = {}
    try: 
        if apu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR APU           
            # -------------------------------------------------------------------------------------           
            info2kernel4apu = create2kernel4apu()
            message2print = "{(Step 1B2/33) initialized" + "; info2kernel4apu-initialized-by-get2kernelinfo4apu to: " + str(info2kernel4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #
            code2ack  = code2ack + '1B2-' 
        else:
            message2print = "{(Step 1B3/33) using" + "; apu2kernel4xi-using-by-get2kernelinfo4apu: " + str(apu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '1B3-'
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE IF NO PARAMETERS           
        # -------------------------------------------------------------------------------------     
        if task2getkernelinfo4apu is None:
            task2getkernelinfo4apu = {}
            info2kernel4apu = apu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; sizeinfo2kernel4apu-using-by-get2kernelinfo4apu: " + str(size(info2kernel4apu))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '1C-'
        else:
            pass    

        keys2task4kernelinfo = task2getkernelinfo4apu.keys()
                    
        # -------------------------------------------------------------------------------------
        # RETURN ACCORDING TO TASK       
        # -------------------------------------------------------------------------------------         
        for key2task4kernelinfo in keys2task4kernelinfo:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task4kernelinfo-using-by-get2kernel4apu: " + str(key2task4kernelinfo)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # DIRECTORY4CL; COUNT4SOURCE
                 
                info2kernel4apu [key2task4kernelinfo] = apu2kernel4xi[key2task4kernelinfo]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-info2kernel4apu-set-by-get2kernelinfo4apu to: " + str(info2kernel4apu [key2task4kernelinfo])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # folder2lib4apu; 2
                
                code2ack  = code2ack + '2D3-'
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task4kernelinfo-yielded-by-get2kernel4apu: " + str(key2task4kernelinfo) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task2getkernelinfo4apu-using-by-get2kernel4apu: " + str(task2getkernelinfo4apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; apu2kernel4xi-using-by-get2kernel4apu: " + str(apu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                code2nack  = code2nack + '2Z3-' 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            info2kernel4apu = create2kernel4apu()
            
            message2print = "{(Step 1F/33) initialized" + "; info2kernel4apu-initialized-by-get2kernelinfo4apu to: " + str(info2kernel4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task2getkernelinfo4apu is None:
                info2kernel4apu = apu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; info2kernel4apu-set-by-get2kernelinfo4apu to: " + str(info2kernel4apu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                code2ack  = code2ack + '1G-' 
            else:
                keys2task = task2getkernelinfo4apu.keys()
                for key2task4kernelinfo in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task4kernelinfo-using-by-get2kernel4apu: " + str(key2task4kernelinfo)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        info2kernel4apu [key2task4kernelinfo] = apu2kernel4xi[key2task4kernelinfo]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-info2kernel4apu -set-by-get2kernelinfo4apu to: " + str(info2kernel4apu  [key2task4kernelinfo])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #
                        code2ack  = code2ack + 'HD2-'   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task4kernelinfo-yielded-by-get2kernel4apu: " + str(key2task4kernelinfo) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + 'HZ-'                                                    
        except:
            info2kernel4apu = {}
            message2print = "{(Step 1Z3/70) yielded" + "; info2kernel4apu-yielded-by-get2kernel4apu: " + str(info2kernel4apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            
            code2nack  = code2nack + '1Z3-'            
     
    keys2info4kernel = info2kernel4apu.keys()
    for key2info4kernel in sorted(keys2info4kernel):
        message2print = "{(Step 70/70) returning" + "; key2info4kernel-returning-by-get2kernelinfo4apu: " + str(key2info4kernel) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        #1(ALL)
        # ACK2RETURN
        # BUFFER
        # CODE2ERROR
        # 
        # CODE4BIN
        # CODE4C
        # CODE4CL
        # CODE4CPP
        # CODE4PY
        # CODE4PYC
        # 
        # COMMANDQUEUE
        # CONTEXT
        # COUNT2REFERENCE
        # 
        # COUNT4BIN
        # COUNT4C
        # COUNT4CL
        # COUNT4CPP
        # COUNT4PY
        # COUNT4PYC
        # COUNT4SOURCE
        # 
        # DATA2CALLBACK
        # DEVICE
        # 
        # DIRECTORY4BIN
        # DIRECTORY4C
        # DIRECTORY4CL
        # DIRECTORY4CPP
        # DIRECTORY4PY
        # DIRECTORY4PYC
        # DIRECTORY4SOURCE
        # 
        # EVENT
        # FUNCTION
        # FUNCTION2CALLBACK
        # LANGUAGE
        # NACK2RETURN
        # PIPE
        # PLATFORM
        # PROGRAM
        # QUEUE
        # 
        # SIZE4BIN
        # SIZE4C
        # SIZE4CL
        # SIZE4CPP
        # SIZE4PY
        # SIZE4PYC
        # 
        #2(selected ones only)
        # COUNT4BIN
        # COUNT4C
        # COUNT4CL
        # COUNT4CPP
        # COUNT4PY
        # COUNT4PYC
        # COUNT4SOURCE
        # DIRECTORY4BIN
        # DIRECTORY4C
        # DIRECTORY4CL
        # DIRECTORY4CPP
        # DIRECTORY4PY
        # DIRECTORY4PYC
        # DIRECTORY4SOURCE
        # SIZE4BIN
        # SIZE4C
        # SIZE4CL
        # SIZE4CPP
        # SIZE4PY
        # SIZE4PYC        
        
    return info2kernel4apu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelarginfo4apu" usage = "
#
#   # -----------------------------------------------------------------------------------------------------
#   # NO PARAMETERS
#   # -----------------------------------------------------------------------------------------------------
#   print('(Step 20A/700) OF APU2KERNEL4XI5TEST - TRYING TO GET ARG INFO FOR KERNEL OF APU DEVICE ', time4xi())                                                                                                            
#   try: 
#       response4getarginfo2kernel = get2kernelarginfo4apu()
#       print('(Step 20B/700) OF APU2KERNEL4XI5TEST - GOT ARG INFO FOR KERNEL OF APU DEVICE ', time4xi())
#   except:
#       print('(Step 20Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO GET ARG INFO FOR KERNEL OF APU DEVICE ', time4xi())  
#   try:                    
#       keys2response = response4getarginfo2kernel.keys()
#       print('(Step 20C/700) OF APU2KERNEL4XI5TEST - PRINT KERNEL ARGUMENTS - KEYS ARE: ', keys2response)
#       # dict_keys([0, 1, 2])                                                                                                          
#   except:
#       print('(Step 20Z2/700) OF APU2KERNEL4XI5TEST *** FAILED TO PRINT KERNEL ARGUMENT KEYS: ', time4xi())  
#   # -----------------------------------------------------------------------------------------------------
#   # SECOND ARGUMENT ONLY 
#   # -----------------------------------------------------------------------------------------------------            
#   task4getinfo2kernel = {}
#   task4getinfo2kernel [1] = 'Yes'            
#    
#   print('(Step 20E/700) OF APU2KERNEL4XI5TEST - TRYING TO GET SECOND ARG INFO FOR KERNEL OF APU DEVICE ', time4xi())                                                                                                            
#   try: 
#       response4getarginfo2kernel = get2kernelarginfo4apu(task4getinfo2kernel)
#       print('(Step 20F/700) OF APU2KERNEL4XI5TEST - GOT ARG SECOND INFO FOR KERNEL OF APU DEVICE ', time4xi())
#   except:
#       print('(Step 20Z3/700) OF APU2KERNEL4XI5TEST *** FAILED TO GET SECOND ARG INFO FOR KERNEL OF APU DEVICE ', time4xi())  
#   try:                    
#       keys2response = response4getarginfo2kernel.keys()
#       print('(Step 20G/700) OF APU2KERNEL4XI5TEST - PRINT SECOND KERNEL ARGUMENTS - KEYS ARE: ', keys2response)
#       # dict_keys([1])                                                                                                         
#   except:
#       print('(Step 20Z4/700) OF APU2KERNEL4XI5TEST *** FAILED TO PRINT SECOND KERNEL ARGUMENT KEYS: ', time4xi())
#                                  
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def get2kernelarginfo4apu(task4getinfo2kernel=None):

    '''
    gets kernel argument information of APU
    '''
    
    global apu2kernel4xi
    global folder2lib4apu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelarginfo4apu"
    method2print = "get2kernelarginfo4apu"

    message2print = "{(Step 0A/33) started" + "; get2kernelarginfo4apu-started: " + str(get2kernelarginfo4apu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <function get2kernelarginfo4apu at 0x0000000003D5C6C8>
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelarginfo4apu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # None; {1: 'Yes'}

    code2ack  = ' '
    code2nack = ' '    
    
    response2arg4apu = {}
    
    if apu2kernel4xi is None:
        # -------------------------------------------------------------------------------------
        # KERNEL FOR APU DOES NOT EXIST      
        # -------------------------------------------------------------------------------------      
        response4create2kernel = {}
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE APU2KERNEL4XI      
            # -------------------------------------------------------------------------------------           
            response4create2kernel = create2kernel4apu()
            message2print = "{(Step 1A/33) initialized" + "; response4create2kernel-initialized-by-get2kernelarginfo4apu to: " + str(response4create2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #
            code2ack  = code2ack + '1A-' 
        except:
            message2print = "{(Step 1Z1/70) failed" + "; response4create2kernel-failed-by-get2kernel4apu: " + str(response4create2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                               
            #               
        try:    
            apu2kernel4xi['ARG'] = {}
            message2print = "{(Step 1B/33) initialized" + "; argapu2kernel-initialized-by-get2kernelarginfo4apu to: " + str(apu2kernel4xi['ARG'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '1B-'
        except:
            message2print = "{(Step 1Z2/70) yielded" + "; apu2kernel4xi-yielded-by-get2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                               
            #                        
            code2nack  = code2nack + '1Z2-'
            
    keys2kernel4apu = apu2kernel4xi.keys()
    message2print = "{(Step 2A/33) using" + "; keys2kernel4apu-using-by-get2kernelarginfo4apu: " + str(keys2kernel4apu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # ['DIRECTORY4CL',
    #  'CODE4PY',
    #  'COUNT4CPP',
    #  'DIRECTORY4PYC',
    #  'QUEUE',
    #  'PROGRAM',
    #  'CONTEXT',
    #  'DIRECTORY4PY',
    #  'DIRECTORY4C',
    #  'PIPE',
    #  'SIZE4PY',
    #  'COUNT4PYC',
    #  'CODE4C',
    #  'DIRECTORY4BIN',
    #  'COUNT4SOURCE',
    #  'FUNCTION2CALLBACK',
    #  'CODE4CL',
    #  'COMMANDQUEUE',
    #  'PLATFORM',
    #  'COUNT4C',
    #  'FUNCTION',
    #  'CODE2ERROR',
    #  'ACK2RETURN',
    #  'DATA2CALLBACK',
    #  'BUFFER',
    #  'CODE4PYC',
    #  'CODE4CPP',
    #  'SIZE4CL',
    #  'COUNT4CL',
    #  'COUNT2REFERENCE',
    #  'DEVICE',
    #  'SIZE4CPP',
    #  'LANGUAGE',
    #  'ARG',
    #  'SIZE4PYC',
    #  'DIRECTORY4CPP',
    #  'SIZE4BIN',
    #  'SIZE4C',
    #  'DIRECTORY4SOURCE',
    #  'COUNT4PY',
    #  'NACK2RETURN',
    #  'COUNT4BIN',
    #  'CODE4BIN',
    #  'EVENT'])
    
    try: 
        
        if 'ARG' in keys2kernel4apu:
            
            message2print = "{(Step 2B/33) using" + "; arg2kernel4apu-using-by-get2kernelarginfo4apu: " + str('ARG') + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #
            
        else:
            
            # -------------------------------------------------------------------------------------
            # INITIALIZE ARGUMENTS     
            # -------------------------------------------------------------------------------------
            apu2kernel4xi['ARG'] = {}     
            
            message2print = "{(Step 2D/33) initialized" + "; argapu2kernel-initialized-by-get2kernelarginfo4apu to: " + str(apu2kernel4xi['ARG'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #
            
            
            code2ack  = code2ack + '2D-' 
            
    except:
        message2print = "{(Step 2Z1/70) yielded" + "; apu2kernel4xi-yielded-by-get2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                               
        # 
        code2nack  = code2nack + '2Z1-'
      
    try:
             
        if task4getinfo2kernel is None:
            # -------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN - TRY TO RETURN ALL ARGUMENTS (IF ANY)      
            # -------------------------------------------------------------------------------------     
            task4getinfo2kernel = {}
            
            try:
                
                if 'ARG' in keys2kernel4apu:
                    
                    task4getinfo2kernel = apu2kernel4xi['ARG']
                    message2print = "{(Step 3A/33) set" + "; arg4getinfo2kernel-set-by-get2kernelarginfo4apu to: " + str('ARG')  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #
                    code2ack  = code2ack + '3A-'
                    
                else:
                    pass 
                                        
     
            except:
                message2print = "{(Step 3Z1/70) yielded" + "; task4getinfo2kernel-yielded-by-get2kernel4apu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                code2nack  = code2nack + '3Z1-'
    except:
        message2print = "{(Step 3Z2/70) yielded" + "; apu2kernel4xi-yielded-by-get2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                               
        # 
        code2nack  = code2nack + '3Z2-'
      
    try:            
        keys2task = task4getinfo2kernel.keys()                                                    # 0,1,2 ...
        # -------------------------------------------------------------------------------------
        # ARG KERNEL INFO OF APU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 4A/33) using" + "; key2task-using-by-get2kernel4apu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 0, 1, 2
                # 1     
                response2arg4apu [key2task] = apu2kernel4xi ['ARG'] [key2task]
                    
                message2print = "{(Step 4B/33) set" + "; response2arg4apu-set-by-get2kernelarginfo4apu to: " + str(response2arg4apu [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'CODE2ERROR': 0 ...
                # {'PIPE': ...
                # {'CODE2ERROR': 0 ...
                code2ack  = code2ack + '4B-'
                    
            except:
                message2print = "{(Step 4Z1/70) yielded" + "; key2task-yielded-by-get2kernel4apu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                       
                message2print = "{(Step 4Z2/70) using" + "; apu2kernel4xi-using-by-get2kernel4apu: " + str(apu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
    except:
        message2print = "{(Step 4Z3/70) yielded" + "; apu2kernel4xi-yielded-by-get2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                               
        # 
        code2nack  = code2nack + '4Z3-'    
    try:
    
        keys2response4apu = response2arg4apu.keys()
        for key2response4apu in keys2response4apu:
            message2print = "{(Step 70/70) returning" + "; key2response4apu-returning-by-get2kernelarginfo4apu: " + str(key2response4apu) + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)
            # 0,1,2 
        code2ack  = code2ack + '70-'    
    except:
        message2print = "{(Step 70Z1/70) yielded" + "; apu2kernel4xi-yielded-by-get2kernel4apu: " + str(apu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                               
        # 
        code2nack  = code2nack + '70Z1-'       
    try:
        return response2arg4apu
    except:
        return {}
                 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2buildinfo4apu" usage = "
#
#   response4get2buildinfo = get2buildinfo4apu()
#            
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def get2buildinfo4apu(task4getinfo2build=None):

    '''
    gets apu2build4xi and apu2build4xi
    '''
    
    global apu2build4xi
    global folder2lib4apu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2buildinfo4apu"
    method2print = "get2buildinfo4apu"

    message2print = "{(Step 0A/33) started" + "; get2buildinfo4apu-started: " + str(get2buildinfo4apu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2build-passed-to-get2buildinfo4apu: " + str(task4getinfo2build) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    apu2build = {}
    try: 
        if apu2build4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR APU           
            # -------------------------------------------------------------------------------------           
            apu2build = {}
            message2print = "{(Step 1B2/33) initialized" + "; apu2build-initialized-by-get2buildinfo4apu to: " + str(apu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; apu2build4xi-using-by-get2buildinfo4apu: " + str(apu2build4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF APU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2build is None:
            task4getinfo2build = {}
            apu2build = apu2build4xi
            message2print = "{(Step 1C/33) using" + "; apu2build-got-by-get2buildinfo4apu: " + str(apu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4buildinfo = task4getinfo2build.keys()
        keys2task = task4getinfo2build.keys()
            
        # -------------------------------------------------------------------------------------
        # BUILD INFO OF APU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2build4apu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                apu2build [key2task] = apu2build4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-apu2build-set-by-get2buildinfo4apu to: " + str(apu2build [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2build4apu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2build-using-by-get2build4apu: " + str(task4getinfo2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; apu2build4xi-using-by-get2build4apu: " + str(apu2build4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE BUILD           
            # -------------------------------------------------------------------------------------           
            apu2build = {}
            message2print = "{(Step 1F/33) initialized" + "; apu2build-initialized-by-get2buildinfo4apu to: " + str(apu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2build is None:
                apu2build = apu2build4xi
                message2print = "{(Step 1G/33) set" + "; apu2build-set-by-get2buildinfo4apu to: " + str(apu2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2build.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2build4apu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        apu2build [key2task] = apu2build4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-apu2build -set-by-get2buildinfo4apu to: " + str(apu2build  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2build4apu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            apu2build = {}
            message2print = "{(Step 1Z3/70) yielded" + "; apu2build-yielded-by-get2build4apu: " + str(apu2build) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; apu2build-returning-by-get2buildinfo4apu: " + str(apu2build) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
    
    return apu2build
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelworkgroupinfo4apu" usage = "
#     
#   print('(Step 2AB2/700) OF APU2KERNEL4XI5TEST - TRYING TO GET KERNEL WORK GROUP INFORMATION ', time4xi())           
#   try:
#       response4link = get2kernelworkgroupinfo4apu()
#       print('(Step 2BB2/700) OF APU2KERNEL4XI5TEST - GOT KERNEL WORK GROUP INFORMATION ', time4xi()) 
#   except:
#       print('(Step 2Z2/700) OF APU2KERNEL4XI5TEST *** FAILED TO KERNEL WORK GROUP INFORMATION ', time4xi())                                                                     
#          
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def get2kernelworkgroupinfo4apu(task4kernelworkgroupinfo2apu=None):

    '''
    gets kernel workgroup info of APU
    '''
    global apu2kernel4xi                                                                                            # Kernel of APU    
    global import2use4apu                                                                                           # Imports of APU
    global target2function4apu                                                                                      # Target function of Process4Xi
    global folder2lib4apu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelworkgroupinfo4apu" 
    method2print = "get2kernelworkgroupinfo4apu"

    message2print = "{(Step 1A/70) started" + "; get2kernelworkgroupinfo4apu-started: " + str(get2kernelworkgroupinfo4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernelworkgroupinfo2apu-to-get2kernelworkgroupinfo4apu: " + str(task4kernelworkgroupinfo2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    process2kernelworkgroupinfo4apu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernelworkgroupinfo2apu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernelworkgroupinfo2apu-yielded-by-get2kernelworkgroupinfo4apu: " + str(task4kernelworkgroupinfo2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - LINK SOURCES INSIDE PROGRAM OBJECT FOR APU ! 
    # ---------------------------------------------------------------------------------------------    
    process2kernelworkgroupinfo4apu = {}                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; process2kernelworkgroupinfo4apu-initialized-by-get2kernelworkgroupinfo4apu to: " + str(process2kernelworkgroupinfo4apu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}

    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                  
        # ---------------------------------------------------------------------------------------------             
        keys2code4apu = apu2kernel4xi['CODE4SOURCE'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2code4apu-using-by-get2kernelworkgroupinfo4apu: " + str(keys2code4apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # dict_keys([folder2lib4apu + 'apu2sampler4xi5test.py'])
        
        unit4processing = "apu"
        
        for key2code4apu in keys2code4apu:
            index2search=str.find(key2code4apu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2link = key2code4apu[index2search:]                                                          # apu2sampler4xi5test.py
                index2search=str.find(target2link,".py")
                if index2search == -1:
                    pass
                else:
                    target2link4apu = target2link[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2link4apu-set-by-get2kernelworkgroupinfo4apu to: " + str(target2link4apu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # apu2sampler4xi5test

                    p2code4apu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4APU 
                        # ---------------------------------------------------------------------------------------------    
      
                        try:
                            import2use4apu.get(target2link4apu, handle2error4apu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2link4apu-imported-by-get2kernelworkgroupinfo4apu: " + str(target2link4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # apu2sampler4xi5test
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4apu-failed-by-get2kernelworkgroupinfo4apu: " + str(import2use4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2link4apu-used-by-get2kernelworkgroupinfo4apu: " + str(target2link4apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4APU
                        # ---------------------------------------------------------------------------------------------                          
                        p2apu = Process4Xi(target=target2function4apu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2apu-created-by-get2kernelworkgroupinfo4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-2, initial)>
                        
                        process2kernelworkgroupinfo4apu[key2code4apu] = p2apu
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2apu.start()
                            message2print = "{(Step 34A/70) started" + "; p2apu-started-by-get2kernelworkgroupinfo4apu: " + str(p2apu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-2
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4apu = p2apu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-get2kernelworkgroupinfo4apu: " + str(status2process4apu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2apu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2apu-run-by-get2kernelworkgroupinfo4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-get2kernelworkgroupinfo4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-get2kernelworkgroupinfo4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-get2kernelworkgroupinfo4apu: " + str(p2apu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2code4apu-failed-by-get2kernelworkgroupinfo4apu: " + str(p2code4apu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    

 
        message2print = "{(Step 38A/70) set" + "; process2kernelworkgroupinfo4apu-set-by-get2kernelworkgroupinfo4apu to: " + str(process2kernelworkgroupinfo4apu)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; code-yielded-by-get2kernelworkgroupinfo4apu: " + str(apu2kernel4xi['CODE4SOURCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2kernel4xi ['ACK2RETURN']  = code2ack
    apu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; process2kernelworkgroupinfo4apu-returning-by-get2kernelworkgroupinfo4apu: " + str(process2kernelworkgroupinfo4apu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 
    return process2kernelworkgroupinfo4apu
            
#</function4xi> 
 
                                        
# =================================================================================================
#<class4xi class = "APU2Kernel4Xi" base = "object" child = "None"
#       synopsis = "offers  methods for APU" usage = "OpenCL APU"
#>
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# =================================================================================================
class APU2Kernel4Xi(object): 
    ''' 
    APU2Kernel4Xi offers  methods for APU program
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2apu = cpu_corecount4xi()
    #"
    #/>
       
       
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'add2kernel',                      # ACK              

            'execute2kernel',                  # ACK 5.8    p169                                             
            'execute2task',                    # ACK 5.8    p172   
            'execute2nativekernel',            # ACK 5.8    p174     
            
            'create2kernel',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram',         # ACK 5.7.1  p158  
                       
            'delete2kernel',                   # ACK

            'fetch2kernel',                    # ACK 
            
            'get2kernelinfo',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo',         # ACK 5.7.3  p164  
            'get2kernelarginfo',               # ACK 5.7.3  p166                                  
            
            'release2kernel',                  # ACK 5.7.1  p159                                         
            'retain2kernel',                   # ACK 5.7.1  p159   
 
            'set2kernel',                      # ACK 
            'set2kernelcallback',              # ACK 
            'set2kernelarg',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel',                    # ACK 
            
            'sense',                           # ACK
            'reason',                          # ACK
            'ace')                             # ACK   
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-APU2Kernel4Xi" usage = "
    # 
    #   print('(Step 110A/700) OF APU2KERNEL4XI5TEST - CREATING KERNEL OBJECT OF APU ', time4xi())        
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                  
    #       # ---------------------------------------------------------------------------------------------        
    #       kernelobject2apu = APU2Kernel4Xi()
    #       print('(Step 110B/700) OF APU2KERNEL4XI5TEST - CREATED KERNEL OBJECT OF APU: ', kernelobject2apu)                                  
    #       # 
    #   except:
    #       print('(Step 110Z/700) OF APU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL OBJECT OF APU') 
    # 
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4kernel2apu = None):
        '''
        _init__ method initializes APU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "APU2Kernel4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-APU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 07:45:55 03/09/12 Pacific Standard Time

        message2print = "{(Step 1B/33) borning" + "; apu2kernel2xi-of-APU2Kernel4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 07:45:55 03/09/12 Pacific Standard Time
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-apu2kernel2xi-of-APU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2apu-sharing-by-apu2kernel2xi-of-APU2Kernel4Xi: " + str(APU2Kernel4Xi.classvariable2apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4        
                                
        message2print = "{(Step 1E/33) passed" + "; task4kernel2apu-passed-to-init-of-APU2Kernel4Xi: " + str(task4kernel2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                      
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
    
        message2print = "{(Step 2A/33) passing" + "; task4kernel2apu-passing-to-create2kernel4apu-by-init-of-APU2Kernel4Xi: " + str(task4kernel2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
                
        apu2kernel2xi = create2kernel4apu(task4kernel2apu)
        
        message2print = "{(Step 2B/33) performed" + "; create2kernel4apu-performed-by-init-of-APU2Kernel4Xi: " + str(create2kernel4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2kernel4apu at 0x00000000041E54C8>
       
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; apu2kernel2xi-of-APU2Kernel4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 07:45:56 03/09/12 Pacific Standard Time
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-apu2kernel2xi-of-APU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2apu-shared-by-apu2kernel2xi-of-APU2Kernel4Xi: " + str(APU2Kernel4Xi.classvariable2apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4     
       
        message2print = "{(Step 3D/33) returning" + "; init-of-APU2Kernel4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 07:45:56 03/09/12 Pacific Standard Time
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "add2kernel-of-APU2Kernel4Xi" usage = "
    #  
    #   print('(Step 2A3/700) OF APU2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO KERNEL OBJECT WITH METHOD ', time4xi())          
    #   try:
    #       task4add2kernel = {}
    #       task4add2kernel ['CODE4PY'] = {}
    #       task4add2kernel ['CODE4PY'] [folder2lib4apu + 'apu2dummy4xi.py'] = {}
    #       task4add2kernel ['CODE4PY'] [folder2lib4apu + 'apu2dummy4xi.py'] [1] = '#<profile4xi profile = "33" />\n'
    #       task4add2kernel ['CODE4PY'] [folder2lib4apu + 'apu2dummy4xi.py'] [2] = '#<program4xi program = "apu2dummy4xi.py" />\n'
    #       task4add2kernel ['SIZE4PY'] = {}
    #       task4add2kernel ['SIZE4PY'] [folder2lib4apu + 'apu2dummy4xi.py'] = len(task4add2kernel ['CODE4PY'] [folder2lib4apu + 'apu2dummy4xi.py'])
    #       
    #       task4add2kernel ['CODE4CPP'] = {}
    #       task4add2kernel ['CODE4CPP'] [folder2lib4apu + 'apu2dummy4xi.cpp'] = {}
    #       task4add2kernel ['CODE4CPP'] [folder2lib4apu + 'apu2dummy4xi.cpp'] [1] = '//<profile4xi profile = "33" />\n'
    #       task4add2kernel ['CODE4CPP'] [folder2lib4apu + 'apu2dummy4xi.cpp'] [2] = '//<program4xi program = "apu2dummy4xi.cpp" />\n'
    #       task4add2kernel ['SIZE4CPP'] = {}
    #       task4add2kernel ['SIZE4CPP'] [folder2lib4apu + 'apu2dummy4xi.cpp'] = len(task4add2kernel ['CODE4CPP'] [folder2lib4apu + 'apu2dummy4xi.cpp'])                        
    #       
    #       task4add2kernel ['CODE4CL'] = {}
    #       task4add2kernel ['CODE4CL'] [folder2lib4apu + 'apu2dummy4xi.cl'] = {}
    #       task4add2kernel ['CODE4CL'] [folder2lib4apu + 'apu2dummy4xi.cl'] [1] = '__kernel void simple( __global float* A) {\n'
    #       task4add2kernel ['CODE4CL'] [folder2lib4apu + 'apu2dummy4xi.cl'] [2] = '    int tid = get_global_id(0);/>\n'
    #       task4add2kernel ['SIZE4CL'] = {}
    #       task4add2kernel ['SIZE4CL'] [folder2lib4apu + 'apu2dummy4xi.cl'] = len(task4add2kernel ['CODE4CL'] [folder2lib4apu + 'apu2dummy4xi.cl'])    
    #       
    #       task4add2kernel ['CODE4BIN'] = {}
    #       dir2bin4apu = folder2lib4apu + 'bin//'
    #       key2bin4apu = dir2bin4apu + 'apu2dummy4xi.exe'
    #       task4add2kernel ['CODE4BIN'] [key2bin4apu] = {}
    #       task4add2kernel ['CODE4BIN'] [key2bin4apu] [1] = '<assemblyIdentity version="04.17.11" processorArchitecture="x86" name="apu2dummy4xi" type="win32"></assemblyIdentity>\n'
    #       task4add2kernel ['CODE4BIN'] [key2bin4apu] [2] = '<description>Dummy for Binary</description>\n'
    #       task4add2kernel ['SIZE4BIN'] = {}
    #       task4add2kernel ['SIZE4BIN'] [key2bin4apu] = len(task4add2kernel ['CODE4BIN'] [key2bin4apu]) 
    #       
    #       task4add2kernel ['CODE4C'] = {}
    #       task4add2kernel ['CODE4C'] [folder2lib4apu + 'apu2dummy4xi.c'] = {}
    #       task4add2kernel ['CODE4C'] [folder2lib4apu + 'apu2dummy4xi.c'] [1] = 'const char *sum_kernel_code =\n'
    #       task4add2kernel ['CODE4C'] [folder2lib4apu + 'apu2dummy4xi.c'] [2] = '__kernel void compute_sum(__global int *a, int n, __local long *tmp_sum, __global long *sum)\n'
    #       task4add2kernel ['SIZE4C'] = {}
    #       task4add2kernel ['SIZE4C'] [folder2lib4apu + 'apu2dummy4xi.c'] = len(task4add2kernel ['CODE4C'] [folder2lib4apu + 'apu2dummy4xi.c'])    
    #                                                                                                              
    #       response4add2kernel = programobject2apu.add2kernel(task4add2kernel)
    #       print('(Step 2A4/700) OF APU2KERNEL4XI5TEST - ADDED KERNEL INTO KERNEL OBJECT WITH METHOD ', response4add2kernel)
    #       # DIRECTORY4CL
    #       # CODE4PY
    #       # ...                                                                  
    #   except:
    #       print('(Step 2Z3/700) OF APU2KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH METHOD ', time4xi())
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def add2kernel(self, task4add2kernel = None):
        '''
        adds kernel to APU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "add2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; add2kernel-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4add2kernel-passed-to-add2kernel-of-APU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4add2kernel-passing-to-add2kernel4apu-by-add2kernel-of-APU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4add2kernel = add2kernel4apu(task4add2kernel)

        message2print = "{(Step 2B/33) performed" + "; add2kernel4apu-performed-by-add2kernel-of-APU2Kernel4Xi: " + str(add2kernel4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4add2kernel-returning-by-add2kernel-of-APU2Kernel4Xi: " + str(response4add2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4add2kernel
                                
                            
    #</methodize4xi>    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2task-of-APU2Kernel4Xi" usage = "
    # 
    #   print('(Step 240A/700) OF APU2KERNEL4XI5TEST - TRYING TO EXECUTE TASK OF APU WITH METHOD ', time4xi())    
    #   try:                               
    #       response4execute2task = programobject2apu.execute2task() 
    #       print('(Step 240B/700) OF APU2KERNEL4XI5TEST - EXECUTED TASK OF APU WITH METHOD ', time4xi())
    #   except:
    #       print('(Step 240Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO EXECUTE TASK OF APU WITH METHOD ', time4xi())
    #                     
    #">   
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def execute2task(self, task4execute = None):
        '''
        executes task of kernel of APU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "execute2task"
                     
        message2print = "{(Step 1A/33) started" + "; execute2task-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute-passed-to-create-of-APU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute-passing-to-execute2task4apu-by-execute2task-of-APU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        apu2program2xi = execute2task4apu(task4execute)

        message2print = "{(Step 2B/33) performed" + "; execute2task4apu-performed-by-execute2task-of-APU2Kernel4Xi: " + str(execute2task4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; apu2program2xi-returning-by-execute2task-of-APU2Kernel4Xi: " + str(apu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return apu2program2xi
                     
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2nativekernel-of-APU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121A1/700) OF APU2KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL OF APU ', time4xi())      
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # COMPILE                        
    #       # ---------------------------------------------------------------------------------------------        
    #       response4compile = executeobject2apu.execute2nativekernel()
    #       print('(Step 121A2/700) OF APU2KERNEL4XI5TEST - EXECUTED KERNEL OF APU', time4xi())                                   
    #   except:
    #       print('(Step 121AZ1/700) OF APU2KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL OF APU', time4xi())   
    #                     
    #">   
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def execute2nativekernel(self, task4execute2kernel = None):
        '''
        executes native kernel of APU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "execute2nativekernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2nativekernel-of-APU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 08:17:31 03/09/12 Pacific Standard Time
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-create-of-APU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2nativekernel4apu-by-execute2nativekernel-of-APU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # None
  
        apu2execute2xi = execute2nativekernel4apu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2nativekernel4apu-performed-by-execute2nativekernel-of-APU2Kernel4Xi: " + str(execute2nativekernel4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; apu2execute2xi-returning-by-execute2nativekernel-of-APU2Kernel4Xi: " + str(apu2execute2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return apu2execute2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelworkgroupinfo-of-APU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121C1/700) OF APU2KERNEL4XI5TEST - TRYING TO GET WORK GROUP INFOR OF APU WITH METHOD ', time4xi())      
    #   try:
    #      
    #       response4getworkgroupinfo = programobject2apu.get2kernelworkgroupinfo()
    #       print('(Step 121C2/700) OF APU2KERNEL4XI5TEST - GOT WORK GROUP INFOR OF APU WITH METHOD ', time4xi())                                   
    #   except:
    #       print('(Step 121CZ1/700) OF APU2KERNEL4XI5TEST *** FAILED TO GET WORK GROUP INFOR OF APU WITH METHOD ', time4xi())  
    #                     
    #">   
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def get2kernelworkgroupinfo(self, task4getworkgroupinfo = None):
        '''
        get kernel work group info OF APU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "get2kernelworkgroupinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelworkgroupinfo-of-APU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4getworkgroupinfo-passed-to-create-of-APU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4getworkgroupinfo-passing-to-get2kernelworkgroupinfo4apu-by-get2kernelworkgroupinfo-of-APU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        apu2program2xi = get2kernelworkgroupinfo4apu(task4getworkgroupinfo)

        message2print = "{(Step 2B/33) performed" + "; get2kernelworkgroupinfo4apu-performed-by-get2kernelworkgroupinfo-of-APU2Kernel4Xi: " + str(get2kernelworkgroupinfo4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; apu2program2xi-returning-by-get2kernelworkgroupinfo-of-APU2Kernel4Xi: " + str(apu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return apu2program2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernel-of-APU2Kernel4Xi" usage = "
    # 
    #   print('(Step 190A/700) OF APU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR APU ', time4xi()) 
    #   try:
    #       kernelobject2apu = APU2Kernel4Xi()                            
    #       response4create2kernel = kernelobject2apu.create2kernel()
    #       print('(Step 190B/700) OF APU2KERNEL4XI5TEST - CREATED KERNEL FOR APU ', time4xi())
    #   except:
    #       print('(Step 190Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR APU ', time4xi())                                    
    #           
    #">   
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def create2kernel(self, task4kernel2create = None):
        '''
        create2kernel method creates kernel objects of APU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "create2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernel-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # <function create2kernel4apu at 0x00000000044AF348> 
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-APU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernel4apu-by-create2kernel-of-APU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # None 
  
        apu2kernel2xi = create2kernel4apu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernel4apu-performed-by-create2kernel-of-APU2Kernel4Xi: " + str(create2kernel4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernel4apu at 0x00000000044AF348> 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        keys2response4create = apu2kernel2xi.keys() 
        message2print = "{(Step 33A/33) returning" + "; keys2response4create-returning-by-create2kernel-of-APU2Kernel4Xi: " + str(keys2response4create) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # ['FUNCTION',
        #  'CODE2ERROR',
        #  'COUNT2REFERENCE',
        #  'DATA2CALLBACK',
        #  'BUFFER',
        #  'FUNCTION2CALLBACK',
        #  'ACK2RETURN',
        #  'QUEUE',
        #  'PLATFORM',
        #  'PROGRAM',
        #  'NACK2RETURN',
        #  'CONTEXT',
        #  'COMMANDQUEUE',
        #  'DEVICE',
        #  'EVENT',
        #  'PIPE']
        message2print = "{(Step 33B/33) returning" + "; function-returning-by-create2kernel-of-APU2Kernel4Xi: " + str(apu2kernel2xi['FUNCTION']) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # {'.py': {'apu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}
        
        return apu2kernel2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernelsinprogram-of-APU2Kernel4Xi" usage = "
    # 
    #   print('(Step 130A/700) OF APU2KERNEL4XI5TEST - CREATING KERNELS IN PROGRM FOR APU ', time4xi())      
    #   try:
    #       response4create2kernelsinprogram = kernelobject2apu.create2kernelsinprogram()
    #       print('(Step 130A/700) OF APU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRM FOR APU ', time4xi())
    #   except:
    #       print('(Step 130Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO KERNELS IN PROGRM FOR APU', time4xi())
    #                     
    #">   
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def create2kernelsinprogram(self, task4kernel2create = None):
        '''
        creates kernels in program of APU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "create2kernelsinprogram"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernelsinprogram-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-APU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernelsinprogram4apu-by-create2kernelsinprogram-of-APU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        apu2kernel2xi = create2kernelsinprogram4apu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernelsinprogram4apu-performed-by-create2kernelsinprogram-of-APU2Kernel4Xi: " + str(create2kernelsinprogram4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernelsinprogram4apu at 0x00000000040248C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; apu2kernel2xi-returning-by-create2kernelsinprogram-of-APU2Kernel4Xi: " + str(apu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return apu2kernel2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delete2kernel-of-APU2Kernel4Xi" usage = "
    #  
    #   print('(Step 134A/700) OF APU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL IN PROGRAM OF APU WITH METHOD ', time4xi())        
    #   try:
    #       task4delete2kernel = {}
    #       task4delete2kernel ['CODE4KERNEL'] = {}
    #       task4delete2kernel ['CODE4KERNEL'] [folder2lib4apu + 'dummy3image4xi..py'] = 'Yes'
    #       task4delete2kernel ['SIZE4KERNEL'] = {}
    #       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4apu + 'dummy3image4xi..py'] = 'Yes'
    #       
    #       response4delete2kernel = programobject2apu.delete2kernel(task4delete2kernel)
    #       print('(Step 134B/700) OF APU2KERNEL4XI5TEST - DELETED DELETE KERNEL IN PROGRAM of APUWITH METHOD ', time4xi())                                                                  
    #   except:
    #       print('(Step 134Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO DELETE DELETE KERNEL IN PROGRAM OF APU WITH METHOD *** ', time4xi())
    #                  
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def delete2kernel(self, task4delete2kernel = None):
        '''
        deletes kernel in program of APU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "delete2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; delete2kernel-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4delete2kernel-passed-to-delete2kernel-of-APU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4delete2kernel-passing-to-delete2kernel4apu-by-delete2kernel-of-APU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4delete2kernel = delete2kernel4apu(task4delete2kernel)

        message2print = "{(Step 2B/33) performed" + "; delete2kernel4apu-performed-by-delete2kernel-of-APU2Kernel4Xi: " + str(delete2kernel4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4delete2kernel-returning-by-delete2kernel-of-APU2Kernel4Xi: " + str(response4delete2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4delete2kernel
                                
                            
    #</methodize4xi>    


        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernel-of-APU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernel ...
    #   print('(Step 158A/700) OF APU2KERNEL4XI5TEST - TRYING TO SET KERNEL OF APU: ', time4xi()) 
    #   try: 
    #       response4set2kernel = kernelobject2apu.set2kernel(task4set2kernel)
    #       print('(Step 158B/700) OF APU2KERNEL4XI5TEST - SET KERNEL OF APU: ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO SET KERNEL OF APU: ', time4xi())
    #       
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def set2kernel(self, task4set2kernel = None):
        '''
        sets kernel APU objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "set2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernel-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernel-passed-to-set2kernel-of-APU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernel-passing-to-set2kernel4apu-by-set2kernel-of-APU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        apu2kernel2xi = set2kernel4apu(task4set2kernel)

        message2print = "{(Step 2B/33) performed" + "; set2kernel4apu-performed-by-set2kernel-of-APU2Kernel4Xi: " + str(set2kernel4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; apu2kernel2xi-returning-by-set2kernel-of-APU2Kernel4Xi: " + str(apu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return apu2kernel2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelarg-of-APU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernelarg ...
    #   print('(Step 158A/700) OF APU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS FOR APU: ', time4xi())
    #   try: 
    #       response4set2kernelarg = programobject2apu.set2kernelarg(task4set2kernelarg)
    #       print('(Step 158B/700) OF APU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS FOR APU ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS FOR APU ', time4xi())
    #       
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def set2kernelarg(self, task4set2kernelarg = None):
        '''
        sets kernel arguments for APU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "set2kernelarg"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelarg-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelarg-passed-to-set2kernelarg-of-APU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelarg-passing-to-set2kernelarg4apu-by-set2kernelarg-of-APU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        apu2program2xi = set2kernelarg4apu(task4set2kernelarg)

        message2print = "{(Step 2B/33) performed" + "; set2kernelarg4apu-performed-by-set2kernelarg-of-APU2Kernel4Xi: " + str(set2kernelarg4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; apu2program2xi-returning-by-set2kernelarg-of-APU2Kernel4Xi: " + str(apu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return apu2program2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelinfo-of-APU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF APU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFO ', time4xi())    
    #   try:                               
    #       response4get2kernelinfo = kernelobject2apu.get2kernelinfo()                                 
    #       print('(Step 106B/700) OF APU2KERNEL4XI5TEST - GOT GET KERNEL INFO ', time4xi())                             
    #   except:
    #       print('(Step 106Z/700) OF APU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO ', time4xi()) 
    #   
    # 
    # ">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def get2kernelinfo(self, task4getinfo2kernel=None):
        '''
        gets kernel info of APU 
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "get2kernelinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelinfo-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        apu2kernel2xi = get2kernelinfo4apu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; apu2kernel2xi-returning-by-get2kernelinfo-of-APU2Kernel4Xi: " + str(apu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return apu2kernel2xi
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelarginfo-of-APU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF APU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENT INFO OF APU ', time4xi())    
    #   try:                               
    #       response4get2kernelarginfo = kernelobject2apu.get2kernelarginfo()
    #       print('(Step 106B/700) OF APU2KERNEL4XI5TEST - GOT KERNEL ARGUMENT INFO OF APU ', time4xi())                                   
    #   except:
    #       print('(Step 106Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENT INFO OF APU ', time4xi()) 
    # 
    # ">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def get2kernelarginfo(self, task4getinfo2kernel=None):
        '''
        gets kernel argument info of APU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "get2kernelarginfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelarginfo-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:01:22 11/17/11 Pacific Standard Time

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        apu2kernel2xi = get2kernelarginfo4apu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; apu2kernel2xi-returning-by-get2kernelarginfo-of-APU2Kernel4Xi: " + str(apu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return apu2kernel2xi
                            
    #</methodize4xi>
   
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2buildinfo-of-APU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A1/700) OF APU2BUILD4XI5TEST - TRYING TO GET BUILD INFO ', time4xi())    
    #   try:                               
    #                               
    #       response4get2buildinfo = programobject2apu.get2buildinfo()
    #       print('(Step 106A2/700) OF APU2BUILD4XI5TEST - GOT BUILD INFO ', time4xi())    
    #   except:
    #       print('(Step 106Z1/700) OF APU2BUILD4XI5TEST *** FAILED TO GET BUILD INFO ', time4xi()) 
    # 
    # ">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def get2buildinfo(self, task4getinfo2build=None):
        '''
        get2buildinfo method gets objects of APU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "get2buildinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2buildinfo-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        apu2build2xi = get2buildinfo4apu(task4getinfo2build)
        
        message2print = "{(Step 2A/33) returning" + "; apu2build2xi-returning-by-get2buildinfo-of-APU2Kernel4Xi: " + str(apu2build2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        return apu2build2xi
                            
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2kernel-of-APU2Kernel4Xi" usage = "
    #
    #   print('(Step 170A/700) OF APU2KERNEL4XI5TEST - RELEASING KERNEL ', time4xi())  
    #   task4release2kernel  = {}
    #   task4release2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4release2kernel = kernelobject2apu.release2kernel(task4release2kernel)
    #       print('(Step 170B/700) OF APU2KERNEL4XI5TEST - RELEASED KERNEL ', time4xi())
    #   except:
    #       print('(Step 170Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL ', time4xi())                        
    #       keys2response = response4release2kernel.keys()
    #  
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def release2kernel(self, task4release2kernel = None):
        '''
        releases APU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "release2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; release2kernel-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2kernel-passed-to-release2kernel-of-APU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2kernel-passing-to-release2kernel4apu-by-release2kernel-of-APU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        apu2kernel2xi = release2kernel4apu(task4release2kernel)

        message2print = "{(Step 2B/33) performed" + "; release2kernel4apu-performed-by-release2kernel-of-APU2Kernel4Xi: " + str(release2kernel4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; apu2kernel2xi-returning-by-release2kernel-of-APU2Kernel4Xi: " + str(apu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #               
                
        return apu2kernel2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2kernel-of-APU2Kernel4Xi" usage = "
    #
    #   print('(Step 180A/700) OF APU2KERNEL4XI5TEST - RETAINING KERNEL ', time4xi())
    #   task4retain2kernel  = {}
    #   task4retain2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4retain2kernel = kernelobject2apu.retain2kernel(task4retain2kernel)
    #       print('(Step 180B/700) OF APU2KERNEL4XI5TEST - RETAINED KERNEL ', time4xi())
    #   except:
    #       print('(Step 180Z1/700) OF APU2KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL ', time4xi())                    
    # 
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def retain2kernel(self, task4retain2kernel = None):
        '''
        retains APU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "retain2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; retain2kernel-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2kernel-of-APU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2kernel4apu-by-retain-of-APU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
  
        apu2kernel2xi = retain2kernel4apu(task4retain2kernel)

        message2print = "{(Step 2B/33) performed" + "; retain2kernel4apu-performed-by-retain2kernel-of-APU2Kernel4Xi: " + str(retain2kernel4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; apu2kernel2xi-returning-by-retain2kernel-of-APU2Kernel4Xi: " + str(apu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
            
                
        return apu2kernel2xi
                                                           
    #</methodize4xi>   
    
 
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2kernel-of-APU2Kernel4Xi" usage = "
    #     
    #   print('(Step 210A/25) OF APU2KERNEL4XI5TEST - TRYING TO TRACE APU: ', time4xi())      
    #   trace2apu = None
    #   try:
    #       trace2apu = programobject2apu.trace2kernel() 
    #               print('(Step 210B/25) OF APU2KERNEL4XI5TEST - TRACE2APU: ', trace2apu)  
    #       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4apu-failed {}; time: 04:40:24 11/16/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4apu', 'METHOD': 'trace2kernel4apu'}
    #        except:
    #           print('(Step 210Z1/25) OF APU2KERNEL4XI5TEST *** FAILED TO TRACE APU: ', trace2apu) 
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def trace2kernel(self, task4trace2kernel = None):
        '''
        traces APU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "trace2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; trace2kernel-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2kernel-passed-to-trace-of-APU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2kernel-passing-to-trace2kernel4apu-by-trace2kernel-of-APU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = trace2kernel4apu(task4trace2kernel)

        message2print = "{(Step 2B/33) performed" + "; trace2kernel4apu-performed-by-trace2kernel-of-APU2Kernel4Xi: " + str(trace2kernel4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2kernel-of-APU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2kernel-of-APU2Kernel4Xi" usage = "
    #        
    #   print('(Step 220A/25) OF APU2KERNEL4XI5TEST - TRYING TO UNLOAD COMPILER OF APU: ', time4xi())      
    #   try:
    #       response4execute2kernel = programobject2apu.execute2kernel() 
    #       print('(Step 220B/25) OF APU2KERNEL4XI5TEST - UNLOADED COMPILER OF APU: ', response4execute2kernel)  
    #       # 
    #   except:
    #       print('(Step 220Z1/25) OF APU2KERNEL4XI5TEST *** FAILED TO TO UNLOAD COMPILER OF APU: ', time4xi()) 
    #    
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def execute2kernel(self, task4execute2kernel = None):
        '''
        executes kernel
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "execute2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2kernel-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-trace-of-APU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2kernel4apu-by-execute2kernel-of-APU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = execute2kernel4apu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2kernel4apu-performed-by-execute2kernel-of-APU2Kernel4Xi: " + str(execute2kernel4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-execute2kernel-of-APU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelcallback-of-APU2Kernel4Xi" usage = "
    #
    #   print('(Step 200A/700) OF APU2KERNEL4XI5TEST - TRYING TO SET KERNELCALLBACK WITH METHOD OF OBJECT XI2APU: ', programobject2apu) 
    #   try:
    #       callback2apu = programobject2apu.set2kernelcallback()                                  
    #       print('(Step 200B/700) OF APU2KERNEL4XI5TEST - SET KERNELWITH CALLBACK TO: ', callback2apu)
    #       # 
    #   except:
    #       print('(Step 200Z/700) OF APU2KERNEL4XI5TEST *** FAILED TO SET KERNELCALLBACK WITH METHOD ***', time4xi())
    #
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def set2kernelcallback(self, task4set2kernelcallback = None): 
        '''
        set2kernelcallback of APU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Kernel4Xi"
        method2print = "set2kernelcallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelcallback-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelcallback-passed-to-set2kernelcallback-of-APU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelcallback-passing-to-set2kernelcallback-by-set2kernelcallback-of-APU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        
        callback2apu4program = {} 
        try:
            callback2apu4program = set2kernelcallback4apu (task4set2kernelcallback)

            
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2apu4program-failed-by-set2kernelcallback-of-APU2Kernel4Xi: " + str(callback2apu4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2apu4program-returning-by-set2kernelcallback-of-APU2Kernel4Xi: " + str(callback2apu4program) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # <function trace2kernel4apu at 0x00000000038CF5C8> 
        
                                             
        return callback2apu4program
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-APU2Kernel4Xi" usage = "
    #
    #   print('(Step 310A/700) OF APU2KERNEL4XI5TEST - SENSING ', time4xi())  
    #   try:
    #       print(programobject2apu.sense())
    #       print('(Step 310B/700) OF APU2KERNEL4XI5TEST - SENSED ', time4xi()) 
    #       # 
    #   except:
    #       print('(Step 310Z/700) OF APU2KERNEL4XI5TEST *** FAILED TO SENSE ', time4xi())     
    #
    # ">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses APU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'APU2Kernel4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; APU2Kernel4Xi-sensing-by-sense-of-APU2Kernel4Xi: " + str(APU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
            
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-APU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2apu-of-APU2Kernel4Xi'] = APU2Kernel4Xi.classvariable2apu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-APU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; APU2Kernel4Xi-sensed-by-sense-of-APU2Kernel4Xi: " + str(APU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-APU2Kernel4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-APU2Kernel4Xi" usage = "
    # 
    #   print('(Step 320A/700) OF APU2KERNEL4XI5TEST - REASONING ', time4xi())
    #   try:
    #       print(programobject2apu.reason())
    #       print('(Step 320B/700) OF APU2KERNEL4XI5TEST - REASONED ', time4xi())
    #       # 
    #   except:
    #       print('(Step 320Z/700) OF APU2KERNEL4XI5TEST *** FAILED TO REASON ', time4xi()) 
    #
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons APU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'APU2Kernel4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; APU2Kernel4Xi-reasoning-by-reason-of-APU2Kernel4Xi: " + str(APU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-APU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
             
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-APU2Kernel4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-APU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; APU2Kernel4Xi-reasoned-by-reason-of-APU2Kernel4Xi: " + str(APU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-APU2Kernel4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #           
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-APU2Kernel4Xi" usage = "
    #
    #   print('(Step 330A/700) OF APU2KERNEL4XI5TEST - ACING ', time4xi())   
    #   try:
    #       print(programobject2apu.ace())
    #       print('(Step 330B/700) OF APU2KERNEL4XI5TEST - ACED ', time4xi())                                                 
    #       # 
    #   except:
    #       print('(Step 330Z/700) OF APU2KERNEL4XI5TEST *** FAILED TO ACE ', time4xi())                                 
    #    
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces APU2Kernel4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'APU2Kernel4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-APU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; APU2Kernel4Xi-acing-by-ace-of-APU2Kernel4Xi: " + str(APU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #      
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-APU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-APU2Kernel4Xi'] = APU2Kernel4Xi.classvariable2apu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-APU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; APU2Kernel4Xi-aced-by-ace-of-APU2Kernel4Xi: " + str(APU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'apu2codeprogram4xi.APU2Kernel4Xi'> 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-APU2Kernel4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
#</class4xi>

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   apu2codeprogram4xi5test.txt
#   sense-apu2codeprogram4xi5test.xml
#   reason-apu2codeprogram4xi5test.xml
#   ace-apu2codeprogram4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of apu2kernel4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
